"""phoneluge URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/1.10/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  url(r'^$', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  url(r'^$', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.conf.urls import url, include
    2. Add a URL to urlpatterns:  url(r'^blog/', include('blog.urls'))
"""

from django.conf.urls import url, include
from django.contrib import admin
from django.conf import settings
from django.conf.urls.static import static
  
urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^userauth/', include('userauth.urls',app_name='userauth',namespace='userauth')),
    url(r'^settings/', include('settings.urls',app_name='settings',namespace='settings')),
    url(r'^menu-management/', include('menumanager.urls',namespace='menumanager',app_name='menu-management')),
    url(r'^numbers/', include('numbermanager.urls',namespace='numbermanager',app_name='numbers')),
    url(r'^campaigns/', include('campaigns.urls',app_name='campaigns',namespace='campaigns')),
    url(r'^rewrites/', include('rewrites.urls',app_name='rewrites',namespace='rewrites')), 
    url(r'^calls/', include('calls.urls',app_name='calls',namespace='calls')),

] 
#+ static(settings.STATIC_URL, document_root=settings.STATIC_URL)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

if settings.DEBUG is True:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
