from django.conf.urls import url
from . import views
import os
from django.views.decorators.csrf import csrf_exempt
from django.conf.urls import handler404

handler404 = 'your_app.views.404'

urlpatterns = [
    url(r'^list/', views.List, name='list'),
    url(r'^pricing/(\d+)', views.Pricing, name='pricing'),
    url(r'^pricing-grid/', views.PricingGrid, name='pricing-grid'),
    url(r'^get-pricing/', views.GetPricing, name='get-pricing'),
    url(r'^get-pricing-client/', views.GetPricingClient, name='get-pricing-client'),
    url(r'^agency-dashboard/', views.AgencyDashboard, name='agency-dashboard'),
    url(r'^get-call-details/', views.GetCallDetails, name='get-call-details'),
    url(r'^get-agency-graph/', views.GetAgencyGraph, name='get-agency-graph'),
    url(r'^get-agency-call-grid/', views.GetAgencyCallGrid, name='get-agency-call-grid'),
    url(r'^client-dashboard/', views.ClientDashboard, name='client-dashboard'),
    url(r'^get-calls-by-campaign/', views.GetCallsByCampaign, name='get-calls-by-campaign'),
    url(r'^get-calls-by-campaign-chart/', views.GetCallsByCampaignChart, name='get-calls-by-campaign-chart'),
    url(r'^client-recent-calls-grid/', views.ClientRecentCallsGrid, name='client-recent-calls-grid'), 
    url(r'^client-recent-calls-datatable/', views.ClientRecentCallsDatatable, name='client-recent-calls-datatable'), 
    url(r'^get-client-graph/', views.GetClientGraph, name='get-client-graph'),  
    url(r'^client-calls-summary/', views.ClientCallSummary, name='client-calls-summary'),
    url(r'^client-call-details/([\w{}.-]{1,40})', views.ClientCallDetails, name='client-call-details'),
    url(r'^leadcenter/', views.LeadCenter, name='leadcenter'),
    url(r'^get-call-history/', views.GetCallHistory, name='get-call-history'),
    url(r'^get-recent-calls/', views.GetRecentCalls, name='get-recent-calls'),
    url(r'^save-call-history/', views.SaveCallHistory, name='save-call-history'),
    url(r'^call-logs/', views.CallLogs, name='call-logs'),
    url(r'^get-call-summary/', views.GetCallSummary, name='get-call-summary'),
    url(r'^live-call-track/', csrf_exempt(views.LiveCallTrack), name='live-call-track'),
    url(r'^get-call-log-grid/', views.GetCallLogGrid, name='get-call-log-grid'),
    url(r'^get-call-log-graph/', views.GetCallLogGraph, name='get-call-log-graph'),
    url(r'^account-data-detail-list/', views.AccountDataDetailList, name='account-data-detail-list'),
    url(r'^account-data-list/', views.AccountDataList, name='account-data-list'),
    url(r'^get-agency-call-datatable/', views.GetAgencyCallDataTable, name='get-agency-call-datatable'),
    url(r'^get-single-client-data/', views.GetSingleClientData, name='get-single-client-data'),     
    # url(r'^manipulate-number/', views.ManipulatingPhoneNumber, name = 'manipulate-number'),   
]
