# -*- coding: utf-8 -*-
from __future__ import unicode_literals,division
from django.core.mail import send_mail, EmailMultiAlternatives
from userauth.models import ProfileDetails, Login
from campaigns.models import CampaignDetails,CampaignTags
from calls.models import CallPricing
from django.http import HttpResponse, JsonResponse
from django.shortcuts import render
from dateutil.relativedelta import *
from datetime import timedelta,datetime
from collections import defaultdict
from numbermanager.models import *
from smtplib import SMTPException
from pymongo import MongoClient
from django.db.models import Q
import calendar,datetime,time
from django.conf import settings
from userauth import views
from bson.son import SON
from decimal import *
import requests, collections, math
import pymongo
import smtplib
import json
from userauth.views import getcalllogdetails
import os,urllib
from random import randint

# Create your views here.

def List(request):
	directory_path = '/home/callluge/public_html/audio/audio1/sample.wav'
	urllib.urlretrieve('http://www.ee.columbia.edu/~dpwe/sounds/dtmf/dtmfA6.wav', directory_path)
	
	directory = os.path.dirname(directory_path)
	os.makedirs(directory)
	# menus = views.SideMenu(request)
	#Call Grid
	# now = datetime.datetime.now()
	# data['date'] = now.strftime("%Y-%m-%d %H:%M:%S")
	# print(request.session)
	account_sid = request.session['sid']
	# # account_sid = "AC61409a9c720668081d8477b481528b97"
	collection_name = 'calls_'+account_sid
	client = MongoClient()
	db = client.calls_test
	# call = db[collection_name].find()
	# print "calls count", call.count()

	#Daily Count calculation starts
	today = datetime.date.today()
	from_date = "2017-07-01 00:00:00"
	# to_date = "2017-07-27 23:59:59"
	to_date = str(today)+' 23:59:59'
	
	call_count_by_date = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}})
	#Group by Days
	days_counts = {}
	for calls in call_count_by_date:
		call_date = calls["date"]
		for day in range(1,28):
			temp_day = day
			day = "%02d" % (day)
			day = "2017-07-"+str(day)
			if day in call_date:
				if temp_day in days_counts:
					cur_count = days_counts[temp_day]
					count = cur_count+1
					days_counts[temp_day] = count
				else:
					days_counts[temp_day] = 1	

	# print days_counts
	daily_count = {}
	for day in range(1,28):	
		daily_count[day] = 0
		if day in days_counts.keys():
			print "Found", day	
			daily_count[day] = days_counts[day]
	# print daily_count

	#Daily Count calculation ends


	#Get all campaigns created by the client
	client_id  = int(request.session["client_id"]) #Check single angency client condition later, now I am busy
	# client_id = 14
	#Graph Data Starts
	campaigns = CampaignDetails.objects.filter(client_id=client_id)
	# print "campaign counts", campaigns.count()
	categories = []
	call_counts = []
	for campaign in campaigns:
		categories.append(campaign.name)
		count = db[collection_name].find({"To":campaign.number.number}).count()
		call_counts.append(count)
	categories = json.dumps(categories)
	#Graph Data Ends
	return render(request,'call-list.html',{"categories":categories,"call_counts":call_counts,"daily_count":daily_count})

def Pricing(request,agencyid):
	datagrid = 'Call Pricing'
	if request.method == "POST":
		data = request.POST
		client_id = int(data["client"])
		call_price = CallPricing.objects.filter(client_id = client_id)
		if call_price.count() >0:
			call_price = CallPricing.objects.get(client_id = client_id)
			call_price.toll_free_number_price = data["toll_free_number_price"]
			call_price.toll_free_minutes_price = data["toll_free_minutes_price"]
			call_price.local_number_price = data["local_number_price"]
			call_price.local_number_minutes_price = data["local_minutes_price"]
			call_price.byprefix_number_price = '2.000'
			call_price.byprefix_minutes_price = '1.0000'
			call_price.save()
			print "Updated Price Details"
			return HttpResponse("Updated Price Details")			
		else:	
			call_price  = CallPricing()
			call_price.client = ProfileDetails.objects.get(id=client_id) #If Default option is selected, then agency id would be saved.
			call_price.toll_free_number_price = data["toll_free_number_price"]
			call_price.toll_free_minutes_price = data["toll_free_minutes_price"]
			call_price.local_number_price = data["local_number_price"]
			call_price.local_number_minutes_price = data["local_minutes_price"]
			call_price.byprefix_number_price = '2.000'
			call_price.byprefix_minutes_price = '1.0000'
			call_price.save()
			print "Saved Price Details"
			return HttpResponse("Saved Price Details")
	else:
		if request.session.has_key('agency_previlege'):
			agency_id = request.session['agency_id'] #Pricing is only for agencies
		else:
			agency_id = 0
		clients = ProfileDetails.objects.filter(parent_id=agency_id)
		return render(request,'call-price.html',{"clients":clients,"datagrid":datagrid,'id':agencyid})

def PricingGrid(request):
	if request.session.has_key('agency_previlege'):
		agency_id = request.session['agency_id'] #Pricing is only for agencies
	else:
		agency_id = 0

	# clients = ProfileDetails.objects.filter(parent_id=agency_id)
	# clients = ProfileDetails.objects.raw("SELECT * FROM AGENCY_CLIENT_DETAILS LEFT JOIN CALL_PRICING ON AGENCY_CLIENT_DETAILS.ID = CALL_PRICING.CLIENT_ID WHERE AGENCY_CLIENT_DETAILS.PARENT_ID = %s",[agency_id])
	# print len(list(clients))
	return render(request,'pricing-grid.html',{})

def GetPricingClient(request):
	data = request.POST
	client_id = request.POST["client"]

	call_price = CallPricing.objects.filter(client_id = client_id)

	pricing = {}
	if call_price.count() >0:
		call_price = CallPricing.objects.get(client_id = client_id)
		if call_price.toll_free_number_price !='':
			pricing['toll_free_number_price'] = float(call_price.toll_free_number_price)
		if call_price.toll_free_minutes_price !='':
			pricing['toll_free_minutes_price'] = float(call_price.toll_free_minutes_price)
		if call_price.local_number_price !='':
			pricing['local_number_price'] = float(call_price.local_number_price)
		if call_price.local_number_minutes_price != '':
			pricing['local_number_minutes_price'] = float(call_price.local_number_minutes_price)
	else:				 
		pricing={'toll_free_number_price':0,'toll_free_minutes_price':0,'local_number_price':0,'local_number_minutes_price':0}
	pricing = json.dumps(pricing)

	return HttpResponse(pricing)

def GetPricing(request):
	
	data = request.POST
	cnt_call = int(data["sEcho"])
	lengthdata = int(data['iDisplayLength'])
	sortop = data['sSortDir_0']
	sort_field = 'mDataProp_'+data['iSortCol_0']
	sort_fieldname = data[sort_field]
	limit_start = int(data['iDisplayStart'])
	search = data['sSearch']	
	pricing = []

	if sort_fieldname == 'Num':
		sort_fieldname = 'name'

	sql = "SELECT * FROM AGENCY_CLIENT_DETAILS LEFT JOIN CALL_PRICING ON AGENCY_CLIENT_DETAILS.ID = CALL_PRICING.CLIENT_ID WHERE"

	if 'client_id' not in request.POST:
		if request.session.has_key('agency_previlege'):
			agency_id = request.session['agency_id'] #Pricing is only for agencies
		else:
			agency_id = 0
		sql += " AGENCY_CLIENT_DETAILS.PARENT_ID = '"+str(agency_id)+"' "
		# call_price = CallPricing.objects.filter(client_id = client_id)				
	else:
		client_id = request.POST["client"]
		sql += " AGENCY_CLIENT_DETAILS.ID = '"+str(client_id)+"' "
		

	if search:
		# sql += "and (name like %s or toll_free_number_price like %s or toll_free_minutes_price like %s or local_number_price like %s or local_number_minutes_price like %s) "
		sql += "and (lower(name) like lower(%s)) "
		pricing_data_cnt = CallPricing.objects.raw(sql,['%'+search+'%'])
	else:
		pricing_data_cnt = CallPricing.objects.raw(sql)

	sql += "order by "+str(sort_fieldname)+" "+str(sortop)+" limit "+str(lengthdata)+" offset "+str(limit_start)

	if search:
		pricing_data = CallPricing.objects.raw(sql,['%'+search+'%'])
	else:
		pricing_data = CallPricing.objects.raw(sql)

	print(pricing_data.query)

	if len(list(pricing_data_cnt)) == 0:
		pricingdata = 0
	else:
		pricingdata = len(list(pricing_data_cnt))
				
		i = 1		
		for value in pricing_data:
			nwdict = {}
			nwdict['Num'] = i	
			nwdict['id'] = value.id	
			if value.name != '':
				nwdict['name'] = value.name
			else:
				nwdict['name'] = ''
			if value.toll_free_number_price > 0:
				nwdict['toll_free_number_price'] = float(value.toll_free_number_price)
			else:
				nwdict['toll_free_number_price'] = 0
			if value.toll_free_minutes_price > 0:
				nwdict['toll_free_minutes_price'] = float(value.toll_free_minutes_price)
			else:
				nwdict['toll_free_minutes_price'] = 0
			if value.local_number_price > 0:
				nwdict['local_number_price'] = float(value.local_number_price)		
			else:
				nwdict['local_number_price'] = 0
			if value.local_number_minutes_price > 0:
				nwdict['local_number_minutes_price'] = float(value.local_number_minutes_price)
			else:
				nwdict['local_number_minutes_price'] = 0
			
			pricing.append(nwdict)
			i = i+1

	results = {"sEcho" : cnt_call, "iTotalRecords" : pricingdata, "iTotalDisplayRecords" : pricingdata, "aaData" : pricing}	
	return HttpResponse(JsonResponse(results))


	# pricing = {}
	# if call_price.count() >0:
	# 	call_price = CallPricing.objects.get(client_id = client_id)
	# 	if call_price.toll_free_number_price !='':
	# 		pricing['toll_free_number_price'] = float(call_price.toll_free_number_price)
	# 	if call_price.toll_free_minutes_price !='':
	# 		pricing['toll_free_minutes_price'] = float(call_price.toll_free_number_price)
	# 	if call_price.local_number_price !='':
	# 		pricing['local_number_price'] = float(call_price.local_number_price)
	# 	if call_price.local_number_minutes_price != '':
	# 		pricing['local_number_minutes_price'] = float(call_price.local_number_minutes_price)
	# else:				 
	# 	pricing={'toll_free_number_price':0,'toll_free_minutes_price':0,'local_number_price':0,'local_number_minutes_price':0}
	# pricing = json.dumps(pricing)
	# print pricing
	# return HttpResponse(pricing)

def AgencyDashboard(request):
	data = {}
	datagrid = 'Dashboard'
	return render(request,'agency-dashboard.html',{"data":data,"datagrid":datagrid})

def GetCallDetails(request):
	client_id = request.POST["client_id"]
	today = datetime.date.today()
	first_day = today.replace(day=1)
	three_mon_rel= relativedelta(months=10)
	three_month = first_day-three_mon_rel
	print three_month.strftime("%Y-%B")
	return render(request,'call-details-table.html',{})	

def GetAgencyGraph(request): 
	MClient = MongoClient()
	db = MClient.calls_test

	agency_id = request.session["agency_id"]
	#Get all clients under the agency

	if 'client_id' not in request.POST:
		clients = ProfileDetails.objects.filter(Q(parent_id=agency_id)|Q(id=agency_id))
		if clients.count() > 0:
			pass
		else:
			clients = ProfileDetails.objects.filter(id=agency_id)
	else:
		clients = ProfileDetails.objects.filter(id=request.POST['client_id'])

	year_month = time.strftime("%Y-%m")	
	cur_year = int(time.strftime("%Y"))
	cur_month = int(time.strftime("%m"))
	cur_day = int(time.strftime("%d"))
	# print "Current Day", cur_day
	today = request.POST['to_date']
	first_day = request.POST['from_date']
	from_date = str(first_day)+' 00:00:00'
	to_date = str(today)+' 23:59:59'

	from_date_obj = datetime.datetime.strptime(from_date, '%Y-%m-%d %H:%M:%S')
	to_date_obj = datetime.datetime.strptime(to_date, '%Y-%m-%d %H:%M:%S')
	days = to_date_obj - from_date_obj
	days = days.days+1

	cal = calendar.monthrange(cur_year,cur_month)
	last_day_of_month = cal[1]

	#Test Collections, Make them dynamic
	# clients = ['AC61409a9c720668081d8477b481528b97','AC657af3d613ca07482633fa69bc591dc2'] 
	days_counts = {}
	tree = lambda:collections.defaultdict(tree)
	arr_calldetails = tree()
	arr_price = collections.defaultdict(dict)
	call_price = collections.defaultdict(dict)
	y_axis_call_count = []
	y_axis_call_duration = []
	client_arr = []
	x_axis_data = []
	totalnumber = []
	maxval_arr = []
	whole_calldur = 0
	whole_invoice = 0
	localnumber_list = []
	tollfreenumber_list = []
	byprefixnumber_list = []
	tollfreenumber_count = localnumber_count = 0
	newtollfreenumber_count = newlocalnumber_count = 0
	yaxis_interval = 5

	if days > 365:
		for dt in yearrange(from_date_obj, to_date_obj):
			x_axis_data.append(dt)
	elif days > 31:
		for dt in monthrange(from_date_obj, to_date_obj):
			x_axis_data.append(dt.strftime("%b, %Y"))
	else:
		for dt in daterange(from_date_obj, to_date_obj):
			x_axis_data.append(dt.strftime("%d %b"))

	for clnt in clients:
		client_arr.append(clnt.id)

	numberdetails = AssignedNumbers.objects.raw('select A.id, A.number, A.date_ordered, B.num_type, D.client_id from number_master A inner join assigned_numbers D on A.id = D.number_id inner join number_details B on A.id = B.number_id where D.client_id in %s',params=[tuple(client_arr)])

	client_arr.append(agency_id)
	callprice = CallPricing.objects.filter(client_id__in=client_arr)

	for price in callprice:
		arr_price[price.client_id]['toll_free_minutes_price'] = price.toll_free_minutes_price
		arr_price[price.client_id]['local_number_minutes_price']=price.local_number_minutes_price
		arr_price[price.client_id]['byprefix_minutes_price']=price.byprefix_minutes_price

	for details in numberdetails:
		date_ordered = ''
		if details.date_ordered != '':
			date_ordered = details.date_ordered.strftime('%Y-%m-%d')
		if details.num_type == 'Local':			
			if details.client_id in arr_price:
				call_price[details.client_id][details.number] = str(arr_price[details.client_id]['local_number_minutes_price']) + '<=>local<=>'+date_ordered
			else:
				call_price[details.client_id][details.number] = str(arr_price[agency_id]['local_number_minutes_price']) + '<=>local<=>'+date_ordered

		elif details.num_type == 'Toll-Free':
			if details.client_id in arr_price:
				call_price[details.client_id][details.number] = str(arr_price[details.client_id]['toll_free_minutes_price'])+'<=>tollfree<=>'+date_ordered
			else:
				call_price[details.client_id][details.number] = str(arr_price[agency_id]['toll_free_minutes_price'])+'<=>tollfree<=>'+date_ordered

		else:
			if details.client_id in arr_price:
				call_price[details.client_id][details.number] = str(arr_price[details.client_id]['byprefix_minutes_price'])+'<=>byprefix<=>'+date_ordered
			else:
				call_price[details.client_id][details.number] = str(arr_price[agency_id]['byprefix_minutes_price'])+'<=>byprefix<=>'+date_ordered
	
	for client in clients:
		# collection_name = 'calls_'+client #test
		collection_name = 'calls_'+str(client.sid) #live 

		call_count_by_date = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}})

		if days > 365:			
			for call in call_count_by_date:
				key_call = datetime.datetime.strptime(call['date'], '%Y-%m-%d %H:%M:%S').strftime('%Y')
				if call['From'] not in totalnumber:
					totalnumber.append(call['From'])

				if key_call in arr_calldetails:
					arr_calldetails[key_call]['calls'] += 1
					if 'RecordingDuration' in call:
						if 'duration' in arr_calldetails[key_call] and arr_calldetails[key_call]['duration'] > 0:
							arr_calldetails[key_call]['duration'] +=int(call['RecordingDuration'])
						else:
							arr_calldetails[key_call]['duration'] =int(call['RecordingDuration'])

						whole_calldur += int(call['RecordingDuration'])
						# whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * call_price[client.id][call['To']]
						call_price_det = call_price[client.id][call['To']].split('<=>')
						whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * Decimal(call_price_det[0])
						if call_price_det[1] == 'local':
							localnumber_count += 1
							localnumber_list.append(call['To'])
							if call_price_det[2] != '' and first_day <= call_price_det[2] <= today:
								newlocalnumber_count += 1 
						elif call_price_det[1] == 'tollfree':
							tollfreenumber_count += 1
							tollfreenumber_list.append(call['To'])
							if call_price_det[2] != '' and first_day <= call_price_det[2] <= today:
								newtollfreenumber_count += 1	
						else:
							byprefixnumber_list.append(call['To'])

				else:
					arr_calldetails[key_call]['calls'] = 1
					if 'RecordingDuration' in call:
						arr_calldetails[key_call]['duration'] =int(call['RecordingDuration'])
						whole_calldur += int(call['RecordingDuration'])
						call_price_det = call_price[client.id][call['To']].split('<=>')
						whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * Decimal(call_price_det[0])
						if call_price_det[1] == 'local':
							localnumber_count += 1
							localnumber_list.append(call['To'])
							if call_price_det[2] != '' and first_day <= call_price_det[2] <= today:
								newlocalnumber_count += 1
						elif call_price_det[1] == 'tollfree':
							tollfreenumber_count += 1
							tollfreenumber_list.append(call['To'])
							if call_price_det[2] != '' and first_day <= call_price_det[2] <= today:
								newtollfreenumber_count += 1
						else:
							byprefixnumber_list.append(call['To'])

		elif days > 31:
			for call in call_count_by_date:

				key_call = datetime.datetime.strptime(call['date'], '%Y-%m-%d %H:%M:%S').strftime('%b, %Y')
				if call['From'] not in totalnumber:
					totalnumber.append(call['From'])

				if key_call in arr_calldetails:
					arr_calldetails[key_call]['calls'] += 1
					if 'RecordingDuration' in call:
						if 'duration' in arr_calldetails[key_call] and arr_calldetails[key_call]['duration'] > 0:
							arr_calldetails[key_call]['duration'] +=int(call['RecordingDuration'])
						else:
							arr_calldetails[key_call]['duration'] =int(call['RecordingDuration'])

						whole_calldur += int(call['RecordingDuration'])
						# whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * call_price[client.id][call['To']]
						call_price_det = call_price[client.id][call['To']].split('<=>')
						whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * Decimal(call_price_det[0])
						if call_price_det[1] == 'local':
							localnumber_count += 1
							localnumber_list.append(call['To'])
							if call_price_det[2] != '' and first_day <= call_price_det[2] <= today:
								newlocalnumber_count += 1
						elif call_price_det[1] == 'tollfree':
							tollfreenumber_count += 1
							tollfreenumber_list.append(call['To'])
							if call_price_det[2] != '' and first_day <= call_price_det[2] <= today:
								newtollfreenumber_count += 1
						else:
							byprefixnumber_list.append(call['To'])
				else:
					arr_calldetails[key_call]['calls'] = 1
					if 'RecordingDuration' in call:
						arr_calldetails[key_call]['duration'] =int(call['RecordingDuration'])
						whole_calldur += int(call['RecordingDuration'])
						# whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * call_price[client.id][call['To']]
						call_price_det = call_price[client.id][call['To']].split('<=>')
						whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * Decimal(call_price_det[0])
						if call_price_det[1] == 'local':
							localnumber_count += 1
							localnumber_list.append(call['To'])
							if call_price_det[2] != '' and first_day <= call_price_det[2] <= today:
								newlocalnumber_count += 1
						elif call_price_det[1] == 'tollfree':
							tollfreenumber_count += 1
							tollfreenumber_list.append(call['To'])
							if call_price_det[2] != '' and first_day <= call_price_det[2] <= today:
								newtollfreenumber_count += 1
						else:
							byprefixnumber_list.append(call['To'])

		else:
			for call in call_count_by_date:
				key_call = datetime.datetime.strptime(call['date'], '%Y-%m-%d %H:%M:%S').strftime('%d %b')
				if call['From'] not in totalnumber:
					totalnumber.append(call['From'])

				if key_call in arr_calldetails:
					arr_calldetails[key_call]['calls'] += 1
					if 'RecordingDuration' in call:
						if 'duration' in arr_calldetails[key_call] and arr_calldetails[key_call]['duration'] > 0:
							arr_calldetails[key_call]['duration'] +=int(call['RecordingDuration'])
						else:
							arr_calldetails[key_call]['duration'] =int(call['RecordingDuration'])

						whole_calldur += int(call['RecordingDuration'])
						# whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * call_price[client.id][call['To']]		
						call_price_det = call_price[client.id][call['To']].split('<=>')
						whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * Decimal(call_price_det[0])
						if call_price_det[1] == 'local':
							localnumber_count += 1
							localnumber_list.append(call['To'])
							if call_price_det[2] != '' and first_day <= call_price_det[2] <= today:
								newlocalnumber_count += 1
						elif call_price_det[1] == 'tollfree':
							tollfreenumber_count += 1
							tollfreenumber_list.append(call['To'])
							if call_price_det[2] != '' and first_day <= call_price_det[2] <= today:
								newtollfreenumber_count += 1
						else:
							byprefixnumber_list.append(call['To'])		

				else:
					arr_calldetails[key_call]['calls'] = 1
					if 'RecordingDuration' in call:						
						arr_calldetails[key_call]['duration'] =int(call['RecordingDuration'])
						whole_calldur += int(call['RecordingDuration'])
						# whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * call_price[client.id][call['To']]
						call_price_det = call_price[client.id][call['To']].split('<=>')
						whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * Decimal(call_price_det[0])
						if call_price_det[1] == 'local':
							localnumber_count += 1
							localnumber_list.append(call['To'])
							if call_price_det[2] != '' and first_day <= call_price_det[2] <= today:
								newlocalnumber_count += 1
						elif call_price_det[1] == 'tollfree':
							tollfreenumber_count += 1
							tollfreenumber_list.append(call['To'])
							if call_price_det[2] != '' and first_day <= call_price_det[2] <= today:
								newtollfreenumber_count += 1
						else:
							byprefixnumber_list.append(call['To'])
											
	if arr_calldetails:
		for val in x_axis_data:		
			v1 = str(val)	
			if v1 not in arr_calldetails:
				y_axis_call_count.append(0)
				y_axis_call_duration.append(0)
			else:
				y_axis_call_count.append(arr_calldetails[v1]['calls'])
				if 'duration' in arr_calldetails[v1] and arr_calldetails[v1]['duration'] > 0:
					y_axis_call_duration.append(arr_calldetails[v1]['duration'])
				else:
					y_axis_call_duration.append(0)
	else:
		for val in x_axis_data:
			y_axis_call_count.append(0)
			y_axis_call_duration.append(0)
	
	max_val = max(y_axis_call_count)+1	
	if int(max_val)%int(yaxis_interval) == 0:
		maxval_app = max_val
	else:
		maxval_app = int(max_val) + (int(yaxis_interval) - int(max_val)%int(yaxis_interval))	

	for call_count in y_axis_call_count:
		maxval_arr.append(maxval_app)
		
	categories = json.dumps(x_axis_data)
	if whole_calldur >= 60:
		rem = quot = 0
		quot = int(math.floor(int(whole_calldur)/60))
		rem = int(int(whole_calldur) % 60)
		if rem > 0:
			whole_calldur = str(quot) + 'm ' + str(rem) + 's'
		else:
			whole_calldur = str(quot) + 'm'
	else:
		whole_calldur = str(whole_calldur) + 's'

	if whole_invoice > 0:
		whole_invoice = round(whole_invoice, 2)

	set_local = set(localnumber_list)
	localnumber_cnt = len(list(set_local))

	set_tollfree = set(tollfreenumber_list)
	tollfreenumber_cnt = len(list(set_tollfree))

	# print(byprefixnumber_list)
	set_byprefix = set(byprefixnumber_list)
	byprefixnumber_cnt = len(list(set_byprefix))

	totalnumber_cnt = int(localnumber_cnt) + int(byprefixnumber_cnt) + int(tollfreenumber_cnt)
	# print(byprefixnumber_cnt)
	return render(request,'agency-call-count.html',{'max_val':max_val,		
		'maxval_arr':maxval_arr,
		'tickInterval':yaxis_interval,
		'categories':categories,
		'newlocalnumber_count':newlocalnumber_count,
		'newtollfreenumber_count':newtollfreenumber_count,
		'localnumber_count':localnumber_cnt,
		'tollfreenumber_count':tollfreenumber_cnt,
		'byprefixnumber_count':byprefixnumber_cnt,
		'call_count':y_axis_call_count,
		'call_price':whole_invoice,
		'duration_count':y_axis_call_duration,
		'totalnumbers':totalnumber_cnt,
		'totalcall':sum(y_axis_call_count),
		'call_duration':whole_calldur
		})

	# print(totalnumber)
	# print(y_axis_call_count)
	# print(y_axis_call_duration)

		# for calls in call_count_by_date:
		# 	call_date = calls["date"]
		# 	for day in range(1,cur_day+1):
		# 		temp_day = day
		# 		day = "%02d" % (day) #making the days format in two digits say 01 insted of 1
		# 		day = year_month+"-"+str(day)
		# 		print "Outside"
		# 		print "Month Year", day
		# 		if day in call_date:
		# 			print "Inside If"	
		# 			if temp_day in days_counts:
		# 				cur_count = days_counts[temp_day]
		# 				count = cur_count+1
		# 				days_counts[temp_day] = count
		# 			else:
		# 				days_counts[temp_day] = 1

	#Poplate the days having no counts with 0							
	# daily_count = {}
	# for day in range(1,last_day_of_month+1):	
	# 	daily_count[day] = 0
	# 	if day in days_counts.keys():
	# 		daily_count[day] = days_counts[day]
						
	#Daily Count calculation ends
	# return render(request,'agency-call-count.html',{"daily_count":daily_count})	

def GetSingleClientData(request):	
	MClient = MongoClient()
	db = MClient.calls_test
	numType = {}
	agency_callprice = {}
	client_arr = []
	yeararr = []
	callcntdate = {}
	call_price = {}
	invoiceTotal = []
	number_price = {}
	numberPurchase = []
	arr_calldetails_uniq = {}
	arr_calldetails_rept = {}
	tree = lambda:collections.defaultdict(tree)
	arr_calldetails_unique = tree()
	callcost = collections.defaultdict(dict)
	callcost_dur = collections.defaultdict(dict)
	arr_price = collections.defaultdict(dict)
	arr_call = collections.defaultdict(dict)
	client_data = collections.defaultdict(dict)
	numbertype = collections.defaultdict(dict)
	duration = collections.defaultdict(dict)
	agency_id = request.session["agency_id"]

	now = datetime.datetime.now()
	client_id = request.POST['client_id']
	# client_id = 44
	year = request.POST['year']
	sid = request.POST['sid']
	# year = 2017
	# sid = 'AC6c580f81779a325f0311ab7c55a6bc28'

	if now.year == year:
		today = datetime.date.today()
		to_date = str(today)+' 23:59:59'
		from_date = str(int(year)-1)+'-'+str(now.month)+'-'+'01 00:00:00'
	else:
		to_date = str(year)+'-'+str(now.month)+'-'+str(now.day)+' 23:59:59'
		last_month = now.month-1 if now.month > 1 else 12
		from_date = str(int(year)-1)+'-'+str(last_month)+'-'+'01 00:00:00'

	monthyearlits = GetMonthYearList(year)

	client_arr.append(agency_id)
	client_arr.append(client_id)
	callprice = CallPricing.objects.filter(client_id__in=client_arr)

	for price in callprice:
		arr_price[price.client_id]['toll_free_number_price'] = price.toll_free_number_price
		arr_price[price.client_id]['toll_free_minutes_price'] = price.toll_free_minutes_price
		arr_price[price.client_id]['local_number_price']=price.local_number_price
		arr_price[price.client_id]['local_number_minutes_price']=price.local_number_minutes_price
		arr_price[price.client_id]['byprefix_number_price']=price.byprefix_number_price
		arr_price[price.client_id]['byprefix_minutes_price']=price.byprefix_minutes_price

	numberdetails = AssignedNumbers.objects.raw("select A.id, A.number, A.date_ordered, B.num_type from number_master A inner join assigned_numbers D on A.id = D.number_id inner join number_details B on A.id = B.number_id where D.client_id='"+str(client_id)+"'")

	for details in numberdetails:
		numType[details.number] = details.num_type
		date_ordered = str(details.date_ordered).split( )

		if datetime.datetime.strptime(date_ordered[0],'%Y-%m-%d').strftime("%b `%y") in numbertype[details.num_type]:
			numbertype[details.num_type][datetime.datetime.strptime(date_ordered[0],'%Y-%m-%d').strftime("%b `%y")] += 1
		else:
			numbertype[details.num_type][datetime.datetime.strptime(date_ordered[0],'%Y-%m-%d').strftime("%b `%y")] = 1

		if details.num_type == 'Local':
			if 'local_number_minutes_price' in arr_price[client_id] and arr_price[client_id]['local_number_minutes_price'] is not None:
				call_price[details.number] = arr_price[client_id]['local_number_minutes_price']
				# number_price[details.number] = arr_price[client_id]['local_number_price']
			else:
				call_price[details.number] = arr_price[agency_id]['local_number_minutes_price']
				# number_price[details.number] = arr_price[agency_id]['local_number_price']

		elif details.num_type == 'Toll-Free':
			if 'local_number_minutes_price' in arr_price[client_id] and arr_price[client_id]['local_number_minutes_price'] is not None:
				call_price[details.number] = arr_price[client_id]['toll_free_minutes_price']
				# number_price[details.number] = arr_price[client_id]['toll_free_number_price']				
			else:
				call_price[details.number] = arr_price[agency_id]['toll_free_minutes_price']
				# number_price[details.number] = arr_price[agency_id]['toll_free_number_price']

		else:
			if 'byprefix_minutes_price' in arr_price[client_id] and arr_price[client_id]['byprefix_minutes_price'] is not None:
				call_price[details.number] = arr_price[client_id]['byprefix_minutes_price']
				# number_price[details.number] = arr_price[client_id]['byprefix_number_price']
			else:
				call_price[details.number] = arr_price[agency_id]['byprefix_minutes_price']
				# number_price[details.number] = arr_price[agency_id]['byprefix_number_price']
			
	collection_name = 'calls_'+str(sid)
	calls = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}})

	dur = j = i = 0
	for call in calls:

		key_call = datetime.datetime.strptime(call['date'], '%Y-%m-%d %H:%M:%S').strftime("%b `%y")
		
		if 'Duration' in callcost_dur:
			if key_call in callcost_dur['Duration']:
				pass
			else:
				callcost_dur['Duration'][key_call] = 0
		else:
			callcost_dur['Duration'][key_call] = 0

		if 'RecordingDuration' in call:
			callcntdate[call['date']] = call['From'] +' == '+ call['RecordingDuration']
			callcost_dur['Duration'][key_call] += Decimal(call_price[call['To']]) * Decimal(math.ceil(int(call["RecordingDuration"])/60))
		else:
			callcntdate[call['date']] = call['From']

		j += 1
		
		if key_call in arr_calldetails_unique and call['From'] in arr_calldetails_unique[key_call]:

			if call['From'] in arr_calldetails_unique[key_call] and arr_calldetails_unique[key_call][call['From']] != 'updated_repeat':			
				arr_call['unique'][key_call] -= 1
				if 'repeat' in arr_call and key_call in arr_call['repeat']:
					arr_call['repeat'][key_call] += 1
				else:
					arr_call['repeat'][key_call] = 1

				# print('UNIQUE TO repeat=='+key_call+'---'+str(arr_call['repeat'][key_call])+'--'+call['From'])

				if arr_calldetails_unique[key_call][call['From']] != 'yes':	
					spltdata = arr_calldetails_unique[key_call][call['From']].split('==')
					duration['unique'][key_call] -= int(spltdata[1])
					callcost['unique'][key_call] = Decimal(callcost['unique'][key_call]) - Decimal(spltdata[0])
					if 'repeat' in callcost and key_call in callcost['repeat']:
						duration['repeat'][key_call] += int(spltdata[1])
						callcost['repeat'][key_call] = Decimal(callcost['repeat'][key_call]) + Decimal(spltdata[0])
					else:
						duration['repeat'][key_call] = int(spltdata[1])
						callcost['repeat'][key_call] = Decimal(spltdata[0])


				arr_calldetails_unique[key_call][call['From']] = 'updated_repeat'

			if 'repeat' in arr_call and key_call in arr_call['repeat']:
				arr_call['repeat'][key_call] += 1
			else:
				arr_call['repeat'][key_call] = 1
			# print('repeat=='+key_call+'---'+str(arr_call['repeat'][key_call]))

			if 'RecordingDuration' in call:
				dur = int(call["RecordingDuration"])
				if 'repeat' in callcost and key_call in callcost['repeat']:
					callcost['repeat'][key_call] += Decimal(call_price[call['To']]) * Decimal(math.ceil(int(call["RecordingDuration"])/60))
					callcost_dur['Duration'][key_call] += Decimal(call_price[call['To']]) * Decimal(math.ceil(int(call["RecordingDuration"])/60))
					duration['repeat'][key_call] += dur
				else:
					callcost['repeat'][key_call] = Decimal(call_price[call['To']]) * Decimal(math.ceil(int(call["RecordingDuration"])/60))
					callcost_dur['Duration'][key_call] += Decimal(call_price[call['To']]) * Decimal(math.ceil(int(call["RecordingDuration"])/60))
					duration['repeat'][key_call] = dur

		else:
			arr_calldetails_unique[key_call][call['From']] = 'yes'
			i += 1
			if 'unique' in arr_call and key_call in arr_call['unique']:
				arr_call['unique'][key_call] += 1
			else:
				arr_call['unique'][key_call] = 1
			# print('unique==='+key_call+'---'+str(arr_call['unique'][key_call]))

			if 'RecordingDuration' in call:
				dur = int(call["RecordingDuration"])

				if call['From'] in arr_calldetails_unique[key_call]:
					arr_calldetails_unique[key_call][call['From']] = str(Decimal(call_price[call['To']]) * Decimal(math.ceil(int(call["RecordingDuration"])/60)))+'=='+str(dur)

				if 'unique' in callcost and key_call in callcost['unique']:
					callcost['unique'][key_call] = Decimal(callcost['unique'][key_call]) + Decimal(Decimal(call_price[call['To']]) * Decimal(math.ceil(int(call["RecordingDuration"])/60)))
					callcost_dur['Duration'][key_call] += Decimal(callcost['unique'][key_call]) + Decimal(Decimal(call_price[call['To']]) * Decimal(math.ceil(int(call["RecordingDuration"])/60)))
					duration['unique'][key_call] += dur
				else:
					callcost['unique'][key_call] = Decimal(call_price[call['To']]) * Decimal(math.ceil(int(call["RecordingDuration"])/60))
					callcost_dur['Duration'][key_call] += Decimal(call_price[call['To']]) * Decimal(math.ceil(int(call["RecordingDuration"])/60))
					duration['unique'][key_call] = dur


	dominantnumType = ['Local','Toll-Free', 'By-Prefix']
	callType = ['unique','repeat']
	numbtype_total = []
	numbtype = collections.defaultdict(dict)
	calldet_total = []
	call_det = collections.defaultdict(dict)
	durationdet_total = []
	duration_det = collections.defaultdict(dict)
	callcostdet_total = []
	callcost_det = collections.defaultdict(dict)

	inc = TotalnumberPurcahse = 0

	if 'local_number_price' in arr_price[client_id] and arr_price[client_id]['local_number_price'] is not None:
		number_price['Local'] = arr_price[client_id]['local_number_price']
	else:
		number_price['Local'] = arr_price[agency_id]['local_number_price']

	if 'toll_free_number_price' in arr_price[client_id] and arr_price[client_id]['toll_free_number_price'] is not None:
		number_price['Toll-Free'] = arr_price[client_id]['toll_free_number_price']
	else:
		number_price['Toll-Free'] = arr_price[agency_id]['toll_free_number_price']

	if 'byprefix_number_price' in arr_price[client_id] and arr_price[client_id]['byprefix_number_price'] is not None:
		number_price['By-Prefix'] = arr_price[client_id]['byprefix_number_price']
	else:
		number_price['By-Prefix'] = arr_price[agency_id]['byprefix_number_price']


	for month in monthyearlits:
		numbtype_total.append(0)
		calldet_total.append(0)
		durationdet_total.append(0)
		callcostdet_total.append(0)
		invoiceTotal.append(0)
		numberPurchase.append(0)
		for val in dominantnumType:	
			
			if val in numbertype:				
				if month in numbertype[val]:
					numbtype[val][inc] = numbertype[val][month]
				else:
					numbtype[val][inc] = 0

				if numberPurchase[inc]:
					numberPurchase[inc] = Decimal(numberPurchase[inc]) + (Decimal(numbtype[val][inc]) * Decimal(number_price[val]))					
				else:
					numberPurchase[inc] = Decimal(numbtype[val][inc]) * Decimal(number_price[val])
					
				numbtype_total[inc] = int(numbtype[val][inc]) + int(numbtype_total[inc])
				
			else:
				numbtype[val][inc] = 0
				numbtype_total[inc] = int(numbtype[val][inc]) + int(numbtype_total[inc])
				if numberPurchase[inc]:
					numberPurchase[inc] = Decimal(numberPurchase[inc]) + (Decimal(numbtype[val][inc]) * Decimal(number_price[val]))
				else:
					numberPurchase[inc] = Decimal(numbtype[val][inc]) * Decimal(number_price[val])
							
			if 'total' in numbtype[val]:
				numbtype[val]['total'] = int(numbtype[val][inc]) + int(numbtype[val]['total'])
			else:
				numbtype[val]['total'] = int(numbtype[val][inc])


		for val in callType:
			if val in arr_call:
				if month in arr_call[val]:
					call_det[val][inc] = arr_call[val][month]
				else:
					call_det[val][inc] = 0

				calldet_total[inc] = int(call_det[val][inc]) + int(calldet_total[inc])
			else:
				call_det[val][inc] = 0
				calldet_total[inc] = int(call_det[val][inc]) + int(calldet_total[inc])

			if 'total' in call_det[val]:
				call_det[val]['total'] = int(call_det[val][inc]) + int(call_det[val]['total'])
			else:
				call_det[val]['total'] = int(call_det[val][inc])
		
		for val in callType:			
			if val in duration:
				if month in duration[val]:
					duration_det[val][inc] = duration[val][month]
				else:
					duration_det[val][inc] = 0

				durationdet_total[inc] = int(duration_det[val][inc]) + int(durationdet_total[inc])
			else:
				duration_det[val][inc] = 0
				durationdet_total[inc] = int(duration_det[val][inc]) + int(durationdet_total[inc])
			
			if 'total' in duration_det[val]:
				duration_det[val]['total'] = int(duration_det[val][inc]) + int(duration_det[val]['total'])
			else:
				duration_det[val]['total'] = int(duration_det[val][inc])
			

		for val in callType:		
			
			if val in callcost:
				
				if month in callcost[val]:
					callcost_det[val][inc] = callcost[val][month]
				else:
					callcost_det[val][inc] = 0

				callcostdet_total[inc] = Decimal(callcost_det[val][inc]) + Decimal(callcostdet_total[inc])
			else:
				callcost_det[val][inc] = 0
				callcostdet_total[inc] = Decimal(callcost_det[val][inc]) + Decimal(callcostdet_total[inc])

			if 'total' in callcost_det[val]:
				callcost_det[val]['total'] = Decimal(callcost_det[val][inc]) + Decimal(callcost_det[val]['total'])
			else:
				callcost_det[val]['total'] = Decimal(callcost_det[val][inc])

		invoiceTotal[inc] = Decimal(callcostdet_total[inc]) + Decimal(numberPurchase[inc])
		# print(invoiceTotal[inc])
		# print(numberPurchase[inc])
		# print(callcost_det[val]['total'])
		# print(val)
		inc += 1

	# print('monthlist-----')
	# print(monthyearlits)
	# print('numbertypelist-----')
	# print(numbtype)
	# print(numberPurchase)
	# print('numbertypetotallist-----')
	# print(numbtype_total)
	# print('calllist-----')
	# print(call_det)
	# print('calltotallist-----')
	# print(calldet_total)
	# print('durationlist-----')
	# print(duration_det)
	# print('durationtotallist-----')
	# print(durationdet_total)
	# print('callcostlist-----')
	# print(callcost_dur)
	# print('callcosttotallist-----')
	# print(callcostdet_total)

	sumnumtypetotal = sum(numbtype_total)
	sumcalldettotal = sum(calldet_total)
	sumdurationdettotal = sum(durationdet_total)
	sumcallcostdettotal = sum(callcostdet_total)
	TotalnumberPurcahse = sum(numberPurchase)
	sumnumpurdettotal = Decimal(sumcallcostdettotal) + Decimal(TotalnumberPurcahse)

	# print(invoiceTotal)

	# cnt = 0
	# while cnt < 3:
	# 	yeararr.append(int(year) - cnt)
	# 	cnt += 1
	yeararr.append(year)

	return render(request,'agency-client-calldetails.html',{"monthlist":monthyearlits, "year":yeararr, "number":numbtype.items(), "number_total": numbtype_total, "sumnumtypetotal" :sumnumtypetotal, "call":call_det.items(), "call_total": calldet_total, "sumcalldettotal":sumcalldettotal, "duration":duration_det.items(), "duration_total":durationdet_total, "sumdurationdettotal":sumdurationdettotal, "cost":callcost_det.items(), "cost_total":callcostdet_total, "sumcallcostdettotal":sumcallcostdettotal, "TotalnumberPurcahse": TotalnumberPurcahse, "numberPurchase": numberPurchase, 'sumnumpurdettotal': sumnumpurdettotal, 'invoiceTotal' : invoiceTotal})	


def GetAgencyCallGrid(request):
	now = datetime.datetime.now()
	MClient = MongoClient()
	agency_callprice = {}
	call_price = {}
	client_data = collections.defaultdict(dict)
	db = MClient.calls_test
	agency_id = request.session["agency_id"]
	client_search = ''
	today = request.POST['to_date']
	first_day = request.POST['from_date']
	from_date = str(first_day)+' 00:00:00'
	to_date = str(today)+' 23:59:59'

	# from_date = '2017-08-01 00:00:00'
	# to_date = '2016-07-15 23:59:59'

	callprice = CallPricing.objects.filter(client_id=agency_id)
	for price in callprice:
		agency_callprice['toll_free_minutes_price'] = price.toll_free_minutes_price
		agency_callprice['local_number_minutes_price']=price.local_number_minutes_price
		agency_callprice['byprefix_minutes_price']=price.byprefix_minutes_price
	
	if 'client_search' not in request.POST:
		clients = ProfileDetails.objects.raw("select A.id,A.name,A.date_created,A.status, A.sid, count(DISTINCT B.pid) as camp_count, count(DISTINCT C.id) as user_count, count(DISTINCT D.id) as num_count, E.* from agency_client_details A left join campaign_details B on A.id = B.client_id left join user_master C on A.id = C.agency_client_id and C.status = 1 and C.previlege = 5 left join assigned_numbers D on A.id = D.client_id left join call_pricing E on A.id = E.client_id where A.parent_id = '"+str(agency_id)+"' group by A.id, E.id order by A.name")
	else:
		client_search = request.POST['client_search']
		clients = ProfileDetails.objects.raw("select A.id,A.name,A.date_created,A.status, A.sid, count(DISTINCT B.pid) as camp_count, count(DISTINCT C.id) as user_count, count(DISTINCT D.id) as num_count, E.* from agency_client_details A left join campaign_details B on A.id = B.client_id left join user_master C on A.id = C.agency_client_id and C.status = 1 and C.previlege = 5 left join assigned_numbers D on A.id = D.client_id left join call_pricing E on A.id = E.client_id where A.name like %s and A.parent_id = '"+str(agency_id)+"' group by A.id, E.id order by A.name",['%'+client_search+'%'])
	
	if len(list(clients)) > 0:
		for client in clients:
			# print(client.name)
			numberdetails = AssignedNumbers.objects.raw("select A.id, A.number, B.num_type from number_master A inner join assigned_numbers D on A.id = D.number_id inner join number_details B on A.id = B.number_id where D.client_id='"+str(client.id)+"'")

			for details in numberdetails:
				# print(details.number)
				if details.num_type == 'Local':
					if client.local_number_minutes_price is not None:
						call_price[details.number] = client.local_number_minutes_price
					else:
						call_price[details.number] = agency_callprice['local_number_minutes_price']

				elif details.num_type == 'Toll-Free':
					if client.toll_free_minutes_price is not None:
						call_price[details.number] = client.toll_free_minutes_price
					else:
						call_price[details.number] = agency_callprice['toll_free_minutes_price']

				else:
					if client.byprefix_minutes_price is not None:
						call_price[details.number] = client.byprefix_minutes_price
					else:
						call_price[details.number] = agency_callprice['byprefix_minutes_price']
			
			collection_name = 'calls_'+str(client.sid)
			calls = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}})

			callcost = dur = duration = i = 0
			for call in calls:
				i += 1
				
				if 'RecordingDuration' in call:
					dur = int(call["RecordingDuration"])
					callcost += Decimal(call_price[call['To']]) * Decimal(math.ceil(int(call["RecordingDuration"])/60))
					duration = duration+dur


			if duration >= 60:
				duration = str(int(math.floor(int(duration)/60))) + 'm ' + str(int(math.floor(int(duration) % 60))) + 's'
			else:
				duration = str(duration) + 's'
			
			client_data[client.id]['name'] = client.name
			client_data[client.id]['campaign'] = client.camp_count
			dateCreated = client.date_created.split( )
			client_data[client.id]['date'] = datetime.datetime.strptime(dateCreated[0], '%Y-%m-%d').strftime('%d %b %Y')
			client_data[client.id]['number'] = client.num_count
			client_data[client.id]['call'] = i
			client_data[client.id]['duration'] = duration
			client_data[client.id]['status'] = client.status
			client_data[client.id]['users'] = int(client.user_count)
			client_data[client.id]['invoice'] = round(callcost, 2)
			client_data[client.id]['sid'] = client.sid
			

	return render(request,'agency-call-grid.html',{"data":client_data.items(),"year":now.year, "search":client_search})	

def GetAgencyCallDataTable(request):
	#get agency call grid data		
	data = {}
	MClient = MongoClient()
	db = MClient.calls_test
	agency_id = request.session["agency_id"]
	
	#Get all clients under the agency
	# clients = ProfileDetails.objects.filter(Q(parent_id=agency_id)|Q(id=agency_id))
	if 'client_id' not in request.POST:
		clients = ProfileDetails.objects.filter(Q(parent_id=agency_id)|Q(id=agency_id))
		if clients.count() > 0:
			pass
		else:
			clients = ProfileDetails.objects.filter(id=agency_id)
	else:
		clients = ProfileDetails.objects.filter(id=request.POST['client_id'])
	
	today = request.POST['to_date']
	first_day = request.POST['from_date']
	from_date = str(first_day)+' 00:00:00'
	to_date = str(today)+' 23:59:59'

	for client in clients:
		date_created = ''
		if client.date_created != '':
			dateCreated = client.date_created.split( )
			date_created = datetime.datetime.strptime(dateCreated[0], '%Y-%m-%d').date()

		users = Login.objects.filter(agency_client_id=int(client.id),status=1).count()
		numbers = AssignedNumbers.objects.filter(client_id=client.id).count()
		campaigns = CampaignDetails.objects.filter(client_id=client.id).count()
		collection_name = 'calls_'+str(client.sid)
		calls_count = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}}).count()
		
		# RecordingDuration
		duration = 0
		calls = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date},'RecordingDuration':{'$exists':'TRUE'}})
		for call in calls:
			dur = int(call["RecordingDuration"])
			duration = duration+dur

		if duration >= 60:
			duration = str(math.floor(int(duration)/60)) + 'm'
		else:
			duration = str(duration) + 's'
					
		basic_data = {'id':client.id,'Status':'Active','CreatedDate':date_created,'Users':users,'Numbers':numbers,'Campaigns':campaigns,'Calls':calls_count,'Duration':duration}
		data[client.name] = basic_data

	return render(request,'agency-call-grid.html',{"data":data})	

def ClientDashboard(request):
	datagrid = 'Dashboard'
	return render(request,'client-dashboard.html',{'datagrid':datagrid})

def GetCallsByCampaign(request):

	#Current month by default
	today = datetime.date.today()
	first_day = today.replace(day=1)
	from_date = str(first_day)+' 00:00:00'
	to_date = str(today)+' 23:59:59'

	account_sid = request.session["sid"]
	collection_name = 'calls_'+account_sid
	client = MongoClient()
	db = client.calls_test
	client_id = int(request.session["client_id"])
	#Graph Data Starts
	campaigns = CampaignDetails.objects.filter(client_id=client_id)

	data = {}
	for campaign in campaigns:
		total_count = db[collection_name].find({"To":campaign.number.number,'date': {'$lte': to_date, '$gte': from_date}}).count()
		unique_count = db[collection_name].find({"To":campaign.number.number,'date': {'$lte': to_date, '$gte': from_date}}).distinct("From")
		unique_count = len(unique_count)

		# RecordingDuration
		duration = 0
		calls = db[collection_name].find({"To":campaign.number.number,'date': {'$lte': to_date, '$gte': from_date},'RecordingDuration':{'$exists':'TRUE'}})
		for call in calls:
			dur = int(call["RecordingDuration"])
			duration = duration+dur

		campaign_data = {'total_count': total_count,'unique_count':unique_count,'duration':duration}
		data[campaign.name] = campaign_data

	# print "Data", data	
	categories = json.dumps(data)	
	print categories

	return render(request,'call-by-campaign.html',{"data":data})

def GetCallsByCampaignChart(request):
	
	#Current month by default (have to change according to date filter)
	today = datetime.date.today()
	first_day = today.replace(day=1)
	from_date = str(first_day)+' 00:00:00'
	to_date = str(today)+' 23:59:59'

	account_sid = request.session["sid"]
	collection_name = 'calls_'+account_sid
	client = MongoClient()
	db = client.calls_test
	client_id = int(request.session["client_id"])
	#Graph Data Starts
	campaigns = CampaignDetails.objects.filter(client_id=client_id)

	categories = []
	call_counts = []
	for campaign in campaigns:
		categories.append(campaign.name)
		count = db[collection_name].find({"To":campaign.number.number,'date': {'$lte': to_date, '$gte': from_date}}).count()
		call_counts.append(count)
	categories = json.dumps(categories)

	return render(request,'call-by-campaign-chart.html',{"call_counts":call_counts,"categories":categories})	

def ClientRecentCallsGrid(request):
	from_date = request.POST['from_date']
	to_date = request.POST['to_date']
	return render(request,'client-recent-calls-grid.html',{"from_date":from_date,"to_date":to_date})		

def ClientRecentCallsDatatable(request):
	numberTo = []
	today = datetime.date.today()
	first_day = today.replace(day=1)
	# from_date = str(first_day)+' 00:00:00'
	from_date = '2017-08-01 00:00:00'
	to_date = str(today)+' 23:59:59'

	data = request.POST

	from_date1 = data["from_date"]
	to_date1 = data["to_date"]

	from_date = str(from_date1)+' 00:00:00'
	to_date = str(to_date1)+' 23:59:59'
	cnt_call = int(data["sEcho"])
	lengthdata = int(data['iDisplayLength'])
	sortop = data['sSortDir_0']
	if data['iSortCol_0'] == '0':
		sort_field = 'mDataProp_4'
		sortop = 'desc'
	else:
		sort_field = 'mDataProp_'+data['iSortCol_0']
	sort_fieldname = data[sort_field]
	limit_start = int(data['iDisplayStart'])
	search = data['sSearch'].replace( '(', '' ).replace( ') ', '' ).replace( '-', '' )

	if sortop == 'asc':
		sort_oper = int(1)
	else:
		sort_oper = int(-1)

	client_id = request.session["client_id"]
	account_sid = request.session["sid"]
	collection_name = 'calls_'+account_sid
	# print collection_name
	client = MongoClient()
	db = client.calls_test

	if search:
		# print('hi')
	 	totalcall = db[collection_name].find({'$and' : [ {"$or" : [{"From": {"$regex" : search }},{"CallStatus": {"$regex" : search}},{"FromState": {"$regex" : search}},{"ToState": {"$regex" : search}},{"To": {"$regex" : search}},{"date": {"$regex" : search}},{"RecordingDuration": {"$regex" : search}},
	 		]},{'date': {'$lte': to_date, '$gte': from_date}} ]}).count()
	 	call = db[collection_name].find({'$and' : [ {"$or" : [{"From": {"$regex" : search }},{"CallStatus": {"$regex" : search}},{"FromState": {"$regex" : search}},{"ToState": {"$regex" : search}},{"To": {"$regex" : search}},{"date": {"$regex" : search}},{"RecordingDuration": {"$regex" : search}},
	 		]},{'date': {'$lte': to_date, '$gte': from_date}} ]}, {'_id': 0 }).sort(sort_fieldname,sort_oper).limit(lengthdata).skip(limit_start)
	else:
		totalcall = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}}).count()
		call = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}}, {'_id': 0 }).sort(sort_fieldname,sort_oper).limit(lengthdata).skip(limit_start)
	new_call = []
	i = 0
	num = limit_start+1
	for value in call:
		if 'CallSid' in value:
			pass
		else:
			value['CallSid'] = ''
		if 'From' in value:
			value['From'] = phone_number(value['From'])
		else:
			value['From'] = ''
		if 'CallStatus' in value:
			pass
		else:
			value['CallStatus'] = ''
		if 'FromState' in value:
			pass
		else:
			value['FromState'] = ''
		if 'ToState' in value:
			pass
		else:
			value['ToState'] = ''
		if 'To' in value:
			sql = "select A.id as num_id, B.pid, B.name as camp_name, C.pid as ad_id, C.name as ad_name from number_master A left join campaign_details B on A.id = B.number_id left join ad_groups C on C.pid = B.ad_group_id where A.number = '"+str(value['To'])+"' and B.client_id = '"+str(client_id)+"'"
			# print(sql)
			campaigndetails = CampaignDetails.objects.raw(sql)
			# campaigndetails = CampaignDetails.objects.filter(client_id = client_id, number = value['To'])
			if len(list(campaigndetails)) > 0:
				# print(campaigndetails)
				for campaign in campaigndetails:
					value['number_name'] = campaign.ad_name
					value['campaign_name'] = campaign.camp_name
			else:
				value['number_name'] = ''
				value['campaign_name'] = ''
			value['To'] = phone_number(value['To'])
			pass
		else:
			value['To'] = ''
			value['number_name'] = ''
			value['campaign_name'] = ''
		if 'date' in value:
			value['date'] = datetime.datetime.strptime(str(value['date']), '%Y-%m-%d %H:%M:%S').strftime("%b %d, %Y %I:%M %p")
			pass
		else:
			value['date'] = ''
		if 'RecordingDuration' in value:
			if value['RecordingDuration'] > 60:
				mints = round(int(value['RecordingDuration'])/60)
				sec = round(int(value['RecordingDuration']) % 60)	
			else:
				mints = 0
				sec = value['RecordingDuration']
			value['RecordingDuration'] = str(int(mints))+'m '+str(int(sec))+'s'
			pass
		else:
			value['RecordingDuration'] = 0

		
		new_call.append(value)
		i = i+1
		num = num+1

	results = {"sEcho" : cnt_call, "iTotalRecords" : totalcall, "iTotalDisplayRecords" : totalcall, "aaData" : new_call}	
	return HttpResponse(JsonResponse(results))

def GetClientGraph(request):
	MClient = MongoClient()
	db = MClient.calls_test

	client_id = request.session["client_id"]
	#Get all clients under the agency

	client = ProfileDetails.objects.get(id=client_id)

	# from_date = "2017-07-01 00:00:00"
	# to_date = "2017-07-27 23:59:59"
	year_month = time.strftime("%Y-%m")	
	cur_year = int(time.strftime("%Y"))
	cur_month = int(time.strftime("%m"))
	cur_day = int(time.strftime("%d"))
	# print "Current Day", cur_day
	today = datetime.date.today()
	first_day = today.replace(day=1)
	from_date = str(first_day)+' 00:00:00'
	to_date = str(today)+' 23:59:59'
	cal = calendar.monthrange(cur_year,cur_month)
	last_day_of_month = cal[1]

	#Test Collections, Make them dynamic
	# clients = ['AC61409a9c720668081d8477b481528b97','AC657af3d613ca07482633fa69bc591dc2'] 
	days_counts = {}

	# collection_name = 'calls_'+client #test
	collection_name = 'calls_'+str(client.sid) #live 
	# print collection_name
	call_count_by_date = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}})
	# print "Count by date", call_count_by_date.count()
	for calls in call_count_by_date:
		call_date = calls["date"]
		for day in range(1,cur_day+1):
			temp_day = day
			day = "%02d" % (day) #making the days format in two digits say 01 insted of 1
			day = year_month+"-"+str(day)
			# print "Outside"
			# print "Month Year", day
			if day in call_date:
				# print "Inside If"	
				if temp_day in days_counts:
					cur_count = days_counts[temp_day]
					count = cur_count+1
					days_counts[temp_day] = count
				else:
					days_counts[temp_day] = 1

	# print "Days with call counts", days_counts
	#Poplate the days having no counts with 0							
	daily_count = {}
	for day in range(1,last_day_of_month+1):	
		daily_count[day] = 0
		if day in days_counts.keys():
			daily_count[day] = days_counts[day]
	# print daily_count
						
	#Daily Count calculation ends
	return render(request,'agency-call-count.html',{"daily_count":daily_count})	

def ClientCallSummary(request):
	# today = datetime.date.today()
	# first_day = today.replace(day=1)
	# from_date = str(first_day)+' 00:00:00'
	# to_date = str(today)+' 23:59:59'

	from_date = request.POST['from_date']
	to_date = request.POST['to_date']
	from_date = from_date+' 00:00:00'
	to_date = to_date+' 23:59:59'

	account_sid = request.session["sid"]
	collection_name = 'calls_'+account_sid
	client = MongoClient()
	db = client.calls_test
	client_id = int(request.session["client_id"])

	total_count = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}}).count()
	unique_count = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}}).distinct("From")
	unique_count = len(unique_count)
	repeat_count = total_count - unique_count

	# RecordingDuration
	duration = 0
	calls = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date},'RecordingDuration':{'$exists':'TRUE'}})
	for call in calls:
		dur = int(call["RecordingDuration"])
		duration = duration+dur

	summary_data = {'total_count': total_count,'unique_count':unique_count, 'repeat_count': repeat_count, 'duration':duration}
	# print summary_data
	return render(request,'client-calls-summary.html',{"summary_data":summary_data})

def LeadCenter(request):
	today = datetime.date.today()
	first_day = today.replace(day=1)
	from_date = str(first_day)+' 00:00:00'
	to_date = str(today)+' 23:59:59'

	account_sid = request.session["sid"]
	# account_sid = "AC61409a9c720668081d8477b481528b97"
	collection_name = 'calls_'+account_sid
	client = MongoClient()
	db = client.calls_test
	# calls = db[collection_name].find({'date': {'$lte': to_date}}).sort('date',pymongo.DESCENDING).distinct('From')
	# calls = db[collection_name].find({'date': {'$lte': to_date}}).distinct('From')
	
	data = db[collection_name].aggregate([
		{'$match':{'date':{'$exists':'TRUE'}}},
	    { "$sort": {"date": -1 } },
	    {
	       "$group":
	         {
	           "_id": "$From",
	           "lastCallDate": { "$last": "$date" },
	           "numberOfCalls": { '$sum':1 },
	           "from": {"$first":"$From"}
	         }
	    },
	    {'$sort' : {'lastCallDate' : -1}},
	    {
	    	"$project": {
	    		"From":"$from",
	    		"LatestCall":"$lastCallDate",
	    		"Count":"$numberOfCalls"
	    	}
	    }
	                   ])

	# for val in data:
	# 	print val['From']
	return render(request,'leadcenter.html',{"data":data})

def ClientCallDetails(request,callid):
	datagrid = 'Call Details'
	account_sid = request.session["sid"]
	number = ''
	dialed_to =''
	collection_name = 'calls_'+account_sid
	client_id = request.session["client_id"]
	client = MongoClient()
	db = client.calls_test
	calls = db[collection_name].find({'CallSid':callid}).sort('date',pymongo.DESCENDING)
	
	if 'dialed_to' in calls[0]:
		dialed_to = calls[0]['dialed_to']

	tracking_number = calls[0]['To']
	country = calls[0]['CallerCountry']
	state = calls[0]['FromState']
	caller_no = calls[0]['From']
	campaign = CampaignDetails.objects.get(number__number=tracking_number)
	data = {}
	medium = '-'
	tag_name_list = []
	campaign_name = '-'
	campaign_id = ''
	first_call = ''
	i = 0
	for call in calls:
		call_date = call['date']
		call_sid = call['CallSid']
		# print call_date
		date_obj = datetime.datetime.strptime(str(call_date), '%Y-%m-%d %H:%M:%S')
		# print type(date_obj)
		call_day = datetime.date.strftime(date_obj, "%b %d")
		first_call = datetime.date.strftime(date_obj, "%b %d, %Y %I:%M %p") #value gets overwritten
		call_time =  datetime.date.strftime(date_obj, "%I:%M %p")
		data[i] = {'call_sid':call_sid,'day':call_day,'time':call_time,'type':'Inbound Call'}
		data[i]['data'] = call

		sql = "select A.id as num_id, B.pid, B.name as camp_name, C.pid as ad_id, C.name as ad_name from number_master A left join campaign_details B on A.id = B.number_id left join ad_groups C on C.pid = B.ad_group_id where A.number = '"+str(call['To'])+"' and B.client_id = '"+str(client_id)+"'"
		# print(sql)
		campaigndetails = CampaignDetails.objects.raw(sql)
		# campaigndetails = CampaignDetails.objects.filter(client_id = client_id, number = value['To'])
		if len(list(campaigndetails)) > 0:
			# print(campaigndetails)
			for campaign in campaigndetails:
				medium = campaign.ad_name
				campaign_name = campaign.camp_name
				campaign_id = campaign.pid
			
			campaigntags = CampaignTags.objects.filter(campaign_id = campaign_id)
			if len(list(campaigntags)) > 0:
				for tag in campaigntags:
					tag_name_list.append(tag.tag_name)

		if 'RecordingDuration' in call:
			call_duration = int(call['RecordingDuration'])
			# print call_duration, 'sec'
			if call_duration > 60:
				mints = call_duration/60
				# print mints , 'mints'
				rem = call_duration % 60
				# print rem, 'sec'
				duration = str(mints)+'m '+str(rem)+' s'
				data[i]['mint'] = mints
				data[i]['sec'] = rem
			else:
				duration = str(call_duration)+'s'
				data[i]['mint'] = 0
				data[i]['sec'] = duration

			# print duration	
			data[i].update({'type':'Inbound Record Call','duration':duration, 'url':call['RecordingUrl']})	

		i = i+1	

	general_details = {'country':country,'state':state, 'medium':medium, 'caller_no': caller_no, 'campaign_name':campaign_name, 'from':number,'no_of_calls':i,'first_call':first_call,'campaign':campaign.name,'campaign_desc':campaign.description,'tracking_number':phone_number(campaign.number.number),'dialed_to':phone_number(dialed_to),'group_name':campaign.ad_group.name}

	userdetails = getcalllogdetails(request,request.session['client_id'])


	# for val in data:
	# 	print val['From']
	return render(request,'call-details.html',{'users':userdetails,'data':data,'general_details':general_details, 'datagrid': datagrid, 'tag_list': tag_name_list})

def GetCallHistory(request):
	
	number = request.POST["number"]

	today = datetime.date.today()
	first_day = today.replace(day=1)
	from_date = str(first_day)+' 00:00:00'
	to_date = str(today)+' 23:59:59'

	account_sid = request.session["sid"]
	# account_sid = "AC61409a9c720668081d8477b481528b97"
	collection_name = 'calls_'+account_sid
	client = MongoClient()
	db = client.calls_test
	calls = db[collection_name].find({'From':number,'date': {'$lte': to_date}}).sort('date',pymongo.DESCENDING)

	if 'dialed_to' in calls[0]:
		dialed_to = calls[0]['dialed_to']

	tracking_number = calls[0]['To']
	country = calls[0]['ToCountry']
	state = calls[0]['ToState']
	campaign = CampaignDetails.objects.get(number__number=tracking_number)
	data = {}
	first_call = ''
	i = 0
	for call in calls:
		call_date = call['date']
		call_sid = call['CallSid']
		# print call_date
		date_obj = datetime.datetime.strptime(str(call_date), '%Y-%m-%d %H:%M:%S')
		# print type(date_obj)
		call_day = datetime.date.strftime(date_obj, "%B %d")
		first_call = datetime.date.strftime(date_obj, "%B %d, %Y %I:%M %p") #value gets overwritten
		call_time =  datetime.date.strftime(date_obj, "%I:%M %p")
		data[i] = {'call_sid':call_sid,'day':call_day,'time':call_time,'type':'Inbound Call'}
		data[i]['data'] = call
		if 'RecordingDuration' in call:
			call_duration = int(call['RecordingDuration'])
			# print call_duration, 'sec'
			if call_duration > 60:
				mints = call_duration/60
				# print mints , 'mints'
				rem = call_duration % 60
				# print rem, 'sec'
				duration = str(mints)+'m '+str(rem)+' s'
				data[i]['mint'] = mints
				data[i]['sec'] = rem
			else:
				duration = str(call_duration)+'s'
				data[i]['mint'] = 0
				data[i]['sec'] = duration

			# print duration	
			data[i].update({'type':'Inbound Record Call','duration':duration, 'url': call['RecordingUrl']})	

		i = i+1	
	general_details = {'country':country,'state':state,'from':number,'no_of_calls':i,'first_call':first_call,'campaign':campaign.name,'campaign_desc':campaign.description,'tracking_number':campaign.number.number,'dialed_to':dialed_to,'group_name':campaign.ad_group.name}

	userdetails = getcalllogdetails(request,request.session['client_id'])

	return render(request,'call-history.html',{'users':userdetails,'data':data,'general_details':general_details})
	# return render(request,'single-calls.html',{"calls":calls})

def GetRecentCalls(request):
	today = datetime.date.today()
	first_day = today.replace(day=1)
	from_date = str(first_day)+' 00:00:00'
	to_date = str(today)+' 23:59:59'

	account_sid = request.session["sid"]
	# account_sid = "AC61409a9c720668081d8477b481528b97"
	collection_name = 'calls_'+account_sid
	print collection_name
	client = MongoClient()
	db = client.calls_test
	# calls = db[collection_name].find({'date': {'$lte': to_date}}).sort('date',pymongo.DESCENDING).distinct('From')
	# calls = db[collection_name].find({'date': {'$lte': to_date}}).distinct('From')
	
	data = db[collection_name].aggregate([
		{'$match':{'date':{'$exists':'TRUE'}}},
	    # { "$sort": {"date": -1 } },
	    {
	       "$group":
	         {
	           "_id": "$From",
	           "lastCallDate": { "$last": "$date" },
	           "FromState": { "$last": "$FromState" },
	           "FromCountry": { "$last": "$FromCountry" },
	           "RecordingDuration":{"$last":"$RecordingDuration"},
	           "numberOfCalls": { '$sum':1 },
	           "from": {"$first":"$From"}
	         }
	    },
	    {'$sort' : {'lastCallDate' : -1}},
	    {
	    	"$project": {
	    		"From":"$from",
	    		"LatestCall":"$lastCallDate",
	    		"Count":"$numberOfCalls",
	    		"FromState":"$FromState",
	    		"FromCountry":"$FromCountry",
	    		"RecordingDuration":"$RecordingDuration"
	    	}
	    }
	                   ])	

	call_data = {}
	i = 0
	for call in data:
		call_date = call['LatestCall']
		# print 'date: ', call_date
		caller = call['From']
		from_state = call['FromState']
		from_country = call['FromCountry']

		date_obj = datetime.datetime.strptime(str(call_date), '%Y-%m-%d %H:%M:%S')
		call_day = datetime.date.strftime(date_obj, "%B %d")
		call_time =  datetime.date.strftime(date_obj, "%I:%M %p")
		call_data[i] = {'day':call_day,'time':call_time,'duration':'0s','caller':caller,'from_state':from_state,'from_country':from_country}
		if call['RecordingDuration']:
			print "Record exist"
			call_duration = int(call['RecordingDuration'])
			if call_duration > 60:
				mints = call_duration/60
				rem = call_duration % 60
				call_data[i].update({'minute':mints,'second':rem})
			else:
				call_data[i].update({'minute':0,'second':call_duration})	

		i = i+1		
	print call_data	

	return render(request,'recent-calls.html',{"data":call_data})

def SaveCallHistory(request):
	account_sid = request.session["sid"]
	collection_name = 'calls_'+account_sid
	client = MongoClient()
	db = client.calls_test

	update_data={}
	if request.method == "GET":
		print request.GET
		if request.GET['call_sid']:
			call_sid = request.GET['call_sid']
			print "Call Sid:", call_sid
		if 'tag' in request.GET:
			update_data['tag'] = request.GET['tag']
		if 'assigned_to' in request.GET:
			update_data['assigned_to'] = request.GET['assigned_to']
		if 'revenue' in request.GET:
			update_data['revenue'] = request.GET['revenue']	
		if 'star' in request.GET:
			update_data['star'] = request.GET['star']	
		if 'notes' in request.GET:
			update_data['notes'] = request.GET['notes']			
		update_id = db[collection_name].update({"CallSid":call_sid},{'$set':update_data}) 
		print update_data
		print "Call History Assosiated Details Updated"
		return HttpResponse('saved')
	return HttpResponse('ok')

def CallLogs(request):
	datagrid = 'Call Logs'
	return render(request,'call-logs.html',{"datagrid":datagrid})

def GetCallSummary(request):  

	from_date = request.POST['from_date']
	to_date = request.POST['to_date']
	from_date = from_date+' 00:00:00'
	to_date = to_date+' 23:59:59'

	from_date_obj = datetime.datetime.strptime(from_date, '%Y-%m-%d %H:%M:%S')
	to_date_obj = datetime.datetime.strptime(to_date, '%Y-%m-%d %H:%M:%S')
	days = to_date_obj - from_date_obj
	days = days.days+1

	summary_data = CreateSummaryData(request,from_date,to_date)
	unique_count = summary_data['unique_count']
	repeat_call = summary_data['repeat_count']

	# %value for pie-chart
	unique_call_percentage = 0
	repeat_call_percentage = 0

	if unique_count > 0 :
		unique_call_percentage = (unique_count/(unique_count+repeat_call))*100
	if repeat_call > 0:
		repeat_call_percentage = (repeat_call/(unique_count+repeat_call))*100

	#Now compare with same period previous data
	prev_from_date = from_date_obj-relativedelta(days=+days)
	to_date = from_date
	from_date = str(prev_from_date)
	summary_data_prev = CreateSummaryData(request,from_date,to_date)
		
	inc_percent = {}
	for key,val in summary_data.items():
		cur_month_value = summary_data[key]
		prev_month_value = summary_data_prev[key]
		if int(prev_month_value) > 0:
			if prev_month_value > cur_month_value:
				direction = 'icon-up-dir'
				percentage = ((prev_month_value - cur_month_value)/prev_month_value)*100
				inc_percent[key] = {'direction':direction,'percentage':percentage}
			elif prev_month_value < cur_month_value:
				direction = 'icon-down-dir down'
				percentage = ((cur_month_value - prev_month_value)/prev_month_value)*100
				inc_percent[key] = {'direction':direction,'percentage':percentage,'color':'red'}				
			else:
				inc_percent[key] = {'percentage':0}
		else:
			inc_percent[key] = {'percentage':0}				

	return render(request,'call-log-summary.html',{'summary_data':summary_data,
		'summary_data_prev':summary_data_prev,
		'inc_percent':inc_percent,
		'days':days,
		'unique_percent':unique_call_percentage,
		'repeat_percent':repeat_call_percentage})	

def CreateSummaryData(request,from_date,to_date):

	account_sid = request.session["sid"]
	collection_name = 'calls_'+account_sid
	client = MongoClient()
	db = client.calls_test
	client_id = int(request.session["client_id"])

	total_count = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}}).count()
	unique_count = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}}).distinct("From")
	unique_count = len(unique_count)

	# RecordingDuration
	duration = 0
	calls = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date},'RecordingDuration':{'$exists':'TRUE'}})
	for call in calls:
		dur = int(call["RecordingDuration"])
		duration = duration+dur

	if duration > 60:
		mints = round(duration/60)
		sec = round(duration % 60)	
	else:
		mints = 0
		sec = duration	

	data = db[collection_name].aggregate([
		{"$match": {"date" : {'$lte': to_date, '$gte': from_date} }},
		{"$group" : { "_id": "$From", "count": { "$sum": 1 } } },
	    {"$match": {"count" : {"$gt": 1} }}, 
	    {"$project": {"number" : "$_id", "count" : "$count"} },
		                   ])	
	repeat_call = 0	
	for call in data:
		# print call
		repeat_call = repeat_call+1

	summary_data = {
	'total_count': total_count,
	'unique_count':unique_count,
	'repeat_count':repeat_call,
	'mints':mints,
	}
	return summary_data

def LiveCallTrack(request):
	data = request.POST
	name = data['name']
	print name
	print "okay"
	return HttpResponse(name)

def GetCallLogGrid(request):
	from_date = request.POST['from_date']
	to_date = request.POST['to_date']
	from_date = from_date+' 00:00:00'
	to_date = to_date+' 23:59:59'
	call_no = []
	camp_ad_dict = {}
	data = {}

	account_sid = request.session["sid"]
	client_id = request.session["client_id"]
	collection_name = 'calls_'+account_sid
	client = MongoClient()
	db = client.calls_test
	client_id = int(request.session["client_id"])
	calls_count = i = 0
	calls_count = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}}).count()
	calls = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}}).sort('date',-1)


	for call in calls:
		if call['To'] not in call_no:
			call_no.append(call['To'])
			sql = "select A.id, B.pid, B.name as camp_name, C.pid as ad_id, C.name as ad_name from number_master A left join campaign_details B on A.id = B.number_id left join ad_groups C on C.pid = B.ad_group_id where A.number ='"+str(call['To'])+"' and B.client_id = '"+str(client_id)+"'"
			campaigndetails = CampaignDetails.objects.raw(sql)

			if len(list(campaigndetails)) > 0:
				for campaign in campaigndetails:
					camp_ad_dict[call['To']] = str(campaign.ad_name)+'<=>'+ str(campaign.camp_name)

		data[i] = call
		call_date = datetime.datetime.strptime(str(call['date']), '%Y-%m-%d %H:%M:%S').strftime("%b %d, %Y %I:%M %p")
		data[i].update({'call_date': call_date})

		if 'RecordingDuration' in call:
			if int(call['RecordingDuration']) > 60:
				mints = round(int(call['RecordingDuration'])/60)
				sec = round(int(call['RecordingDuration']) % 60)	
			else:
				mints = 0
				sec = call['RecordingDuration']

			data[i].update({'call_duration': str(int(mints))+'m '+str(int(sec))+'s'})

		if call['To'] in camp_ad_dict:
			campData = camp_ad_dict[call['To']].split('<=>')
			data[i].update({'campaign_name':campData[1],'ad_name':campData[0]})		

		data[i].update({'To': phone_number(call['To']), 'From': phone_number(call['From'])})
		i += 1
		
	# print(data)

	
	return render(request,'call-log-grid.html',{'calls':data,'calls_count':calls_count})		

def GetCallLogGraph(request):
	agency_id = ''
	if request.session.has_key('agency_id'):
		agency_id = request.session['agency_id']

		
	db = GetDB(request)
	collection_name = GetCollection(request)	

	if 'selected_client' in request.POST:
		client_id = int(request.POST['selected_client'])
	else:
		client_id = request.session['client_id']


	from_date1 = request.POST['from_date']
	to_date1 = request.POST['to_date']
	from_date = from_date1+' 00:00:00'
	to_date = to_date1+' 23:59:59'	
	from_page = request.POST['from_page']	

	from_date_obj = datetime.datetime.strptime(from_date, '%Y-%m-%d %H:%M:%S')
	to_date_obj = datetime.datetime.strptime(to_date, '%Y-%m-%d %H:%M:%S')
	days = to_date_obj - from_date_obj
	days = days.days+1	
	# print(days)
	
	daily_counts = {}
	x_axis_data = []
	y_axis_unique_count = []
	y_axis_repeat_count = []

	tree = lambda:collections.defaultdict(tree)
	arr_calldetails_unique = tree()
	arr_price = collections.defaultdict(dict)
	call_price = collections.defaultdict(dict)
	arr_calldetailswhole_unique = {}
	client_select = {}
	arr_calldetails_uniq = {}
	arr_calldetails_rept = {}
	arr_calldetailswhole_unique_prev = {}
	whole_calldur = arr_calldetailswhole_uniq = arr_calldetailswhole_rept = 0
	arr_calldetailswhole_uniq_prev = arr_calldetailswhole_rept_prev = 0
	whole_calldur_prev = whole_invoice_prev = 0
	client_arr = []
	maxval_arr = []
	total_call = []
	whole_invoice = 0
	yaxis_interval = 5
	totalcall_comp = uniq_comp = rept_comp = duration_comp = invoice_comp = 00
		
	call_details = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}})
	
	i = prevcall = 0
	repeat = 0
	unique = 0

	clientDetails = ProfileDetails.objects.filter(parent_id=agency_id) 
	if clientDetails.count() > 0:
		for details in clientDetails:
			client_select[details.id] = details.name

	numberdetails = AssignedNumbers.objects.raw("select A.id, A.number, B.num_type, D.client_id from number_master A inner join assigned_numbers D on A.id = D.number_id inner join number_details B on A.id = B.number_id where D.client_id='"+str(client_id)+"'")

	client_arr.append(agency_id)
	client_arr.append(client_id)
	callprice = CallPricing.objects.filter(client_id__in=client_arr)

	for price in callprice:
		arr_price[price.client_id]['toll_free_minutes_price'] = price.toll_free_minutes_price
		arr_price[price.client_id]['local_number_minutes_price']=price.local_number_minutes_price
		arr_price[price.client_id]['byprefix_minutes_price']=price.byprefix_minutes_price

	for details in numberdetails:
		# print(details.number)
		if details.num_type == 'Local':
			if details.client_id in arr_price:
				call_price[details.client_id][details.number] = arr_price[details.client_id]['local_number_minutes_price']
			else:
				call_price[details.client_id][details.number] = arr_price[agency_id]['local_number_minutes_price']

		elif details.num_type == 'Toll-Free':
			if details.client_id in arr_price:
				call_price[details.client_id][details.number] = arr_price[details.client_id]['toll_free_minutes_price']
			else:
				call_price[details.client_id][details.number] = arr_price[agency_id]['toll_free_minutes_price']

		else:
			if details.client_id in arr_price:
				call_price[details.client_id][details.number] = arr_price[details.client_id]['byprefix_minutes_price']
			else:
				call_price[details.client_id][details.number] = arr_price[agency_id]['byprefix_minutes_price']

	# print(call_price)


	if from_page == 'call_log':
		frmexp_date = GetPrevDayFromDate(str(from_date1), 30)
		toexp_date = GetPrevDayFromDate(str(from_date1), 1)
		fromDate_prev = str(frmexp_date)+' 00:00:00'
		toDate_prev = str(toexp_date)+' 23:59:59'

		call_details_pre = db[collection_name].find({'date': {'$lte': toDate_prev, '$gte': fromDate_prev}})

		for callprev in call_details_pre:
			prevcall += 1
			if callprev['From'] in arr_calldetailswhole_unique_prev:
				if arr_calldetailswhole_unique_prev[callprev['From']] != 'updated_repeat':
					arr_calldetailswhole_uniq_prev -= 1					
					arr_calldetailswhole_rept_prev = 1

					arr_calldetailswhole_unique_prev[callprev['From']] = 'updated_repeat'

				arr_calldetailswhole_rept_prev += 1

				if 'RecordingDuration' in callprev:
					whole_calldur_prev += int(callprev['RecordingDuration'])
					whole_invoice_prev += int(math.ceil(int(callprev['RecordingDuration'])/60)) * call_price[client_id][callprev['To']]
			else:
				arr_calldetailswhole_unique_prev[callprev['From']] = 'yes'
				arr_calldetailswhole_uniq_prev += 1

				if 'RecordingDuration' in callprev:
					whole_calldur_prev += int(callprev['RecordingDuration'])
					whole_invoice_prev += int(math.ceil(int(callprev['RecordingDuration'])/60)) * call_price[client_id][callprev['To']]

	if days > 365:
		for dt in yearrange(from_date_obj, to_date_obj):
			x_axis_data.append(dt)

		for call in call_details:
			key_call = datetime.datetime.strptime(call['date'], '%Y-%m-%d %H:%M:%S').strftime('%Y')

			if call['From'] in arr_calldetailswhole_unique:
				if arr_calldetailswhole_unique[call['From']] != 'updated_repeat':
					arr_calldetailswhole_uniq -= 1					
					arr_calldetailswhole_rept = 1

					arr_calldetailswhole_unique[call['From']] = 'updated_repeat'

				arr_calldetailswhole_rept += 1
			else:
				arr_calldetailswhole_unique[call['From']] = 'yes'
				arr_calldetailswhole_uniq += 1


			if key_call in arr_calldetails_unique and call['From'] in arr_calldetails_unique[key_call]:
				if arr_calldetails_unique[key_call][call['From']] != 'updated_repeat':

					arr_calldetails_uniq[key_call] -= 1
					if key_call in arr_calldetails_rept:
						arr_calldetails_rept[key_call] += 1
					else:
						arr_calldetails_rept[key_call] = 1

					arr_calldetails_unique[key_call][call['From']] = 'updated_repeat'


				if key_call in arr_calldetails_rept:
					arr_calldetails_rept[key_call] += 1
				else:
					arr_calldetails_rept[key_call] = 1

				if repeat < arr_calldetails_rept[key_call]:
					repeat = arr_calldetails_rept[key_call]
			else:
				arr_calldetails_unique[key_call][call['From']] = 'yes'
				i += 1
				if key_call in arr_calldetails_uniq:
					arr_calldetails_uniq[key_call] += 1
				else:
					arr_calldetails_uniq[key_call] = 1

				if unique < arr_calldetails_uniq[key_call]:
					unique = arr_calldetails_uniq[key_call]

			if 'RecordingDuration' in call:
				whole_calldur += int(call['RecordingDuration'])
				whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * call_price[client_id][call['To']]

	elif days > 31:
		for dt in monthrange(from_date_obj, to_date_obj):
			x_axis_data.append(dt.strftime("%b, %Y"))
		for call in call_details:
			key_call = datetime.datetime.strptime(call['date'], '%Y-%m-%d %H:%M:%S').strftime('%b, %Y')

			if call['From'] in arr_calldetailswhole_unique:
				if arr_calldetailswhole_unique[call['From']] != 'updated_repeat':
					arr_calldetailswhole_uniq -= 1					
					arr_calldetailswhole_rept = 1

					arr_calldetailswhole_unique[call['From']] = 'updated_repeat'

				arr_calldetailswhole_rept += 1
			else:
				arr_calldetailswhole_unique[call['From']] = 'yes'
				arr_calldetailswhole_uniq += 1


			if key_call in arr_calldetails_unique and call['From'] in arr_calldetails_unique[key_call]:
				if arr_calldetails_unique[key_call][call['From']] != 'updated_repeat':
					arr_calldetails_uniq[key_call] -= 1
					if key_call in arr_calldetails_rept:
						arr_calldetails_rept[key_call] += 1
					else:
						arr_calldetails_rept[key_call] = 1

					arr_calldetails_unique[key_call][call['From']] = 'updated_repeat'


				if key_call in arr_calldetails_rept:
					arr_calldetails_rept[key_call] += 1
				else:
					arr_calldetails_rept[key_call] = 1

				if repeat < arr_calldetails_rept[key_call]:
					repeat = arr_calldetails_rept[key_call]
			else:
				arr_calldetails_unique[key_call][call['From']] = 'yes'
				i += 1
				if key_call in arr_calldetails_uniq:
					arr_calldetails_uniq[key_call] += 1
				else:
					arr_calldetails_uniq[key_call] = 1

				if unique < arr_calldetails_uniq[key_call]:
					unique = arr_calldetails_uniq[key_call]

			if 'RecordingDuration' in call:
				whole_calldur += int(call['RecordingDuration'])				
				whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * call_price[client_id][call['To']]
				# print(call_price[client_id][call['To']])

	else:
		for dt in daterange(from_date_obj, to_date_obj):
			x_axis_data.append(dt.strftime("%d %b"))
		for call in call_details:
			key_call = datetime.datetime.strptime(call['date'], '%Y-%m-%d %H:%M:%S').strftime('%d %b')	

			if call['From'] in arr_calldetailswhole_unique:
				if arr_calldetailswhole_unique[call['From']] != 'updated_repeat':
					arr_calldetailswhole_uniq -= 1					
					arr_calldetailswhole_rept += 1

					arr_calldetailswhole_unique[call['From']] = 'updated_repeat'

				arr_calldetailswhole_rept += 1
			else:
				arr_calldetailswhole_unique[call['From']] = 'yes'
				arr_calldetailswhole_uniq += 1

			if key_call in arr_calldetails_unique and call['From'] in arr_calldetails_unique[key_call]:
				if arr_calldetails_unique[key_call][call['From']] != 'updated_repeat':
					arr_calldetails_uniq[key_call] -= 1
					if key_call in arr_calldetails_rept:
						arr_calldetails_rept[key_call] += 1
					else:
						arr_calldetails_rept[key_call] = 1

					arr_calldetails_unique[key_call][call['From']] = 'updated_repeat'


				if key_call in arr_calldetails_rept:
					arr_calldetails_rept[key_call] += int(1)
				else:
					arr_calldetails_rept[key_call] = int(1)

				if repeat < arr_calldetails_rept[key_call]:
					repeat = arr_calldetails_rept[key_call]
			else:
				arr_calldetails_unique[key_call][call['From']] = 'yes'
				i += 1
				if key_call in arr_calldetails_uniq:
					arr_calldetails_uniq[key_call] += int(1)
				else:
					arr_calldetails_uniq[key_call] = int(1)

				if unique < arr_calldetails_uniq[key_call]:
					unique = arr_calldetails_uniq[key_call]

			if 'RecordingDuration' in call:
				whole_calldur += int(call['RecordingDuration'])
				whole_invoice += int(math.ceil(int(call['RecordingDuration'])/60)) * call_price[client_id][call['To']]
				# print(call_price[client_id][call['To']])

	if arr_calldetails_uniq:
		for val in x_axis_data:		
			v1 = str(val)	
			if v1 not in arr_calldetails_uniq:
				y_axis_unique_count.append(0)
			else:
				y_axis_unique_count.append(arr_calldetails_uniq[v1])
	else:
		for val in x_axis_data:
			y_axis_unique_count.append(0)

	if arr_calldetails_rept:
		for val in x_axis_data:
			v1 = str(val)
			if v1 not in arr_calldetails_rept:
				y_axis_repeat_count.append(0)
			else:
				y_axis_repeat_count.append(arr_calldetails_rept[v1])
	else:
		for val in x_axis_data:
			y_axis_repeat_count.append(0)

	total_call = [(x + y) for x, y in zip(y_axis_unique_count, y_axis_repeat_count)]

	# if repeat < unique:
	# 	max_val = int(unique)+1
	# else:
	# 	max_val = int(repeat)+1
	max_val = 0
	for ii in range(len(y_axis_unique_count)):
		val = int(y_axis_unique_count[ii]) + int(y_axis_repeat_count[ii])
		if val > max_val:
			max_val = val
	if max_val == 0:
		max_val = 1
	# for jj in range(len(y_axis_repeat_count)):
	# 	if y_axis_repeat_count[jj] > max:
	# 		max = y_axis_repeat_count[jj]
	# 		max_repeat = jj

	# print(max_unique)
	# print(max_repeat)

	# max_uniquerepeat = int(y_axis_unique_count[max_unique]) + int(y_axis_repeat_count[max_unique])
	# max_repeatunique = int(y_axis_unique_count[max_repeat]) + int(y_axis_repeat_count[max_repeat])
			
	categories = json.dumps(x_axis_data)


	if int(max_val)%int(yaxis_interval) == 0:
		maxval_app = max_val
	else:
		maxval_app = int(max_val) + (int(yaxis_interval) - int(max_val)%int(yaxis_interval))	

	for val in x_axis_data:	
		maxval_arr.append(maxval_app)
		
	categories = json.dumps(x_axis_data)


	if from_page == 'call_log':
		if prevcall > 0:
			totalcall_comp = ((int(sum(total_call)) - int(prevcall)) / int(prevcall)) * 100
		
		if arr_calldetailswhole_uniq_prev > 0:
			uniq_comp = ((int(arr_calldetailswhole_uniq) - int(arr_calldetailswhole_uniq_prev))/ int(arr_calldetailswhole_uniq_prev))*100
		
		if arr_calldetailswhole_rept_prev > 0:
			rept_comp = ((int(arr_calldetailswhole_rept) - int(arr_calldetailswhole_rept_prev))/ int(arr_calldetailswhole_rept_prev))*100
		
		if whole_calldur_prev > 0:
			duration_comp = ((int(whole_calldur) - int(whole_calldur_prev))/ int(whole_calldur_prev)) * 100
		
		if whole_invoice_prev > 0:
			invoice_comp = ((int(whole_invoice) - int(whole_invoice_prev))/ int(whole_invoice_prev)) * 100
		
		# if whole_calldur > whole_calldur_prev:
		# 	dur_icon = 'up'			

		if whole_calldur_prev >= 60:
			rem_prev = quot_prev = 0
			quot_prev = int(math.floor(int(whole_calldur_prev)/60))
			rem_prev = int(int(whole_calldur_prev) % 60)
			if rem_prev > 0:
				whole_calldur_prev = str(quot_prev) + 'm ' + str(rem_prev) + 's'
			else:
				whole_calldur_prev = str(quot_prev) + 'm'
		else:
			whole_calldur_prev = str(whole_calldur_prev) + 's'

		if whole_invoice_prev > 0:
			whole_invoice_prev = round(whole_invoice_prev, 2)


	if whole_calldur >= 60:
		rem = quot = 0
		quot = int(math.floor(int(whole_calldur)/60))
		rem = int(int(whole_calldur) % 60)
		if rem > 0:
			whole_calldur = str(quot) + 'm ' + str(rem) + 's'
		else:
			whole_calldur = str(quot) + 'm'
	else:
		whole_calldur = str(whole_calldur) + 's'

	if whole_invoice > 0:
		whole_invoice = round(whole_invoice, 2)
	# print(client_select)
	# print(y_axis_unique_count)
	# print(y_axis_repeat_count)
	return render(request,'call-log-graph.html',{'max_val':maxval_app,
		'maxval_arr':maxval_arr,	
		'tickInterval':yaxis_interval,
		'call_price':whole_invoice,	
		'categories':categories,
		'unique_count':y_axis_unique_count,
		'repeat_count':y_axis_repeat_count,
		'total_call':total_call,
		'total_call_count':sum(total_call),
		'unique_count_disp':arr_calldetailswhole_uniq,
		'repeat_count_disp':arr_calldetailswhole_rept,
		'call_duration':whole_calldur,
		'client_select':client_select,
		'selected_client':client_id,
		'from_date': from_date1,
		'to_date': to_date1,
		'total_call_prev_count': prevcall,
		'unique_count_prev_disp':arr_calldetailswhole_uniq_prev,
		'repeat_count_prev_disp':arr_calldetailswhole_rept_prev,
		'call_duration_prev':whole_calldur_prev,
		'call_price_prev': whole_invoice_prev,
		'totalcall_comp': totalcall_comp,
		'uniq_comp': uniq_comp,
		'rept_comp': rept_comp,
		'duration_comp': duration_comp,
		'invoice_comp': invoice_comp,
		'from_page': from_page
		})

def GetUniqueCount(request,start_time,end_time):
	unique_count = 0
	db = GetDB(request)
	collection_name = GetCollection(request)
	unique_count = db[collection_name].find({'date': {'$lte': end_time, '$gte': start_time}}).distinct("From")
	unique_count = len(unique_count)
	return unique_count

def GetCallDuration(request,start_time,end_time):
	duration = 0
	db = GetDB(request)
	collection_name = GetCollection(request)
	# call_duration = db[collection_name].aggregate([
	# 	{"$match": {"date" : {'$lte': end_time, '$gte': start_time} }},
	# 	{"$match": {"RecordingDuration" : {'$exists': 'true'} }},
	# 	{"$group" : { "_id": "$_id", "total": { "$sum": '$RecordingDuration'} } }])	
	calls = db[collection_name].find({'date': {'$lte': end_time, '$gte': start_time}, "RecordingDuration" : {'$exists': 'true'}})
	for call in calls:
		dur = int(call["RecordingDuration"])
		duration = duration+dur

	return duration

def GetRepeatCount(request,start_time,end_time):
	repeat_count = 0
	db = GetDB(request)
	collection_name = GetCollection(request)
	data = db[collection_name].aggregate([
		{"$match": {"date" : {'$lte': end_time, '$gte': start_time} }},
		{"$group" : { "_id": "$From", "count": { "$sum": 1 } } },
	    {"$match": {"count" : {"$gt": 1} }}, 
	    {"$project": {"number" : "$_id", "count" : "$count"} },
		                   ])	
	for call in data:
		repeat_count = repeat_count+1
	return repeat_count	

def GetDB(request):	
	client = MongoClient()
	db = client.calls_test
	return db

def GetCollection(request):
	if 'sid' in request.POST:
		account_sid = request.POST["sid"]
	else:
		account_sid = request.session["sid"]

	collection_name = 'calls_'+account_sid
	return collection_name

def daterange(date1, date2):
    for n in range(int ((date2 - date1).days)+1):
        yield date1 + timedelta(n)

def monthrange(date1, date2):
	result = []
	start = date1
	end = date2
	cur_date = start
	while cur_date < end:
		result.append(cur_date)
		cur_date += relativedelta(months=1)

	return result 

def yearrange(date1, date2):
	year_range = range(date1.year, date2.year+1)
	return year_range

def AccountDataList(request):
	return render(request,'account-data-list.html')

def AccountDataDetailList(request):
	now = datetime.datetime.now()
	MClient = MongoClient()
	agency_callprice = {}
	call_price = {}
	arr_call = {}
	arr_calldetails_unique = {}
	client_data = collections.defaultdict(dict)
	db = MClient.calls_test
	agency_id = request.session["agency_id"]
	client_search = ''
	today = request.POST['to_date']
	first_day = request.POST['from_date']
	from_date = str(first_day)+' 00:00:00'
	to_date = str(today)+' 23:59:59'

	# from_date = '2017-08-01 00:00:00'
	# to_date = '2016-07-15 23:59:59'


	callprice = CallPricing.objects.filter(client_id=agency_id)
	for price in callprice:
		agency_callprice['toll_free_minutes_price'] = price.toll_free_minutes_price
		agency_callprice['local_number_minutes_price']=price.local_number_minutes_price
		agency_callprice['byprefix_minutes_price']=price.byprefix_minutes_price
	
	# if 'client_search' not in request.POST:
	clients = ProfileDetails.objects.raw("select A.id,A.name,A.date_created,A.status, A.sid, count(DISTINCT B.pid) as camp_count, count(DISTINCT C.id) as user_count, count(DISTINCT D.id) as num_count, E.* from agency_client_details A left join campaign_details B on A.id = B.client_id left join user_master C on A.id = C.agency_client_id and C.status = 1 and C.previlege = 5 left join assigned_numbers D on A.id = D.client_id left join call_pricing E on A.id = E.client_id where A.parent_id = '"+str(agency_id)+"' group by A.id, E.id order by A.name")
	# else:
	# 	client_search = request.POST['client_search']
	# 	clients = ProfileDetails.objects.raw("select A.id,A.name,A.date_created,A.status, A.sid, count(DISTINCT B.pid) as camp_count, count(DISTINCT C.id) as user_count, count(DISTINCT D.id) as num_count, E.* from agency_client_details A left join campaign_details B on A.id = B.client_id left join user_master C on A.id = C.agency_client_id and C.status = 1 and C.previlege = 5 left join assigned_numbers D on A.id = D.client_id left join call_pricing E on A.id = E.client_id where A.name like %s and A.parent_id = '"+str(agency_id)+"' group by A.id, E.id order by A.name",['%'+client_search+'%'])
	
	if len(list(clients)) > 0:
		for client in clients:
			# print(client.name)
			numberdetails = AssignedNumbers.objects.raw("select A.id, A.number, B.num_type from number_master A inner join assigned_numbers D on A.id = D.number_id inner join number_details B on A.id = B.number_id where D.client_id='"+str(client.id)+"'")

			for details in numberdetails:
				# print(details.number)
				if details.num_type == 'Local':
					if client.local_number_minutes_price is not None:
						call_price[details.number] = client.local_number_minutes_price
					else:
						call_price[details.number] = agency_callprice['local_number_minutes_price']

				elif details.num_type == 'Toll-Free':
					if client.toll_free_minutes_price is not None:
						call_price[details.number] = client.toll_free_minutes_price
					else:
						call_price[details.number] = agency_callprice['toll_free_minutes_price']

				else:
					if client.byprefix_minutes_price is not None:
						call_price[details.number] = client.byprefix_minutes_price
					else:
						call_price[details.number] = agency_callprice['byprefix_minutes_price']
			
			collection_name = 'calls_'+str(client.sid)
			calls = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}})
			
			# unique_count = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}}).distinct("From")
			# unique_count = len(unique_count)

			callcost = dur = duration = i = 0
			arr_call['unique'] = 0
			arr_call['repeat'] = 0
			for call in calls:
				i += 1

				if call['From'] in arr_calldetails_unique:
					# print(call['From'])
					if arr_calldetails_unique[call['From']] != 'updated_repeat':			
						arr_call['unique'] -= 1
						# print('unique - repeat')
						# print(arr_call['unique'])
						if 'repeat' in arr_call:
							arr_call['repeat'] += 1
						else:
							arr_call['repeat'] = 1

						arr_calldetails_unique[call['From']] = 'updated_repeat'

					if 'repeat' in arr_call:
						arr_call['repeat'] += 1
					else:
						arr_call['repeat'] = 1
				else:
					arr_calldetails_unique[call['From']] = 'yes'
					
					if 'unique' in arr_call:
						arr_call['unique'] += 1
					else:
						arr_call['unique'] = 1
					# print('unique')
					# print(arr_call['unique'])


				
				if 'RecordingDuration' in call:
					dur = int(call["RecordingDuration"])
					callcost += Decimal(call_price[call['To']]) * Decimal(math.ceil(int(call["RecordingDuration"])/60))
					duration = duration+dur


			if duration >= 60:
				duration = str(int(math.floor(int(duration)/60))) + 'm '+ str(int(math.floor(int(duration)%60))) + 's'
			else:
				duration = str(duration) + 's'
			
			client_data[client.id]['name'] = client.name
			client_data[client.id]['campaign'] = client.camp_count
			dateCreated = client.date_created.split( )
			client_data[client.id]['date'] = datetime.datetime.strptime(dateCreated[0], '%Y-%m-%d').strftime('%d %b %Y')
			client_data[client.id]['number'] = client.num_count
			client_data[client.id]['call'] = i
			client_data[client.id]['duration'] = duration
			client_data[client.id]['status'] = client.status
			client_data[client.id]['users'] = int(client.user_count)
			client_data[client.id]['invoice'] = round(callcost,2)
			client_data[client.id]['sid'] = client.sid
			client_data[client.id]['unique'] = arr_call['unique']
			client_data[client.id]['repeat'] = arr_call['repeat']
			

	return render(request,'agency-detail-client-list.html',{"data":client_data.items()})

def GetMonthYearList(year):
	monthyearlist = []
	now = datetime.datetime.now()
	month = now.month

	count = 0
	while count < 12:
	    date_get = datetime.date(int(year),int(month),1)+relativedelta(months=-count)
	    monthyearlist.append(datetime.datetime.strptime(str(date_get), '%Y-%m-%d').strftime("%b `%y"))
	    count += 1
	return monthyearlist

def GetPrevDayFromDate(date_req, cnt):
	date_sp = date_req.split('-')
 	expectedDate = datetime.date(int(date_sp[0]),int(date_sp[1]),int(date_sp[2]))+relativedelta(days=-cnt)
 	return expectedDate

def phone_number(number_param):
	if number_param !='':
		number = number_param[-10:]
		first = number[0:3]
		second = number[3:6]
		third = number[6:10]
		return '(' + first + ')' + ' ' + second + '-' + third
	else:
		return number_param

# def ManipulatingPhoneNumber(request):
# 	client = MongoClient()
# 	db = client.calls_test
# 	collection_name = 'calls_AC11e4b59b0ed69a0d1aade89fbe996f72'
# 	# collection_name = 'calls_AC6c580f81779a325f0311ab7c55a6bc28'
# 	# print(collection_name)
# 	from_date = '2017-10-15 00:00:00'
# 	to_date = '2017-10-30 23:59:59'

# 	calls = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}})
# 	# print(calls)

# 	for call in calls:
# 		update_data = {}
# 		call_id = call['_id']
# 		# print(call['_id'])
# 		randNum = randint(100, 999)
# 		# print(randNum)
# 		from1 = call['From'][:-3]
# 		# print(from1)
# 		update_data['From'] = str(from1) + str(randNum)
# 		updateDb = db[collection_name].update({"_id":call_id},{'$set':update_data}) 
# 		# print(update_data)
# 	return 'Success'


    