# -*- coding: utf-8 -*-
# Generated by Django 1.11 on 2017-10-09 10:03
from __future__ import unicode_literals

import datetime
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('numbermanager', '0002_auto_20171009_1512'),
        ('settings', '0002_auto_20171009_1512'),
    ]

    operations = [
        migrations.CreateModel(
            name='BusinessHours',
            fields=[
                ('pid', models.AutoField(primary_key=True, serialize=False)),
                ('account_id', models.IntegerField()),
                ('day', models.CharField(max_length=50)),
                ('open_time', models.CharField(max_length=50)),
                ('close_time', models.CharField(max_length=50)),
                ('all_day', models.IntegerField(null=True)),
            ],
            options={
                'db_table': 'business_hours',
            },
        ),
        migrations.CreateModel(
            name='CallForwardSettings',
            fields=[
                ('pid', models.AutoField(primary_key=True, serialize=False)),
                ('numberid', models.IntegerField()),
                ('number', models.CharField(max_length=200)),
                ('description', models.TextField()),
                ('step', models.IntegerField()),
                ('when', models.CharField(choices=[('0', 'Always'), ('1', 'During Business Hours'), ('2', 'After Business Hours')], max_length=1)),
                ('active', models.CharField(max_length=5)),
                ('assign_to', models.CharField(max_length=200)),
                ('time_out', models.IntegerField()),
                ('date_created', models.DateTimeField(default=datetime.datetime.now)),
                ('date_modified', models.DateTimeField(default=datetime.datetime.now)),
            ],
            options={
                'db_table': 'call_forward_settings',
            },
        ),
        migrations.CreateModel(
            name='CallGeneralSettings',
            fields=[
                ('pid', models.AutoField(primary_key=True, serialize=False)),
                ('numberid', models.IntegerField()),
                ('good_call_emailid', models.CharField(max_length=200)),
                ('miss_call_emailid', models.CharField(max_length=200)),
                ('business_hrs_play_file', models.CharField(max_length=200)),
                ('after_hrs_play_file', models.CharField(max_length=200)),
                ('time_zone', models.CharField(max_length=200)),
                ('record_call', models.CharField(max_length=2)),
                ('time_out', models.IntegerField()),
                ('caller_id', models.CharField(max_length=15)),
                ('voice_mail_playfile', models.CharField(max_length=200)),
                ('voice_mail_email', models.CharField(max_length=200)),
                ('date_created', models.DateTimeField()),
                ('date_modified', models.DateTimeField()),
            ],
            options={
                'db_table': 'call_general_settings',
            },
        ),
        migrations.CreateModel(
            name='CampaignCustomfields',
            fields=[
                ('pid', models.AutoField(primary_key=True, serialize=False)),
            ],
            options={
                'db_table': 'campaign_customfields',
            },
        ),
        migrations.CreateModel(
            name='CampaignDetails',
            fields=[
                ('pid', models.AutoField(primary_key=True, serialize=False)),
                ('agency_id', models.IntegerField()),
                ('client_id', models.IntegerField()),
                ('name', models.CharField(max_length=200)),
                ('description', models.TextField()),
                ('created_date', models.DateTimeField()),
                ('ad_group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='settings.AdGroups')),
                ('number', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='numbermanager.NumberMaster')),
            ],
            options={
                'db_table': 'campaign_details',
            },
        ),
        migrations.CreateModel(
            name='CustomFields',
            fields=[
                ('pid', models.AutoField(primary_key=True, serialize=False)),
                ('agency_id', models.IntegerField()),
                ('client_id', models.IntegerField()),
                ('field_id', models.IntegerField()),
                ('label', models.CharField(max_length=100)),
                ('field_type', models.CharField(max_length=100)),
                ('field_data', models.TextField()),
                ('date_created', models.DateTimeField()),
            ],
            options={
                'db_table': 'custom_fields',
            },
        ),
        migrations.AddField(
            model_name='campaigncustomfields',
            name='campaign',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='campaigns.CampaignDetails'),
        ),
        migrations.AddField(
            model_name='campaigncustomfields',
            name='field_id',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='campaigns.CustomFields'),
        ),
        migrations.AddField(
            model_name='businesshours',
            name='campaign',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='campaigns.CampaignDetails'),
        ),
    ]
