# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from datetime import datetime    

from django.db import models


# Create your models here.

class CampaignCustomfields(models.Model):
	pid = models.AutoField(primary_key=True)
	campaign = models.ForeignKey('CampaignDetails',null=True)
	fieldid = models.IntegerField()
	value =  models.CharField(max_length=200)
	
	class Meta():
		db_table = 'campaign_customfields'

class CampaignTags(models.Model):
	id = models.AutoField(primary_key=True)
	tag_name = models.CharField(max_length=200)
	campaign_id = models.IntegerField()
	client_id =  models.IntegerField()
	agency_id =  models.IntegerField()
	
	class Meta():
		db_table = 'campaign_tags'

class CallGeneralSettings(models.Model):
    pid = models.AutoField(primary_key=True)
    numberid = models.IntegerField()
    good_call_emailid = models.CharField(max_length=200)
    miss_call_emailid = models.CharField(max_length=200)
    business_hrs_play_file = models.CharField(max_length=200)
    after_hrs_play_file = models.CharField(max_length=200)
    time_zone = models.CharField(max_length=200)
    record_call = models.CharField(max_length=2)
    time_out = models.IntegerField()
    caller_id = models.CharField(max_length=15)
    voice_mail_playfile = models.CharField(max_length=200)
    voice_mail_email = models.CharField(max_length=200)
    date_created = models.DateTimeField()
    date_modified = models.DateTimeField()
    campaign = models.ForeignKey('CampaignDetails',null=True)
    active = models.CharField(max_length=5)

    class Meta():
    	db_table='call_general_settings' 

CALL_WHEN_OPTIONS = (
    ('0', 'Always'),
    ('1', 'During Business Hours'),
    ('2', 'After Business Hours')
    )

class CallForwardSettings(models.Model):
	pid = models.AutoField(primary_key=True)
	numberid = models.IntegerField()
	number = models.CharField(max_length=200)
	description = models.TextField()
	step = models.IntegerField()
	when = models.CharField(max_length=1,choices=CALL_WHEN_OPTIONS)
	active = models.CharField(max_length=5)
	assign_to = models.CharField(max_length=200)
	time_out = models.IntegerField()
	date_created = models.DateTimeField(default=datetime.now)
	date_modified = models.DateTimeField(default=datetime.now)
	campaign = models.ForeignKey('CampaignDetails',null=True)

	class Meta():
		db_table = 'call_forward_settings'
   
class BusinessHours(models.Model):
	pid = models.AutoField(primary_key=True)
	account_id = models.IntegerField()
	day = models.CharField(max_length=50)
	open_time = models.CharField(max_length=50)
	close_time = models.CharField(max_length=50)
	all_day = models.IntegerField(null=True)
	campaign = models.ForeignKey('CampaignDetails',null=True)

	class Meta():
		db_table = 'business_hours'


		
class CustomFields(models.Model):
	pid = models.AutoField(primary_key=True)
	agency_id = models.IntegerField()
	client_id = models.IntegerField()
	field_id = models.IntegerField()
	label = models.CharField(max_length=100)
	field_type = models.CharField(max_length=100)
	field_data = models.TextField()
	date_created = models.DateTimeField()

	class Meta():
		db_table = 'custom_fields'

class CampaignDetails(models.Model):
	pid = models.AutoField(primary_key=True)
	agency_id = models.IntegerField()
	client_id = models.IntegerField()
	ad_group = models.ForeignKey('settings.AdGroups')
	name = models.CharField(max_length=200)
	description = models.TextField()
	created_date = models.DateTimeField()
	number = models.ForeignKey('numbermanager.NumberMaster')
	status = models.IntegerField()

	class Meta():
		db_table = 'campaign_details'

