from django import template

register = template.Library()

@register.filter(name='phonenumber_format')
def phonenumber_format(value):
	if value != 'no_rewrite' and len(value) >= 10 :
		number = value[-10:]
		first = number[0:3]
		second = number[3:6]
		third = number[6:10]
		return '(' + first + ')' + ' ' + second + '-' + third
	else:
		return value

@register.filter(name='amount_format')
def amount_format(value):
	if value > 0:
		amt = round(value, 2)
	else:
		amt = int(value)

	return amt

@register.filter(name='agencydb_format')
def agencydb_format(value):
	if value == 'unique':
		data = 'Numbers'
	else:
		data = 'Duration'
	return data

@register.filter(name='string_upper')
def string_upper(value):
	return value.title()

@register.filter(name='number_counter')
def number_counter(number):
    return range(1,number)

@register.filter(name='lookup')
def lookup(d, key):
    return d[key]
@register.filter(name='in_list')
def in_list(value,arg):
   return value in arg
   
@register.filter(name='in')
def inside(value, arg):
    return value in arg   