# -*- coding: utf-8 -*-

from numbermanager.models import AssignedNumbers,NumberMaster
from settings.models import PlayFiles, AdGroups
from models import CampaignDetails,CallGeneralSettings,CallForwardSettings,BusinessHours,CampaignTags,CampaignCustomfields,CustomFields
from userauth import views
from django.template import RequestContext
from django.http import HttpResponse, JsonResponse
from time import gmtime, strftime
from userauth.models import Login
from django.db.models import Q
import json,collections
from django.shortcuts import render
from django.shortcuts import redirect
from twilio.rest import Client
from collections import defaultdict

tree = lambda:collections.defaultdict(tree)
# Create your views here.
def Settings(request):
	agency_id = request.session['agency_id']
		
	return render(request, "campaigns/settings.html", {"agency_id" : agency_id})

def List(request):
	datagrid = "Campaign(s)"
	# menus = views.SideMenu(request)
	agency_id = str(request.session['agency_id'])
	logged_user_name = request.session['name'] 
	available_numbers = {}
	usednumbers = []
	freenumbers = []
	

	if 'agency_id' not in request.session:
		agency_id = ''

	if 'client_id' not in request.session:
		client_id = str(request.session['agency_id'])
	else:
		client_id = str(request.session['client_id'])
		#https://hubfiles.pw/fcac6b49071073f5?pt=wztoh7lhURSbr9XGyfWnKmfsyb%2F8BvgMQsiKi4gco1U%3D

	campaign_list_all = CampaignDetails.objects.filter(status = 1)	
	adgroup_list = AdGroups.objects.filter(client_id = client_id)
	#available_numbers = AssignedNumbers.objects.filter(number__status=1,agency_id=agency_id,client_id=client_id)
	sql = "select A.*,number from assigned_numbers A inner join number_master B on A.number_id = B.id where status = 1 and agency_id = '"+agency_id+"' and client_id = '"+client_id+"'"
	
	assigned_numbers = AssignedNumbers.objects.raw(sql)
	for number in campaign_list_all:
		usednumbers.append(number.number_id)

	for numberdata in assigned_numbers:
		if numberdata.number_id not in usednumbers:
			available_numbers[numberdata.number_id] = numberdata.number

	call_forward_details = CallForwardSettings.objects.filter(numberid__in=usednumbers).distinct('numberid')
	for forward_detail in call_forward_details:
	 	x = {"pid":forward_detail.pid,"number" : forward_detail.number,
	 	"active" : forward_detail.active,"numberid":forward_detail.numberid}
	 	freenumbers.append(x)

	return render(request, "campaigns/list.html", {"freenumbers":freenumbers,
		"logged_user_name":logged_user_name, "usednumbers":usednumbers, "available_numbers" : available_numbers, "assigned_numbers" : assigned_numbers, "adgroup_list" : adgroup_list,"datagrid":datagrid})

def CampaignList(request):
	agency_id = str(request.session['agency_id'])
	logged_user_name = request.session['name'] 
	campaign_details = []

	data = request.POST
	cnt_call = data["sEcho"]
	lengthdata = data['iDisplayLength']
	sortop = data['sSortDir_0']
	sort_field = 'mDataProp_'+data['iSortCol_0']
	sort_fieldname = str(data[sort_field])
	limit_start = data['iDisplayStart']
	search = data['sSearch']

	if sort_fieldname == "inbound_no":
		sort_fieldname = ""
	elif sort_fieldname == "Num":
		sort_fieldname = ""
	elif sort_fieldname == "forward_no":
		sort_fieldname = " "+sortop+", C.number"
	elif sort_fieldname == "name":
		sort_fieldname = " "+sortop+", A.name"
	else:
		sort_fieldname = " "+sortop+", B.name"
	

	if 'agency_id' not in request.session:
		agency_id = ''

	if 'client_id' not in request.session:
		client_id = str(request.session['agency_id'])
	else:
		client_id = str(request.session['client_id'])

	sql_camp = "select Distinct On (D.number) D.number as inbound_no, A.pid, A.name, B.name as ad_name, C.active, C.number as forward_no from campaign_details A inner join ad_groups B on A.ad_group_id = B.pid left join call_forward_settings C on A.number_id = C.numberid left join number_master D on A.number_id = D.id Where A.status = 1 and "

	if agency_id:
		sql_camp += "A.agency_id='"+agency_id+"' "

	if agency_id != '' and client_id != '':
		sql_camp += "and "

	if client_id:
		sql_camp += "A.client_id='"+client_id+"' "

	if search:
		sql_camp += "and (D.number like %s or lower(A.name) like lower(%s) or lower(B.name) like lower(%s) or C.number like %s) "
		campaign_list_cnt = CampaignDetails.objects.raw(sql_camp,['%'+search+'%','%'+search+'%','%'+search+'%','%'+search+'%'])
		sql_camp += "order by D.number"+sort_fieldname+" "+sortop+" limit "+lengthdata+" offset "+limit_start
		campaign_list = CampaignDetails.objects.raw(sql_camp,['%'+search+'%','%'+search+'%','%'+search+'%','%'+search+'%'])
	else:
		campaign_list_cnt = CampaignDetails.objects.raw(sql_camp)
		sql_camp += "order by D.number"+sort_fieldname+" "+sortop+" limit "+lengthdata+" offset "+limit_start
		campaign_list = CampaignDetails.objects.raw(sql_camp)
	print(sql_camp)
	if len(list(campaign_list_cnt)) == 0:
		campdetails = 0
	else:
		campdetails = len(list(campaign_list_cnt))
		
		i = 1
		num = int(limit_start)+1
		for value in campaign_list:
			nwdict = {}
			nwdict['Num'] = i	
			nwdict['id'] = value.pid	
			if value.name != '':
				nwdict['name'] = value.name
			else:
				nwdict['name'] = ''
			if value.ad_name != '':
				nwdict['ad_name'] = value.ad_name		
			else:
				nwdict['ad_name'] = ''
			if value.inbound_no:
				# nwdict['inbound_no'] = str(value.inbound_no)
				nwdict['inbound_no'] = phone_number(value.inbound_no)
			else:
				nwdict['inbound_no'] = ''

			if value.forward_no:
				# print(value.forward_no)
				# nwdict['forward_no'] = value.forward_no
				nwdict['forward_no'] = phone_number(value.forward_no)		
			else:
				nwdict['forward_no'] = ''
			# if value.status == 'Y':
			# 	nwdict['active'] = 'Active'
			# else:
			# 	nwdict['active'] = 'Inactive'
			
			campaign_details.append(nwdict)
			i = i+1	

	results = {"sEcho" : cnt_call, "iTotalRecords" : campdetails, "iTotalDisplayRecords" : campdetails, "aaData" : campaign_details}
	return HttpResponse(JsonResponse(results))

def CreateCampaign(request):
	agency_id = request.session['agency_id']
	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']
	if request.method == "POST":
		postdata = request.POST
		
		newcampaign = CampaignDetails(agency_id = agency_id ,client_id = client_id, ad_group_id = postdata['camp_adgroup'],
			name = postdata['camp_name'],description = postdata['camp_desc'],created_date = strftime("%Y-%m-%d %H:%M:%S", gmtime()), status = 1)
		number_master = NumberMaster.objects.get(id=postdata['camp_number'])
		newcampaign.number = number_master
		newcampaign.save()
		lastid = CampaignDetails.objects.latest('pid')

	return HttpResponse(json.dumps({"status":"success","id":lastid.pid}), content_type='application/json')

def GeneralSettings(request):
	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']

	weekdays = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday']
	if request.method == "POST":
		postdata = request.POST

		updatecustomfields(request,postdata)
		updatecustomtags(request,postdata)

		campaign_settings = CallGeneralSettings(numberid = postdata['numerid'] ,good_call_emailid = postdata['good_calls'],
		 miss_call_emailid = postdata['missed_calls'],business_hrs_play_file = postdata['businnes_calls'],
			after_hrs_play_file = postdata['afterhours_calls'],record_call = postdata['record_call'],
			date_created = strftime("%Y-%m-%d %H:%M:%S", gmtime()),
			date_modified =	strftime("%Y-%m-%d %H:%M:%S", gmtime()),
			time_out=postdata['global_time_out'],caller_id=postdata['called_id'], campaign_id = postdata['campaign_id'], active = 'Y')
		campaign_settings.save()


	forward_details = json.loads(postdata['forward_details'])
	for section in forward_details:
		if section.has_key('type'):
			CallForwardSettings.objects.filter(pid = section['pid']).update(number = section['number']
			,description = section['description'],step = section['step']
			,when = section['when'],active = section['active'],assign_to = section['assign_to']
			,time_out = section['time_out'], date_created = strftime("%Y-%m-%d %H:%M:%S", gmtime()))
		else:
			campaign_forward_settings = CallForwardSettings()
			campaign_forward_settings.numberid = postdata['numerid']
			campaign_forward_settings.number = section['number']
			campaign_forward_settings.description = section['description']
			campaign_forward_settings.step = section['step']
			campaign_forward_settings.when = section['when']
			campaign_forward_settings.active = section['active']
			campaign_forward_settings.assign_to = section['assign_to']
			campaign_forward_settings.time_out = section['time_out']
			campaign_forward_settings.campaign_id = postdata['campaign_id']
			campaign_forward_settings.date_created =strftime("%Y-%m-%d %H:%M:%S", gmtime())
			campaign_forward_settings.save()
		
	for day in weekdays:
		busniess_hrs = BusinessHours(account_id = client_id,day = day,open_time = postdata[day+'_open_time']
		,all_day = postdata[day+'_allday'],close_time = postdata[day+'_close_time'],
		campaign_id=postdata['campaign_id'])
		busniess_hrs.save()


	return HttpResponse(json.dumps({"status":"success","id":postdata}), content_type='application/json')


def updatecustomfields(request,postdata):
	agency_id = request.session['agency_id']
	responsedata = {}
	
	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']
	
	for i in range(1, 10):
		print i
		if 'customfield'+str(i) in postdata:
			if postdata['customfield'+str(i)] != '' :
				custom_fields = CampaignCustomfields()
				custom_fields.campaign_id = postdata['campaign_id']
				custom_fields.fieldid = i
				custom_fields.value = postdata['customfield'+str(i)]
				custom_fields.save()


def EditCampaign(request, campaign_id):
	datagrid = 'Edit campaign'
	
	agency_id = request.session['agency_id']
	
	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']
	weekdays = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday']

	#campaign_list = CampaignDetails.objects.raw("SELECT pid,name,description,nm.number FROM campaign_details as cd inner join number_master as nm on cd.number_id=nm.id where client_id="+str(client_id)+" and pid ="+str(campaign_id)+" and agency_id="+str(agency_id))
	campaign_list = CampaignDetails.objects.get(client_id = client_id,pid = campaign_id,agency_id=agency_id, status = 1)
	
	general_settings = CallGeneralSettings.objects.filter(numberid = campaign_list.number_id, campaign_id = campaign_id, active = 'Y')
	forward_settings = CallForwardSettings.objects.filter(numberid = campaign_list.number_id, campaign_id = campaign_id, active = 'Y')
	busniess_hrs = BusinessHours.objects.filter(campaign_id = campaign_id).order_by('pid')
	# adgroup_list = AdGroups.objects.filter(client_id = client_id)
	# campaign_count = campaign_list.count()
	# if(campaign_list > 0):
	# 	status= 1
	# else:

	general_setting = []
	for general in general_settings:
		y = {"good_call_emailid": general.good_call_emailid, "miss_call_emailid": general.miss_call_emailid, "business_hrs_play_file": general.business_hrs_play_file, "after_hrs_play_file": general.after_hrs_play_file, "time_out": general.time_out, "caller_id": general.caller_id, "record_call": general.record_call}
		general_setting.append(y)

	# print(general_setting)

	details = []
	final_array = []
	i = 1
	for setting in forward_settings:
		x = {"pid":setting.pid,"numberid" : setting.numberid,"number" : setting.number,
		"description" : setting.description,"step" : setting.step,"when":setting.when,
		"active" : setting.active,"time_out": setting.time_out,
		"assign_to": setting.assign_to,"type":"old"}

		details.append(x)

	customfields = CustomFields.objects.filter(client_id = client_id)
	if(customfields):
		customfields = customfields
	else:
		customfields = CustomFields.objects.filter(agency_id = agency_id)

	for field in customfields:
		result_array = {}
		result_array['label'] = field.label
		result_array['field_id'] = field.field_id
		result_array['type'] = field.field_type
		if field.field_type == 'menu':
			result_array['data'] = json.loads(field.field_data)
		else:
			result_array['data'] = field.field_data

		final_array.append(result_array)
		
	status= 0
	userlist = Login.objects.filter(agency_client_id = client_id)
	playfiles_list = PlayFiles.objects.filter(Q(client = client_id)| Q(general_file=1))
	taglist = CampaignTags.objects.filter(campaign_id = campaign_id,agency_id = agency_id,client_id = client_id)
	
	sql = "select A.*,number from assigned_numbers A inner join number_master B on A.number_id = B.id where status = 1 and agency_id = '"+str(agency_id)+"' and client_id = '"+str(client_id)+"'"
	available_numbers = AssignedNumbers.objects.raw(sql)
	
	return render(request, "campaigns/editcampaign.html",{"campaign_id":campaign_id,
		"userlist":userlist,"status" : status,"weekdays":weekdays,
		"campaign_list":campaign_list,"playfiles_list":playfiles_list,
		"general_settings":general_setting,"forward_settings":forward_settings,
		"busniess_hrs":busniess_hrs,"details":json.dumps(details),"customfields":final_array,
		"taglist":taglist, "datagrid":datagrid, "available_numbers": available_numbers})

def DeleteCampaign(request):
	camp_numbers = []
	agency_id = request.session['agency_id']
	
	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']

	campaign_id = request.POST['camp_id']
	deactivate_option = int(request.POST['camp_opt'])

	campaign_list = CampaignDetails.objects.get(client_id = client_id,pid = campaign_id,agency_id=agency_id)
	CallGeneralSettings.objects.filter(campaign_id = campaign_id).update(active = 'N')
	CallForwardSettings.objects.filter(campaign_id = campaign_id).update(active = 'N')
	# BusinessHours.objects.filter(campaign_id = campaign_id).delete()
	# CustomFields.objects.filter(campaign_id = campaign_id).delete()
	# CampaignTags.objects.filter(client_id = client_id,campaign_id = campaign_id,agency_id=agency_id).delete()
	if deactivate_option == 2:
		number_details = NumberMaster.objects.get(id = campaign_list.number_id)
		client = TwilioClient(request)
		client.incoming_phone_numbers(number_details.sid).delete();
		NumberMaster.objects.filter(id = campaign_list.number_id).update(status = 2)


	CampaignDetails.objects.filter(client_id = client_id,pid = campaign_id,agency_id=agency_id).update(status = 2)
	
	return HttpResponse('success')


def EditSettings(request):
	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']
	weekdays = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday']

	if request.method == "POST":
		postdata = request.POST
		updatecustomfields(request,postdata)
		updatecustomtags(request,postdata)
		campaign_id = postdata['campaign_id']

		CampaignDetails.objects.filter(pid = campaign_id, status = 1).update(name = postdata['camp_name'], description = postdata['camp_desc'], number_id = postdata['numberid'])
		campaign_general_settings = CallGeneralSettings.objects.filter(campaign_id = campaign_id)
		#campaign_forward_settings = CallForwardSettings.objects.get(numberid = postdata['numberid'])

		if len(list(campaign_general_settings)) == 0:
			campaign_settings = CallGeneralSettings(numberid = postdata['numberid'] ,good_call_emailid = postdata['good_calls'],
		 miss_call_emailid = postdata['missed_calls'],business_hrs_play_file = postdata['businnes_calls'],
			after_hrs_play_file = postdata['afterhours_calls'],record_call = postdata['record_call'],
			date_created = strftime("%Y-%m-%d %H:%M:%S", gmtime()),
			date_modified =	strftime("%Y-%m-%d %H:%M:%S", gmtime()),
			time_out=postdata['global_time_out'],caller_id=postdata['called_id'], campaign_id = postdata['campaign_id'], active = 'Y')
			campaign_settings.save()
		else:
			campaign_general_settings = CallGeneralSettings.objects.get(campaign_id = campaign_id)

			campaign_general_settings.numberid = postdata['numberid']
			campaign_general_settings.good_call_emailid = postdata['good_calls']
			campaign_general_settings.miss_call_emailid = postdata['missed_calls']
			campaign_general_settings.business_hrs_play_file = postdata['businnes_calls']
			campaign_general_settings.after_hrs_play_file = postdata['afterhours_calls']
			campaign_general_settings.record_call = postdata['record_call']
			campaign_general_settings.date_modified = strftime("%Y-%m-%d %H:%M:%S", gmtime())
			campaign_general_settings.time_out = postdata['global_time_out']
			campaign_general_settings.caller_id = postdata['called_id']
			campaign_general_settings.campaign_id = postdata['campaign_id']
			campaign_general_settings.active = 'Y'
			campaign_general_settings.save()

		forward_details = json.loads(postdata['forward_details'])

		for section in forward_details:
			if section.has_key('type'):
				CallForwardSettings.objects.filter(pid = section['pid']).update(numberid = postdata['numberid'], number = section['number']
				,description = section['description'],step = section['step']
				,when = section['when'],active = section['active'],assign_to = section['assign_to']
				,time_out = section['time_out'], date_created = strftime("%Y-%m-%d %H:%M:%S", gmtime()))
			else:
				campaign_forward_settings = CallForwardSettings()
				
				campaign_forward_settings.numberid = postdata['numberid']
				campaign_forward_settings.number = section['number']
				campaign_forward_settings.description = section['description']
				campaign_forward_settings.step = section['step']
				campaign_forward_settings.when = section['when']
				campaign_forward_settings.active = section['active']
				campaign_forward_settings.assign_to = section['assign_to']
				campaign_forward_settings.time_out = section['time_out']
				campaign_forward_settings.campaign_id = postdata['campaign_id']
				campaign_forward_settings.date_created =strftime("%Y-%m-%d %H:%M:%S", gmtime())
				campaign_forward_settings.save()
				
		for day in weekdays:
			BusinessHours.objects.filter(day = day,campaign_id = campaign_id).update(open_time = postdata[day+'_open_time']
		  	,all_day = postdata[day+'_allday'],close_time = postdata[day+'_close_time'])

		
	return HttpResponse(json.dumps({"status":"success","id":postdata}), content_type='application/json')

def CustomFieldsList(request):
	datagrid = 'Custom Fields'
	context = range(1, 11)
	agency_id = request.session['agency_id']
	
	final_array = []
	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']

	customfields = CustomFields.objects.filter(client_id = client_id)
	if(customfields):
		customfields = customfields

	else:
		customfields = CustomFields.objects.filter(agency_id = agency_id)
	i=0
	# result_array = defaultdict(dict)
	for field in customfields:
		result_array = {}
		result_array['label']= field.label
		result_array['pid'] = field.pid
		result_array['field_id'] = field.field_id
		result_array['type'] = field.field_type
		result_array['data'] = json.loads(field.field_data)

		final_array.append(result_array)

		i +=1
	print final_array
	return render(request, "campaigns/customfields.html",{"request":request,"datagrid":datagrid,
		"context":context,"customfields":final_array})

def AddField(request,field_id):
	datagrid = 'Add Field'
	agency_id = request.session['agency_id']
	responsedata = {}

	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']


	if request.method == "POST":
		postdata = request.POST
		item_type = postdata['itemtype']
		item_desc = postdata['itemdesc']
		item_label = postdata['itemlabel']
		if(item_type=='menu'):
			i = 0
			for item in item_desc.splitlines():
				responsedata[item]=item
				i +=1

		new_custom_field = CustomFields()
		new_custom_field.agency_id = agency_id
		new_custom_field.client_id = client_id
		new_custom_field.label = item_label
		new_custom_field.field_id = field_id
		new_custom_field.field_type = item_type
		new_custom_field.field_data = json.dumps(responsedata)
		new_custom_field.date_created = strftime("%Y-%m-%d %H:%M:%S", gmtime())
		new_custom_field.save()
		return redirect('/campaigns/customfields')	

	return render(request, "campaigns/addfield.html",{"request":request,"datagrid":datagrid,
		"field_id":field_id})

def UpdateField(request,field_id):
	datagrid = 'Edit Field'
	final_array =[]
	agency_id = request.session['agency_id']
	responsedata = {}

	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']


	if request.method == "POST":
		postdata = request.POST
		item_type = postdata['itemtype']
		item_desc = postdata['itemdesc']
		item_label = postdata['itemlabel']
		pid 	= postdata['pid']
		if(item_type=='menu'):
			i = 0
			for item in item_desc.splitlines():
				responsedata[item]=item
				i +=1

		new_custom_field = CustomFields()
		new_custom_field.agency_id = agency_id
		new_custom_field.client_id = client_id
		new_custom_field.label = item_label
		new_custom_field.field_id = field_id
		new_custom_field.pid = pid
		new_custom_field.field_type = item_type
		new_custom_field.field_data = json.dumps(responsedata)
		new_custom_field.date_created = strftime("%Y-%m-%d %H:%M:%S", gmtime())
		new_custom_field.save()

		return redirect('/campaigns/customfields')	

	customfields = CustomFields.objects.filter(client_id = client_id,field_id=field_id)
	if(customfields):
		customfields = customfields

	else:
		customfields = CustomFields.objects.filter(agency_id = agency_id,field_id=field_id)
	i=0

	for field in customfields:
		result_array = {}
		result_array['label'] = field.label
		result_array['pid'] = field.pid
		result_array['field_id'] = field.field_id
		result_array['type'] = field.field_type
		joindata  = json.loads(field.field_data)
		result_array['data'] = '\n'.join(joindata);

		final_array.append(result_array)

		i +=1
	print final_array
	
	return render(request, "campaigns/editfield.html",{"request":request,"datagrid":datagrid,"final_array":final_array,
		"field_id":field_id})

def RemoveField(request):
	campaigncustom = CustomFields.objects.filter(pid=request.POST['pid'])
	campaigncustom.delete()	
	return HttpResponse(json.dumps({"status":"success"}), content_type='application/json')

def CampaignSetting(request, campaign_id):
	datagrid = 'Create Campaign'
	agency_id = request.session['agency_id']

	weekdays = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday']
	menus = views.SideMenu(request)
	final_array = []

	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']

	# campaign_list = CampaignDetails.objects.raw("SELECT pid,name,description,nm.number FROM campaign_details as cd inner join number_master as nm on cd.number_id=nm.id where client_id="+str(client_id)+" and pid ="+str(campaign_id)+" and agency_id="+str(agency_id))
	campaign_list = CampaignDetails.objects.get(client_id=client_id,pid=campaign_id,agency_id=agency_id, status = 1)
	# campaign_count = len(list(campaign_list))
	if(campaign_list):
		status = 1
	else:
		status = 0
	userlist = Login.objects.filter(agency_client_id = client_id)
	playfiles_list = PlayFiles.objects.filter(Q(client = client_id)| Q(general_file = 1))

	customfields = CustomFields.objects.filter(client_id = client_id)
	if(customfields):
		customfields = customfields
	else:
		customfields = CustomFields.objects.filter(agency_id = agency_id)
	
	# for field in customfields:
	# 	result_array = {}
	# 	result_array['label'] = field.label
	# 	result_array['field_id'] = field.field_id
	# 	result_array['type'] = field.field_type
	# 	result_array['data'] = json.loads(field.field_data)

	# 	final_array.append(result_array)

	return render(request, "campaigns/campaignsetting.html",{"menus":menus,"campaign_id":campaign_id,
		"userlist":userlist,"status" : status,"weekdays":weekdays,
		"campaign_list":campaign_list,"playfiles_list":playfiles_list,"customfields":final_array, "datagrid": datagrid})

def AddTagField(request):
	agency_id = request.session['agency_id']
	tag_id = ''

	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']

	if request.method == "POST":
		postdata = request.POST
		if postdata['editag_id'] is not None and postdata['editag_id'] != '':
			tag_id = postdata['editag_id']
			CampaignTags.objects.filter(id=postdata['editag_id'],campaign_id=postdata['campaign_id']).update(tag_name=postdata['tag_value'])
		else:
			newtags = CampaignTags(tag_name=postdata['tag_value'],campaign_id=postdata['campaign_id'],client_id=client_id,agency_id=agency_id)
			newtags.save()
			tag_id = newtags.id
		
	return HttpResponse(json.dumps({"status":postdata, 'tag_id': tag_id}), content_type='application/json')

def DeleteTag(request):
	agency_id = request.session['agency_id']

	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']

	if request.method == "POST":
		postdata = request.POST
		newtags = CampaignTags.objects.get(id=postdata['tag_id'],campaign_id=postdata['campaign_id'])
		newtags.delete()
	return HttpResponse(json.dumps({"status":postdata}), content_type='application/json')

def phone_number(number_param):
	number = number_param[-10:]
	first = number[0:3]
	second = number[3:6]
	third = number[6:10]
	return '(' + first + ')' + ' ' + second + '-' + third

def TwilioClient(request):
	account_sid = request.session["sid"]
	auth_token = request.session["auth_token"]	
	client = Client(account_sid, auth_token)
	return client

def updatecustomtags(request, postdata):
	agency_id = request.session['agency_id']
	tag_id = ''

	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']

	CampaignTags.objects.filter(campaign_id=postdata['campaign_id']).delete()
	if postdata['tagData'] is not None:
		tagDetails = postdata['tagData'].split(',')
		if len(tagDetails) > 0:
			# CampaignTags.objects.filter(campaign_id=postdata['campaign_id']).delete()
			for details in tagDetails:
				if details != '':
					newtags = CampaignTags(tag_name=str(details),campaign_id=postdata['campaign_id'],client_id=client_id,agency_id=agency_id)
					newtags.save()


