from __future__ import unicode_literals

from django.db import models

# Create your models here.
class Category(models.Model):
	name = models.CharField(max_length = 250)
	url = models.CharField(max_length = 250)
	section = models.IntegerField() #1=>Header Menu, 2=>Side Tab,
	menu_show = models.TextField() #1=>Super Admin, 2=>Agency,3=>Client
	parent_id = models.IntegerField()
	status = models.IntegerField()
	icon = models.CharField(max_length = 250, null=True)

	class Meta:
		db_table = 'menu_category'

class AgencyClientPermission(models.Model):
	category = models.ForeignKey(Category, on_delete=models.CASCADE)
	agency_client_id = models.IntegerField()

	class Meta:
		db_table = 'agency_client_permission'


class UserPermission(models.Model):
	agency_client = models.ForeignKey(AgencyClientPermission, on_delete=models.CASCADE)
	user_id = models.IntegerField()

	class Meta:
		db_table = 'user_permission'		

# class ProfileDetails(models.Model):
# 	name = models.CharField(max_length = 250)
# 	url = models.CharField(max_length = 250)
# 	industry = models.IntegerField()
# 	type_selected = models.IntegerField()
# 	address = models.TextField()
# 	parent_id = models.IntegerField()
# 	status = models.IntegerField()
	# pricing = models.ForeignKey('settings.Pricing')


# 	class Meta:
# 		db_table = 'agency_client_details'