from menumanager.models import Category,AgencyClientPermission
from django.core.urlresolvers import resolve
from userauth.models import ProfileDetails
from django.shortcuts import redirect

from django.http import HttpResponse
from django.shortcuts import render
from userauth.models import Login
from django.db.models import Q
from userauth import views
import simplejson as json

# Create your views here.
def MenuList(request):
	datagrid = 'Manage Menu(s)'
	if request.session.has_key('username'):
		categories = getmenu(request)
		return render(request,"menumanager/index.html",{"categories" : categories,"datagrid" : datagrid})
	else:
		return render(request, "login.html", {"title" : 'Login'})

def AddMenu(request):
	if request.method == 'POST':
		form = request.POST

		menu = Category()
		menu.name = form['menu_name']
		menu.url = form['menu_url']
		menu.status = 1
		menu.section = 1
		if 'chk_sub' not in form:
			menu.parent_id = 0
		else:
			menu.parent_id = form['mainmenu_sel']

		if form['hid_menuid'] == '':
			# menu.save()
			show_list = form.getlist('show')
			list_str = ''
			for show in show_list:
				list_str += show+','

			list_str = list_str[:-1]
			menu.menu_show = list_str
			menu.save()

			response = {'status': 1, 'id': menu.id}
		else:
			show_list = form.getlist('show')
			list_str = ''
			for show in show_list:
				list_str += show+','

			list_str = list_str[:-1]

			Category.objects.filter(id=form['hid_menuid']).update(name=form['menu_name'], url= form['menu_url'], parent_id=menu.parent_id,menu_show=list_str)
			response = {'status': 1, 'id': form['hid_menuid']}
	else:
		response = {'status': 0}

	return HttpResponse(json.dumps(response), content_type='application/json')

def getmenu(request, id = ''):	
	if id == '':
		menu = Category.objects.raw('select A.*, B.name as mainmenu from menu_category A LEFT JOIN menu_category B on A.parent_id = B.id where A.status = 1')
		if len(list(menu)) == 0:
			data_menu = 0
		else:
			data_menu = list(menu)

		return data_menu
	else:
		menu = Category.objects.raw('select A.*, B.name as mainmenu from menu_category A LEFT JOIN menu_category B on A.parent_id = B.id where A.status = 1 and A.id = %s', [id])
		data_menu = list(menu)
		return data_menu[0]
	
def MenuDetails(request):
	if request.method == 'POST':
		data = request.POST
		menu = getmenu(request, data['menu_id'])
		menu_show = menu.menu_show.split(',')
		response = {'result': 'success', 'id': menu.id, 'name': menu.name, 'url': menu.url, 'mainmenu': menu.mainmenu, 'mainmenu_id': menu.parent_id, 'menu_show':menu_show}
	else:
		response = {'result': 'fail'}

	return HttpResponse(json.dumps(response), content_type='application/json')

def SetPermission(request):
	datagrid = 'Set Permission'
	if request.session.has_key('agency_previlege'):
		agency_client_user_type = int(request.session["agency_previlege"])
	elif request.session.has_key('client_previlege'):
		agency_client_user_type = int(request.session["client_previlege"])
	elif request.session.has_key('previlege'):
		agency_client_user_type = int(request.session["previlege"])
	menu_list = {}
	category_final = {}

	if agency_client_user_type == 1:
		#Super Admin, so list all the agencies
		logged_user_previlage = "Super Admin"
		user_type_name = "Agency"	
		user_data = Login.objects.filter(previlege=2)
		categories = Category.objects.all()
		for category in categories:
			if category.parent_id == 0:
				menu_list[category.id] = category.name
		
		for menu in menu_list:
			menu_category = Category.objects.filter(parent_id=menu)
			if menu_category.count() > 0:
				for menu_item in menu_category:
					category_final[menu_item.id] = menu_list[menu]+'-'+menu_item.name
			else:
				category_final[menu] = menu_list[menu]	
					
	if request.method == "POST":
		agency_client_id = request.POST["user_type"]
		# user = Login.objects.get(id=agency_client_id)
		agency_client_remove_old = AgencyClientPermission.objects.filter(agency_client_id=agency_client_id).delete()
		sub_categories = json.loads(request.POST['category'])

		for sub_id in sub_categories:
			agency_client = AgencyClientPermission()
			category = Category.objects.get(id=float(sub_id))
			agency_client.category = category
			agency_client.agency_client_id = agency_client_id
			agency_client.save()
		response = {'result': 'success'}
		return HttpResponse(json.dumps(response), content_type='application/json')

	menu = views.getmainmenu(request)

	return render(request,"set-permission.html",{"user_data":user_data,"datagrid":datagrid,"category":category_final,"user_type":user_type_name,"logged_user":logged_user_previlage})

def TestLogin(request):
	if 'user_type' in request.session:
		del request.session['user_type']
	return render(request,"test-login.html")

def SetLogin(request,key):
	request.session['user_type']=int(key)
	return render(request,"select-user.html")

def UserPermission(request):	
	datagrid = 'User Permission'
	if request.method == "POST":
		# print request.POST
		agency_client_id = request.POST["user_type"]
		agency_client_remove_old = AgencyClientPermission.objects.filter(agency_client_id=agency_client_id).delete()

		sub_categories = request.POST.getlist('category')
		for sub_id in sub_categories:
			agency_client = AgencyClientPermission()
			category = Category.objects.get(id=sub_id)
			agency_client.category = category
			agency_client.agency_client_id = agency_client_id
			agency_client.save()

	user_type_name = "Users"

	if request.session.has_key('client_previlege') and request.session.has_key('client_id'):
		agency_client_id = int(request.session['client_id'])
	elif request.session.has_key('agency_previlege') and request.session.has_key('agency_id'):
		agency_client_id = int(request.session['agency_id'])
	#list the users under this agency
	user_data = Login.objects.filter(agency_client_id=agency_client_id)

	return render(request,"set-permission.html",{"user_data":user_data,"user_type":user_type_name,
		"datagrid":datagrid})

def ClientPermission(request):
	datagrid = 'Client Permission'
	if request.method == "POST":

		agency_client_id = request.POST["user_type"]
		agency_client_remove_old = AgencyClientPermission.objects.filter(agency_client_id=agency_client_id).delete()

		sub_categories = request.POST.getlist('duallistbox_1')
		for sub_id in sub_categories:
			agency_client = AgencyClientPermission()
			category = Category.objects.get(id=sub_id)
			agency_client.category = category
			agency_client.agency_client_id = agency_client_id
			agency_client.save()

	user_type_name = "Clients"
	if request.session.has_key('agency_previlege') and request.session.has_key('agency_id'):
		agency_client_id = int(request.session['agency_id'])
		agency_client_data = ProfileDetails.objects.filter(parent_id=agency_client_id)
		#List All the Clients(Admin user of that client)
		user_data = Login.objects.filter(previlege=3,agency_client_id__in=agency_client_data)

		return render(request,"set-permission.html",{"user_data":user_data,"datagrid":datagrid,"user_type":user_type_name})
	else:
		return redirect('/userauth/logout/')	

def AddUser(request):
	print ("Agency/Client User")
	return render(request,"add-user.html",{})

def HorizontalMenu(request):
	return render(request, "hor_menu.html", {"title" : 'Login'})

def GetMenuList(request):
	id = request.POST['id']
	user_type = request.POST['user_type']

	if request.session.has_key('client_previlege'):
		agency_client_user_type = int(request.session["client_previlege"])
		categories = Category.objects.filter(menu_show__contains='3')
	elif request.session.has_key('agency_previlege'):
		agency_client_user_type = int(request.session["agency_previlege"])
		categories = Category.objects.filter(menu_show__contains='2')
	elif request.session.has_key('previlege'):
		agency_client_user_type = int(request.session["previlege"])	
		categories = Category.objects.filter(status=1)
	
	menu_list={}
	category_final ={}
	permissions = {}

	#Fetch details from agency_client_permission
	agency_client_id = id
	# permissions = AgencyClientPermission.objects.filter(agency_client_id=agency_client_id)
	#result will be a list 
	permissions = AgencyClientPermission.objects.values_list('category_id',flat=True).filter(agency_client_id=agency_client_id)

	for category in categories:
		if category.parent_id == 0:
			menu_list[category.id] = category.name

	for menu in menu_list:
		menu_category = Category.objects.filter(parent_id=menu)
		if menu_category.count() > 0:
			for menu_item in menu_category:
				category_final[menu_item.id] = menu_list[menu]+'-'+menu_item.name
		else:
			category_final[menu] = menu_list[menu]							
														
	return render(request,"category-list.html",{"category":category_final,"selected_items":permissions})	