from django.shortcuts import render
from django.http import HttpResponse
from django.db.models import Q
from menumanager.models import Category,AgencyClientPermission
from myapp.models import Login
from django.shortcuts import redirect

# Create your views here.
def MenuList(request):
	menu = getmenu(request)	
	return render(request,"index.html", {"menu" : menu})

def AddMenu(request):
	return render(request,"add-menu.html")	

def getmenu(request):	
	menu = Category.objects.raw('select A.*, B.name as mainmenu from menu_category A LEFT JOIN menu_category B on A.parent_id = B.id where A.status = 1')
	
	if len(list(menu)) == 0:
		data_menu = 0
	else:
		data_menu = list(menu)

	return data_menu

def ListMenu(request):
	return render(request,"index.html")

def AddCategory(request):
	return render(request,"add-category.html")	

def SetPermission(request):
	#Identify the user type (Agency/Client/Agency-User/Client-User)
	# SuperAdmin=1,Agency=2,Client=3,Agency-User=4,Client-User=5

	agency_client_user_type = int(request.session["user_type"])

	menu_list = {}
	category_final = {}

	if agency_client_user_type == 1:
		#Super Admin, so list all the agencies
		logged_user_previlage = "Super Admin"
		user_type_name = "Agency"
		user_data = Login.objects.filter(previlege=2)	
		categories = Category.objects.all()
		for menu in menu_list:
			menu_category = Category.objects.filter(parent_id=menu)
			if menu_category.count() > 0:
				for menu_item in menu_category:
					category_final[menu_item.id] = menu_list[menu]+'-'+menu_item.name
			else:
				category_final[menu] = menu_list[menu]	
					
	elif agency_client_user_type == 2:
		logged_user_previlage = "Agency"
		logged_user_id = 3 #some id of an agency
		#Agency can have clients & Users so identify it
		sub_user = int(request.session["sub_user"])
		print sub_user

		if sub_user == 3:
			user_type_name = "Client"
			user_data = Login.objects.filter(previlege=3)
			client_categories = AgencyClientPermission.objects.filter(agency_client_id=logged_user_id)
			
			print "sub categories"
			items=[]
			for sub_id in client_categories:
				print sub_id.category_id
				items.append(sub_id.category_id)

			print items	
			category = Category.objects.filter(id__in=items)
			print "Menu Names"
			for elt in category:
				print elt.name
			
			category_final ={}
			for elt in category:
				parent_id = elt.parent_id
				if parent_id !=0:
					parent_menu =Category.objects.get(id=parent_id)
					parent_name = parent_menu.name
					category_final[elt.id] = parent_name+'-'+elt.name
				else:
					category_final[elt.id] = elt.name	
					
			print "Category Final"		
			print category_final		

	if request.method == "POST":
		print request.POST
		agency_client_id = request.POST["user_type"]
		# user = Login.objects.get(id=agency_client_id)
		agency_client_remove_old = AgencyClientPermission.objects.filter(agency_client_id=agency_client_id).delete()

		sub_categories = request.POST.getlist('category')
		for sub_id in sub_categories:
			agency_client = AgencyClientPermission()
			category = Category.objects.get(id=sub_id)
			agency_client.category = category
			agency_client.agency_client_id = agency_client_id
			agency_client.save()
			print ("saved")
			print agency_client.id			

	# print user_data
	# print categories
	return render(request,"set-permission.html",{"user_data":user_data,"category":category_final,"user_type":user_type_name,"logged_user":logged_user_previlage})

def TestLogin(request):
	if 'user_type' in request.session:
		del request.session['user_type']
	return render(request,"test-login.html")
	# print  "test" 

def SetLogin(request,key):
	print key
	request.session['user_type']=int(key)
	return render(request,"select-user.html")

def SetSession(request,key):
	print "Sub user"+key
	if 'sub_user' in request.session:
		del request.session['sub_user']
	request.session['sub_user'] = key	
	print request.session['sub_user']
	return redirect('/menu-management/set-permission')	