# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models

# Create your models here.

class NumberMaster(models.Model):
	number = models.CharField(max_length = 25)
	date_ordered = models.DateTimeField()
	sid = models.CharField(null=True,max_length = 250)
	status = models.IntegerField()
	client_uniqueid = models.CharField(max_length = 20)

	class Meta:
		db_table = 'number_master'

class NumberDetails(models.Model):
	number = models.OneToOneField(NumberMaster,on_delete=models.CASCADE)
	prefix = models.IntegerField(null=True)
	num_type = models.CharField(max_length = 50)
	rate_center = models.CharField(max_length = 50,null=True)
	region = models.CharField(max_length = 50,null=True)
	iso_country = models.CharField(max_length = 50,null=True)

	class Meta:
		db_table = 'number_details'

class AssignedNumbers(models.Model):
	# number = models.OneToOneField(NumberMaster,on_delete=models.CASCADE)
	#number = models.ForeignKey(NumberMaster,NumberDetails)
	number_id = models.IntegerField()
	agency_id = models.IntegerField()
	client = models.ForeignKey('userauth.ProfileDetails')

	class Meta:
		db_table = 'assigned_numbers'

class BlacklistNumbers(models.Model):
	number = models.CharField(max_length = 25)
	agency_client = models.ForeignKey('userauth.ProfileDetails')

	class Meta:
		db_table = 'blacklist_numbers'

class WhitelistNumbers(models.Model):
	number = models.CharField(max_length = 25)
	agency_client = models.ForeignKey('userauth.ProfileDetails')

	class Meta:
		db_table = 'whitelist_numbers'
