from django.conf.urls import url
from django.views.decorators.csrf import csrf_exempt
from . import views

urlpatterns = [
	url(r'^order-numbers/', views.OrderNumbers, name = 'order-numbers'),
    url(r'^order-toll-free/', views.OrderTollFree, name = 'order-toll-free'),
    url(r'^order-local/', views.OrderLocal, name = 'order-local'),
    url(r'^order-final/$', views.OrderFinal, name = 'order-final'),
    url(r'^list-numbers/', views.ListNumbers, name = 'list-numbers'),
    url(r'^list-numbers-data/', views.ListNumberData, name = 'list-numbers-data'),
    url(r'^release/(\d+)/', views.ReleaseNumbers, name = 'release-numbers'),
    url(r'^blacklist/', views.BlacklistNumber, name = 'blacklist'),
    url(r'^add-blacklist/', views.AddBlacklistNumber, name = 'add-blacklist-number'),
    url(r'^remove-blacklist/(\d+)', views.RemoveBlacklistNumber, name = 'remove-blacklist'),
	url(r'^whitelist/', views.WhitelistNumber, name = 'whitelist'),
    url(r'^add-whitelist/', views.AddWhitelistNumber, name = 'add-whitelist-number'),
    url(r'^remove-whitelist/(\d+)', views.RemoveWhitelistNumber, name = 'remove-whitelist'),
    url(r'^order-local-final/$', views.OrderLocalFinal, name = 'order-local-final'),
    url(r'^remove-number/(\d+)', views.RemoveNumber, name = 'remove-number'),   
    url(r'^order-toll-free-final/$', views.OrderTollFreeFinal, name = 'order-toll-free-final'),
    url(r'^order-by-prefix/', views.OrderByPrefix, name = 'order-by-prefix'),
    url(r'^order-by-prefix-final/', views.OrderByPrefixFinal, name = 'order-by-prefix-final'),
    url(r'^order-by-region/', views.OrderByRegion, name = 'order-by-region'),
    url(r'^order-by-region-final/', views.OrderByRegionFinal, name = 'order-by-region-final'),
    url(r'^order-by-state/', views.OrderByState, name = 'order-by-state'),
    url(r'^order-by-state-final/', views.OrderByStateFinal, name = 'order-by-state-final'),
    url(r'^get-states/',views.GetStates,name='get-states'),
    url(r'^deletetest/',views.Deletetest,name='delete-recordings'),
    url(r'^migrate/',views.migrateNumberToSubaccount,name='migrate'),
    url(r'^updatephonenumbers/',views.updatePhoneNumbers,name='updatephonenumber'),
    
    url(r'^voice-url/',csrf_exempt(views.VoiceUrl),name='voice-url'),
    url(r'^record-callback-url/',csrf_exempt(views.RecordCallbackUrl),name='record-callback-url'),
    url(r'^test/',csrf_exempt(views.Test),name='test'),
    url(r'^dial-action-url/',csrf_exempt(views.DialActionUrl),name='dial-action-url'),
    url(r'^number-status-callback-url/',csrf_exempt(views.NumberStatusCallBackUrl),name='number-status-callback-url'),
    
 ]