# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from numbermanager.models import NumberMaster,NumberDetails,AssignedNumbers,BlacklistNumbers,WhitelistNumbers
from campaigns.models import CallGeneralSettings,CallForwardSettings,CampaignTags,BusinessHours,CampaignDetails,CampaignCustomfields
from twilio.twiml.voice_response import Dial, Number, VoiceResponse, Play,Record
from django.core.mail import send_mail, EmailMultiAlternatives
from django.http import HttpResponse,JsonResponse
from django.shortcuts import render,redirect
from django.conf import settings
from userauth.models import ProfileDetails
from settings.models import CountryCodes,WebhookSettings
from django.db.models import Count,Q
from pymongo import MongoClient
from twilio.rest import Client
from urlparse import urlparse
from userauth import views
import datetime, time, urllib, os, json, pymongo, requests, dateutil.parser
from dateutil.parser import parse
from datetime import tzinfo,timedelta

# Create your views here.
def OrderNumbers(request):
	datagrid = 'Order Number'
	if request.session.has_key('client_id'):
		return render(request,'order-number-sub-menu.html',{"datagrid":datagrid})
	elif request.session.has_key('agency_id'):
		menu = views.getmainmenu(request)
		return render(request,'order-number-sub-menu.html',{"datagrid":datagrid})
	elif request.session.has_key('previlege'):
		return render(request,'super-admin-order-number.html',{"datagrid":datagrid})
		# return HttpResponse('<p align="center" style="margin-top:200px">Order Number for Super Admin is not completed</p>')

def OrderTollFree_old(request):
	menu = views.getmainmenu(request)
	if request.session.has_key("client_id"):
		#Ordered by a client
		print "Client" 
		client_id = int(request.session["client_id"])
		client_details = ProfileDetails.objects.filter(id=client_id)[0]
		agency_id = int(client_details.parent_id)
		
		assigned_numbers = AssignedNumbers.objects.values_list('number_id',flat=True).filter(number__numberdetails__num_type="Toll-Free").exclude(client_id__isnull=True)
		assigned_numbers = list(assigned_numbers)

		if request.method == "POST":
			quantity = int(request.POST["quantity"])
			#Check availability
			num = NumberDetails.objects.values('prefix').annotate(prefixcount=Count('prefix')).filter(number__assignednumbers__agency_id=agency_id,prefixcount__gte=quantity).exclude(number_id__in=assigned_numbers)
			
			if num.count() > 0:
				return render(request,'order-number-step2.html',{"menu":menu,"numbers":num,"qty":quantity})
			else:
				print str(quantity)+" Numbers not available"						

	elif request.session.has_key("agency_id"):
		#Agency
		#Already assigned Toll-Free numbers
		assigned_numbers = AssignedNumbers.objects.values_list('number_id',flat=True).filter(number__numberdetails__num_type="Toll-Free")
		assigned_numbers = list(assigned_numbers)

		if request.method == "POST":
			quantity = int(request.POST["quantity"])
			#check if the number of quantities are available

			num = NumberDetails.objects.values('prefix','num_type').annotate(prefixcount=Count('prefix')).filter(num_type="Toll-Free",prefixcount__gte=quantity).exclude(number__in=assigned_numbers)

			if num.count() > 0:
				#list the prefixes, Group by 'prefix'
				return render(request,'order-number-step2.html',{"menu":menu,"numbers":num,"qty":quantity})
			else:
				print str(quantity)+" Numbers not available"

	return render(request,'order-number-step1.html',{"menu":menu})

def Deletetest(request):
	client_t = TwilioClient(request)
	collection_name = 'calls_AC6c580f81779a325f0311ab7c55a6bc28'
	client = MongoClient()
	db = client.calls_test

	today = datetime.date.today()
	from_date = "2017-07-01 00:00:00"
	# to_date = "2017-07-27 23:59:59"
	to_date = str(today)+' 23:59:59'
 

	# calls = db[collection_name].find({'date': {'$lte': to_date}}).sort('date',pymongo.DESCENDING).distinct('From')
	calls = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date},'RecordingUrl':{'$exists':'TRUE'}})

	for call in calls:
		
		src = call["RecordingUrl"]
		file_name = call["RecordingSid"] 
		client_t.recordings(file_name).delete()
		print file_name
		# directory_path = '/var/www/html/callluge/callrecords/'+account_sid+'/'
		directory_path = '/home/callluge/public_html/audio/audio1/sample1.wav'
		urllib.urlretrieve('http://www.ee.columbia.edu/~dpwe/sounds/dtmf/dtmfA6.wav', directory_path)
	
		directory = os.path.dirname(directory_path)
		os.makedirs(directory)
		

		# directory_path = '/media/AC6c580f81779a325f0311ab7c55a6bc28/'
		# directory = os.path.dirname(directory_path)
		# if not os.path.exists(directory):
		# 	os.makedirs(directory)
		# 	print "Directory Created"
		# dstn = directory_path+file_name+'.wav'	
		# record_file = urllib.URLopener()
		# record_file.retrieve(src, dstn)

	return HttpResponse(JsonResponse({'sas':'asa'}))

	
def OrderLocal(request):
	menus = views.SideMenu(request)
	if request.method == "GET":
		area_code = request.GET["area_code"]
		country_iso_code = request.GET["country_iso_code"]
		quantity = int(request.GET["quantity"])

		client = TwilioClient(request)
		numbers = client.available_phone_numbers(country_iso_code).local.list(area_code=area_code)
		return render(request,'order-local-step2.html',{"menus":menus,"numbers":numbers,"quantity":quantity,"area_code":area_code})	

		# number = client.incoming_phone_numbers.create(phone_number=numbers[0].phone_number)		

	return render(request,'order-local-step1.html',{"menus":menus})	

def OrderFinal_old(request):
	if request.method == 'GET':
		#Toll-Free
		prefix = request.GET.get('prefix')
		quantity = request.GET.get('quantity')

		if request.session.has_key("client_id"):
			client_id = int(request.session["client_id"])
			client_details = ProfileDetails.objects.filter(id=client_id)[0]
			agency_id = int(client_details.parent_id)

			assigned_numbers = AssignedNumbers.objects.values_list('number_id',flat=True).filter(number__numberdetails__num_type="Toll-Free").exclude(client_id__isnull=True)
			assigned_numbers = list(assigned_numbers)

			get_available_numbers = AssignedNumbers.objects.filter(number__numberdetails__num_type="Toll-Free",agency_id=agency_id).exclude(number_id__in=assigned_numbers)[:quantity]

			for nums in get_available_numbers:
				print "---------"
				print nums.number.number
				nums.client_id = client_id
				nums.save()
				print "Assigned to client"

		elif request.session.has_key("agency_id"):
			assigned_numbers = AssignedNumbers.objects.values_list('number_id',flat=True).filter(number__numberdetails__num_type="Toll-Free")
			assigned_numbers = list(assigned_numbers)

			get_available_numbers = NumberMaster.objects.filter(numberdetails__num_type="Toll-Free",numberdetails__prefix=prefix).exclude(id__in=assigned_numbers)[:quantity]
			print get_available_numbers

			for nums in get_available_numbers:
				assign = AssignedNumbers()
				assign.number = nums
				assign.agency_id = request.session["agency_id"]
				assign.save()
				#Show listing page
	return redirect('/numbers/list-numbers/')


def ListNumbers(request):
	datagrid = 'Purchased Numbers'
	numberdata = []
	user = ''

	if request.session.has_key("client_id"):
		user = 'client'
		client_id = request.session["client_id"]
		# assigned_numbers = AssignedNumbers.objects.filter(client_id=client_id)
		assigned_numbers = AssignedNumbers.objects.raw("select A.number_id as id, B.number, B.date_ordered, B.status, C.num_type from assigned_numbers A inner join number_master B on A.number_id = B.id inner join number_details C on B.id = C.number_id where B.status = 1 and A.client_id='"+str(client_id)+"'")
	elif request.session.has_key("agency_id"):
		user = 'agency'
		agency_id = request.session["agency_id"]
		assigned_numbers = AssignedNumbers.objects.raw("select A.number_id as id, B.number, B.date_ordered, B.status, C.num_type, D.name from assigned_numbers A inner join number_master B on A.number_id = B.id inner join number_details C on B.id = C.number_id inner join agency_client_details D on A.client_id = D.id where B.status = 1 and A.agency_id='"+str(agency_id)+"'")		# print(assigned_numbers)
	
	if len(list(assigned_numbers)) == 0:
			assignednumbers = 0
	else:
		assignednumbers = list(assigned_numbers)

	print(assignednumbers)
	# i = 0
	# for number in assigned_numbers:
	# 	print(number.id)
	# 	numberdata[i] = number.id
	# 	i += 1 
	# print(numberdata)
	return render(request,'list-numbers.html',{"numbers":assignednumbers,"datagrid":datagrid, "user": user})	

def ListNumberData(request):
	agency_id = client_id = ''
	data = request.POST
	cnt_call = data["sEcho"]
	lengthdata = data['iDisplayLength']
	sortop = data['sSortDir_0']
	sort_field = 'mDataProp_'+data['iSortCol_0']
	sort_fieldname = data[sort_field]
	limit_start = data['iDisplayStart']
	search = data['sSearch']

	numData = []

	if sort_fieldname == 'Num':
		sort_fieldname = 'number'
	
	sql = "select A.*, B.number, B.date_ordered, B.status, C.num_type, C.iso_country, C.rate_center, C.region, D.name from assigned_numbers A inner join number_master B on B.id = A.number_id inner join number_details C on C.number_id = B.id left join agency_client_details D on "	

	if request.session.has_key("client_id"):
		client_id = request.session["client_id"]		
		sql += "A.client_id = D.id where B.status = 1 and client_id='"+str(client_id)+"'"
	elif request.session.has_key("agency_id"):
		agency_id = request.session["agency_id"]
		sql += "A.agency_id = D.id where B.status = 1 and agency_id='"+str(agency_id)+"'"

	if search:
		# sql += " and ("
		# if agency_id:
		# 	sql += "D.name like %s or "
		
		sql += " and (D.name like %s or C.num_type like %s or B.number like %s)"

	if search:
		num_details_cnt = AssignedNumbers.objects.raw(sql,['%'+search+'%','%'+search+'%','%'+search+'%'])
	else:
		num_details_cnt = AssignedNumbers.objects.raw(sql)

	sql += " order by "+sort_fieldname+" "+sortop+" limit "+lengthdata+" offset "+limit_start
		
	if search:
		num_details = AssignedNumbers.objects.raw(sql,['%'+search+'%','%'+search+'%','%'+search+'%'])
	else:
		num_details = AssignedNumbers.objects.raw(sql)
	
	if len(list(num_details_cnt)) == 0:
		numdetails = 0
	else:
		numdetails = len(list(num_details_cnt))
		
		i = 1
		num = int(limit_start)+1
		for value in num_details:
			nwdict = {}
			nwdict['Num'] = i	
			nwdict['id'] = value.id	
			if value.name != '':
				nwdict['name'] = value.name
			else:
				nwdict['name'] = ''
			if value.num_type != '':
				nwdict['num_type'] = value.num_type		
			else:
				nwdict['num_type'] = ''
			if value.number != '':
				# nwdict['number'] = str(value.number)
				nwdict['number'] = phone_number(value.number)
			else:
				nwdict['number'] = ''
			if value.date_ordered != '':
				# nwdict['date_ordered'] = dt_parse(value.date_ordered)				
				nwdict['date_ordered'] = value.date_ordered.strftime('%b %d, %Y')
				# print(nwdict['date_ordered'])	
				# nwdict['date_ordered'] = dateutil.parser.parse(str(value.date_ordered)).date()
			else:
				nwdict['date_ordered'] = ''
			if value.status == 1:
				nwdict['status'] = 'Active'
			else:
				nwdict['status'] = 'Inactive'
			
			numData.append(nwdict)
			i = i+1	
	
	results = {"sEcho" : cnt_call, "iTotalRecords" : numdetails, "iTotalDisplayRecords" : numdetails, "aaData" : numData}
	return HttpResponse(JsonResponse(results))

# def dt_parse(t):
#     ret = datetime.strptime(t[0:16],'%Y-%m-%dT%H:%M')
#     if t[18]=='+':
#     	ret+=timedelta(hours=int(t[19:22]),minutes=int(t[23:]))
#     elif t[18]=='-':
#     	ret-=timedelta(hours=int(t[19:22]),minutes=int(t[23:]))
#     return ret

def ReleaseNumbers(request,key):
	assigned_id = int(key)
	if request.session.has_key("client_id"):
		#Remove client id entry only
		AssignedNumbers.objects.filter(id=assigned_id).update(client_id=None)
		print "Number Released from client"
	elif request.session.has_key("agency_id"):	
		#Remove the entry from assigned_numbers
		AssignedNumbers.objects.get(id=assigned_id).delete()
		print "Number Released from agnecy"
	return redirect('/numbers/list-numbers/')

def BlacklistNumber(request):

	datagrid = 'Blacklisted numbers' 
	agency_client_id = int(request.session["client_id"])
	numbers = BlacklistNumbers.objects.filter(agency_client_id=agency_client_id)
	return render(request,'blacklist-number.html',{'numbers':numbers,'datagrid':datagrid})

def AddBlacklistNumber(request):
	menu = views.getmainmenu(request)
	if request.method == "POST":
		number = request.POST["number"]
		client_id = request.session["client_id"]
		client = ProfileDetails.objects.get(id = client_id)
		blacklist_number = BlacklistNumbers()
		blacklist_number.number = number
		blacklist_number.agency_client = client
		blacklist_number.save()
		print "Black listed"
		return redirect('/numbers/blacklist/')
	return render(request,'add-blacklist-number.html',{'menu':menu})

def RemoveBlacklistNumber(request,key):
	id = int(key)
	blacklist_number = BlacklistNumbers.objects.get(id=id)	
	blacklist_number.delete()
	print "Removed Blacklisted"
	return redirect('/numbers/blacklist/')	

def WhitelistNumber(request):
	datagrid = 'Whitelisted Numbers'
	agency_client_id = int(request.session["client_id"])
	numbers = WhitelistNumbers.objects.filter(agency_client_id=agency_client_id)
	return render(request,'whitelist-number.html',{'datagrid':datagrid,'numbers':numbers})

def AddWhitelistNumber(request):
	menu = views.getmainmenu(request)
	if request.method == "POST":
		number = request.POST["number"]
		client_id = request.session["client_id"]
		client = ProfileDetails.objects.get(id = client_id)
		whitelist_number = WhitelistNumbers()
		whitelist_number.number = number
		whitelist_number.agency_client = client
		whitelist_number.save()
		print "White listed"
		return redirect('/numbers/whitelist/')
	return render(request,'add-whitelist-number.html',{'menu':menu})

def RemoveWhitelistNumber(request,key):
	id = int(key)
	whitelist_number = WhitelistNumbers.objects.get(id=id)	
	whitelist_number.delete()
	print "Removed Whitelisted"
	return redirect('/numbers/whitelist/')	

def OrderLocalFinal(request):
	OrderFinal(request,'Local')
	return redirect('/numbers/list-numbers/')
	
def RemoveNumber(request,key):
	print key
	number = NumberMaster.objects.filter(id=int(key))
	number.delete()
	print "Removed" 
	return redirect('/numbers/list-numbers/')		

def OrderTollFree(request):
	# menus = views.SideMenu(request)
	if request.method == "GET":
		area_code = request.GET["area_code"]
		country_iso_code = request.GET["country_iso_code"]
		quantity = int(request.GET["quantity"])
		client = TwilioClient(request)
		numbers = client.available_phone_numbers(country_iso_code).toll_free.list(area_code=area_code)

		return render(request,'order-toll-free-step2.html',{"numbers":numbers,"quantity":quantity,"area_code":area_code})
	# return render(request,'order-toll-free-step1.html',{"menus":menus})	

def OrderTollFreeFinal(request):
	OrderFinal(request,'Toll-Free')
	return redirect('/numbers/list-numbers/')

def OrderByPrefix(request):
	menus = views.SideMenu(request)
	if request.method == "GET":
		prefix = request.GET["contains"]
		country_iso_code = request.GET["country_iso_code"]
		quantity = int(request.GET["quantity"])
		
		client = TwilioClient(request)
		numbers = client.available_phone_numbers(country_iso_code).local.list(contains=prefix)
		return render(request,'order-by-prefix-step2.html',{"menus":menus,"numbers":numbers,"quantity":quantity,"prefix":prefix})	

		# number = client.incoming_phone_numbers.create(phone_number=numbers[0].phone_number)		

	# return render(request,'order-by-prefix-step1.html',{"menus":menus})

def OrderByPrefixFinal(request):
	OrderFinal(request,'By-Prefix')
	return redirect('/numbers/list-numbers/')

def OrderFinal(request,num_type):

	if request.method == 'GET':
		number_details = request.GET.getlist("order")
		now = datetime.datetime.now()
		#Trial account can't purchase 
		# number = client.incoming_phone_numbers.create(phone_number=phone_number)
		for num_details in number_details:
	
			details = num_details.split(",")
			phone_number = details[0]

			number= NumberMaster.objects.filter(number=phone_number)
			if number.count() == 0:
				num = NumberMaster()
				num.number = phone_number
				num.date_ordered = now.strftime("%Y-%m-%d %H:%M:%S")
				num.status = 1
				client = TwilioClient(request)
				try:
					number = client.incoming_phone_numbers.create(phone_number=phone_number)
					num.sid = number.sid
					num.client_uniqueid = request.session["uniqueid"]
					#Update the voice url
					domain_name = request.META['HTTP_HOST']
					url = "https://"+domain_name+"/numbers/voice-url/"
					number = client.incoming_phone_numbers(number.sid).update(voice_url=url)
					
					num.save()

					num_detail = NumberDetails()
					num_detail.number = num
					num_detail.num_type = num_type
					num_detail.iso_country = details[1]
					if num_type == 'Local':
						num_detail.region = details[2]
						num_detail.iso_country = details[3]
					num_detail.save()

					assign = AssignedNumbers()
					assign.number_id = num.id
					assign.agency_id = request.session["agency_id"]
					if request.session.has_key("client_id"):
						assign.client_id = request.session["client_id"]
					else:
						assign.client_id = request.session["agency_id"]		
					assign.save()

					print phone_number
					print "Saved"

				except:
					print "Trial Account"
					num.sid = '123'
					num.client_uniqueid = request.session["uniqueid"]
				
			else:
				print phone_number
				stg= "Exist"
				
		return "ok"			
		
def OrderByRegion(request):
	menus = views.SideMenu(request)
	if request.method == "GET":
		# prefix = request.POST["contains"]
		country_iso_code = request.GET["country_iso_code"]
		quantity = int(request.GET["quantity"])
		client = TwilioClient(request)
		try:
			numbers = client.available_phone_numbers('US').mobile.list()
			print numbers
		except:
			print "Twilio Error!!"
			numbers={}
			
		return render(request,'order-by-region-step2.html',{"menus":menus,"numbers":numbers,"quantity":quantity})	

		# number = client.incoming_phone_numbers.create(phone_number=numbers[0].phone_number)		

	# return render(request,'order-by-region-step1.html',{"menus":menus})	

def OrderByRegionFinal(request):
	OrderFinal(request,'By-Region')
	return redirect('/numbers/list-numbers/')

def OrderByState(request):
	countries = CountryCodes.objects.values('country_code','country_name').distinct()
	menus = views.SideMenu(request)
	if request.method == "GET":
		country_iso_code = request.GET["country_iso_code"]
		state_iso_code = request.GET["state_iso_code"]
		quantity = int(request.GET["quantity"])
		client = TwilioClient(request)
		numbers = client.available_phone_numbers(country_iso_code).local.list(in_region=state_iso_code)
		return render(request,'order-by-state-step2.html',{"menus":menus,"numbers":numbers,"quantity":quantity})	

		# number = client.incoming_phone_numbers.create(phone_number=numbers[0].phone_number)		

	# return render(request,'order-by-state-step1.html',{"menus":menus,"countries":countries})	

def GetStates(request):
	iso_country_code = request.POST["country_iso_code"]
	states = CountryCodes.objects.filter(country_code=iso_country_code)
	html = '<option value="">Select State</option>'
	for state in states:
		html += '<option value='+state.state_code+'>'+state.state_name+'</option>' 
	return HttpResponse(html)

def OrderByStateFinal(request):
	OrderFinal(request,'By-State')
	return redirect('/numbers/list-numbers/')

def VoiceUrl(request):

	# send_mail("Twilio-Record Data", json.dumps(request.POST), "osho@paul.com",["osho@techwyseintl.com"])

	account_sid = request.POST["AccountSid"]
	print "Account Sid", account_sid
	data = request.POST.copy()
	domain_name = request.META['HTTP_HOST']
	inbound_number = request.POST["Called"]
	now = datetime.datetime.now()
	data['date'] = now.strftime("%Y-%m-%d %H:%M:%S")

	#Store the call details
	collection_name = 'calls_'+account_sid
	client = MongoClient()
	db = client.calls_test
	
	master = NumberMaster.objects.raw("SELECT * FROM NUMBER_MASTER JOIN CALL_GENERAL_SETTINGS ON NUMBER_MASTER.ID = CALL_GENERAL_SETTINGS.NUMBERID JOIN CAMPAIGN_DETAILS ON NUMBER_MASTER.ID = CAMPAIGN_DETAILS.NUMBER_ID WHERE NUMBER_MASTER.NUMBER=%s",[inbound_number])[0]
	
	campaign_details = CampaignDetails.objects.raw("SELECT * FROM CAMPAIGN_DETAILS JOIN AD_GROUPS ON CAMPAIGN_DETAILS.AD_GROUP_ID = AD_GROUPS.PID WHERE CAMPAIGN_DETAILS.NUMBER_ID=%s",[master.id])[0]
	
	data['ad_group_name'] = campaign_details.name
	data['ad_group_desc'] = campaign_details.description
	
	data['client_id'] = master.client_uniqueid
	#insert or update
	call_sid = request.POST["CallSid"]
	
	call = db[collection_name].find({"CallSid": call_sid})
	if call.count() == 0:
		db[collection_name].insert(data)
	else:
		update_id = db[collection_name].update({"CallSid":call_sid},{'$set':data})
		print "Call Details Updated"	 

	# Call details inserted
	#Get the campaign settings of inbound number.
	
	
	print master.id
	print master.pid
	print master.record_call	

	today = now.strftime("%A")
	response = VoiceResponse()

	#Business Hour Check Starts
	businesss_hours = BusinessHours.objects.filter(day=today,campaign_id=master.pid)
	businesss_hours_status = "False"
	if businesss_hours.count() > 0: 
		for hours in businesss_hours:
			cur_time = now.strftime("%H:%M")

			#convert the db format to proper format eg: 9:15 to 09:15
			open_time_ts = time.mktime(datetime.datetime.strptime(hours.open_time, "%H:%M").timetuple())
			open_time = datetime.datetime.fromtimestamp(open_time_ts).strftime('%H:%M')
			close_time_ts = time.mktime(datetime.datetime.strptime(hours.close_time, "%H:%M").timetuple())
			close_time = datetime.datetime.fromtimestamp(close_time_ts).strftime('%H:%M')
			if cur_time < close_time and cur_time > open_time:
				businesss_hours_status = "True"
				print "Business Hours"
				#response.say('This is office hours osho thank you')
				if master.business_hrs_play_file:
					print "Busines hours play file exist"
					play_file = 'https://'+domain_name+'/media/'+master.business_hrs_play_file
					print (play_file)
					response.play(play_file)
				else:
					print "No play file for business hours"	
					response.play("https://app.callluge.com:8000/media/static_/office_hour.wav")
			else:
				print "Non Business Hours"
				if master.after_hrs_play_file:
					print "Non business hours play file found"
					# response.say('This is not office hours thank you')
					play_file = 'https://'+domain_name+'/media/'+master.after_hrs_play_file
					response.play(play_file)
				else:
					print "Non business hours playfile not found"						
	else:
		print "Business  hours not set"
	#Business Hour check ends

	#Now Forward the numbers
	forward_numbers = CallForwardSettings.objects.filter(numberid=master.id).order_by('step')
	print "Forward Numbers Count", forward_numbers.count()

	#Number Forwarding Starts 
	call_record_status = "True"
	if master.record_call == "N":
		call_record_status = "False"
	time_out = master.time_out	

	#Group by step (single call can be forwarded to many numbers based on step)
	num_groups_business = {}
	num_groups_non_business = {}
	num_groups = {}

	for forwards in forward_numbers:

		data = {forwards}
		if businesss_hours_status == "True":
			if forwards.when == "1" or forwards.when == "0":	#business hours	
				if forwards.step in num_groups:
					num_groups[forwards.step].update(data)
				else:
					num_groups[forwards.step] = data
		else:
			if forwards.when == "2" or forwards.when == "0":	#non business
				print "non business"
				if forwards.step in num_groups:
					num_groups[forwards.step].update(data)
				else:
					num_groups[forwards.step] = data	

	print "Forward numbers Grouped by Step", num_groups		

	for key,val in num_groups.items():
		print "step",key
		for forwards in val:
			print forwards.when 
			print forwards.number

	# print "------------------"				
					
	#Multiple forwards at same time	
	for key,val in num_groups.items():
		if len(val) == 1:
			for forwards in val:
				time_out = forwards.time_out
		dial = Dial(
			# action = "https://app.callluge.com:8000/numbers/dial-action-url/",
			record = call_record_status,
			recording_status_callback="https://app.callluge.com:8000/numbers/record-callback-url/",
			timeout=time_out,		
			)
		for forwards in val:
			dial.number(forwards.number,
				status_callback='https://app.callluge.com:8000/numbers/number-status-callback-url/',)
		response.append(dial)		
		
	# Record Voice mail starts
	response.say("All lines are busy now please record a voice mail after the beep")
	response.record(
		timeout=10,
		recording_status_callback="https://app.callluge.com:8000/numbers/record-callback-url/",
		transcribe=True)
	# Record Voice mail ends

	print response 	
	return HttpResponse(response)

def Thirdparty_webhook(postdata):

	account_sid = postdata["AccountSid"]
	CallSid = postdata["CallSid"]

	# account_sid = 'AC11e4b59b0ed69a0d1aade89fbe996f72'
	# CallSid = 'CAff7d322077139353c94c5bf4229cde7e'
	call_details = {}
	customfield = []

	# account_sid = "AC61409a9c720668081d8477b481528b97"
	collection_name = 'calls_'+account_sid
	client = MongoClient()
	db = client.calls_test
	# calls = db[collection_name].find({'date': {'$lte': to_date}}).sort('date',pymongo.DESCENDING).distinct('From')
	calls = db[collection_name].find_one({'CallSid':CallSid})
	
	call_details['From_number'] = calls['From']
	call_details['To_number'] = calls['To']
	call_details['Dialed_to'] = calls['dialed_to']
	call_details['Call_status'] = calls['CallStatus']
	call_details['Called_to_state'] = calls['ToState']
	call_details['Call_id'] = calls['CallSid']
	call_details['Client_id'] = calls['client_id']
	call_details['date'] = calls['date']
	call_details['Called_to_country'] = calls['ToCountry']
	call_details['Recording_status'] = calls['RecordingStatus']
	call_details['Recording_id'] = calls['RecordingSid']
	call_details['Duration'] = calls['RecordingDuration']

	file_name = calls['RecordingSid']

	directory_path = 'https://app.callluge.com:8000/media/callrecords/'+account_sid+'/'+file_name+'.wav'

	call_details['Recording_url'] = directory_path
	

	if 'FromState' in calls:
		call_details['Called_from_state'] = calls['FromState']
	call_details['Called_to_city'] = calls['ToCity']
	if 'FromCountry' in calls:
		call_details['Called_from_country'] = calls['FromCountry']

	master = NumberMaster.objects.raw("SELECT * FROM NUMBER_MASTER JOIN CALL_GENERAL_SETTINGS ON NUMBER_MASTER.ID = CALL_GENERAL_SETTINGS.NUMBERID JOIN CAMPAIGN_DETAILS ON NUMBER_MASTER.ID = CAMPAIGN_DETAILS.NUMBER_ID WHERE NUMBER_MASTER.NUMBER=%s",[calls['To']])[0]
	
	campaign_details = CampaignDetails.objects.raw("SELECT CAMPAIGN_DETAILS.pid,CAMPAIGN_DETAILS.name as adname,AD_GROUPS.name as groupname FROM CAMPAIGN_DETAILS JOIN AD_GROUPS ON CAMPAIGN_DETAILS.AD_GROUP_ID = AD_GROUPS.PID WHERE CAMPAIGN_DETAILS.NUMBER_ID=%s",[master.id])[0]
	custom_fields = CampaignCustomfields.objects.raw("SELECT * FROM CAMPAIGN_DETAILS JOIN CAMPAIGN_CUSTOMFIELDS ON CAMPAIGN_DETAILS.PID = CAMPAIGN_CUSTOMFIELDS.CAMPAIGN_ID JOIN CUSTOM_FIELDS on CUSTOM_FIELDS.field_id=CAMPAIGN_CUSTOMFIELDS.fieldid WHERE CAMPAIGN_DETAILS.pid=%s",[campaign_details.pid])
	for field in custom_fields:
		customfield.append({field.label:field.value})

	call_details['cmp_name'] = campaign_details.adname
	call_details['grp_name'] = campaign_details.groupname
	call_details['custom_fields'] = json.dumps(customfield)
	client_id = int(calls['client_id'].replace('CLU_', ''))
	if calls['client_id']:
		webhook_url = WebhookSettings.objects.get(client_id=client_id,status=1)
		if webhook_url:
			campaing_tags = CampaignTags.objects.filter(client_id=client_id,campaign_id=campaign_details.pid)

			if campaing_tags:
				for tag in campaing_tags:
					customtags.append({tag.tag_name})
				call_details['tags'] = json.dumps(customtags)

			headers = {'X-API-TOKEN': 'your_token_here'}
			payload = call_details
			r = requests.post(webhook_url.url, data=payload, headers=headers)


def VoiceUrl_old(request):
	print "reached voice url"
	# account_sid = "AC657af3d613ca07482633fa69bc591dc2"
	# data = {"Called":"+19149966073","ToState":"NY","CallerCountry":"IN"}
	# inbound_number = "+19149966072"
	# send_mail("Twilio-First Request", json.dumps(request.POST), "osho@paul.com",["osho@techwyseintl.com"]) 
	account_sid = request.POST["AccountSid"]
	data = request.POST.copy()
	domain_name = request.META['HTTP_HOST']
	inbound_number = request.POST["Called"]
	now = datetime.datetime.now()
	data['date'] = now.strftime("%Y-%m-%d %H:%M:%S")

	#Store the call details
	collection_name = 'calls_'+account_sid
	client = MongoClient()
	db = client.calls_test
	
	#insert or update
	call_sid = request.POST["CallSid"]
	print "Call Sid:",call_sid
	call = db[collection_name].find({"CallSid": call_sid})
	if call.count() == 0:
		db[collection_name].insert(data)
		print "Call Details Inserted"
	else:
		update_id = db[collection_name].update({"CallSid":call_sid},{'$set':data})
		print "Call Details Updated"

	response = VoiceResponse()
	#Record Voice mail starts
	response.say("Please record your voice mail now")
	response.record(
		timeout=10,
		recording_status_callback="https://app.callluge.com:8000/numbers/record-callback-url/",
		transcribe=True)
	#Record Voice mail ends

	# print response

	#Check Conditions
	master = NumberMaster.objects.filter(number=inbound_number)[0]
	general = CallGeneralSettings.objects.filter(numberid=master.id)[0]

	general = NumberMaster.objects.raw("SELECT * FROM number_master JOIN call_general_settings ON number_master.id = call_general_settings.numberid WHERE number_master.number = %s",[inbound_number])[0]
	
	now = datetime.datetime.now()
	today = now.strftime("%A")
	assigned = AssignedNumbers.objects.filter(number_id=general.id)[0]
	account_id = assigned.agency_id
	if assigned.client_id:
		account_id = assigned.client_id

	response = VoiceResponse()
	if general.business_hrs_play_file:
		#Check businesss Hours
		businesss_hours = BusinessHours.objects.filter(day=today,account_id=account_id)
		if businesss_hours.count() > 0:
			for hours in businesss_hours:
				cur_time = now.strftime("%H:%M")
				businesss_hours_status = "False"
				if cur_time < hours.close_time and cur_time > hours.open_time:
					businesss_hours_status = "True"
					# print "Business Hoours"
					# response.say('This is office hours osho thank you')
					play_file = domain_name+'/'+general.business_hrs_play_file
					response.play(play_file)
					# response.play("https://app.callluge.com:8000/static/office_hour.wav")
				else:
					# print "Non Business Hours"
					if general.after_hrs_play_file:
						# response.say('This is not office hours thank you')
						play_file = domain_name+'/'+general.after_hrs_play_file
						response.play(play_file)
	#End of Busines Hour Check

	forward_numbers = CallForwardSettings.objects.filter(numberid=general.id).order_by('step')
	#Number Forwarding Starts 
	call_record_status = "True"
	if general.record_call == "N":
		call_record_status = "False"
	time_out = general.time_out	
	# response.say('Hello World')
	# response.play('https://api.twilio.com/cowbell.mp3')

	for forwards in forward_numbers:
		if forwards.time_out:
			time_out = forwards.time_out	
		dial = Dial(
			record = call_record_status,
			recording_status_callback="https://app.callluge.com:8000/numbers/record-callback-url/",
			timeout = time_out
			)
		dial.number(forwards.number)
		response.append(dial)

	#Voice Mail
	response.say("Sorry all the lines seems busy please try later")	
	print response 	
	#XML Generation
	# send_mail("Twilio-Call Ends", json.dumps(request.POST), "osho@paul.com",["osho@techwyseintl.com"])
	return HttpResponse(response)
def migrateNumberToSubaccount(request):

	#rootaccount_sid = 'ACdabff8d1d2eed3e95a3fb7d1f692fef5'
	#rootaccount_sid = 'AC39cefcb9b790a15e3309f86a538ef4e8' #wysentre client
	rootaccount_sid ='AC62f3c1b1ed94cfbeb9facd214da314d3' #wysecentre client2
	client_t = TwilioClientCallBack(rootaccount_sid)
	number = client_t.incoming_phone_numbers.list()
	print(number)
	clientlist = ProfileDetails.objects.filter(parent_id__gt = 0,status = 1).order_by('name')
	return render(request,'migrate.html',{"number":number,'clientlist':clientlist})


def updatePhoneNumbers(request):
 
	agency_id = request.session["agency_id"]
	client_id = request.session["client_id"]
	orginalnumber = request.POST["number"].split(',')
	newclient = request.POST["clientlist"]
	rootaccount_sid = 'ACdabff8d1d2eed3e95a3fb7d1f692fef5'
	#rootaccount_sid = 'AC39cefcb9b790a15e3309f86a538ef4e8'
	rootaccount_sid ='AC62f3c1b1ed94cfbeb9facd214da314d3'
	client = TwilioClientCallBack(rootaccount_sid)
	phone_number = orginalnumber[2] #number
	domain_name = 'googlecs'+request.META['HTTP_HOST']
	url = "https://"+domain_name+"/numbers/voice-url/"	
	print url
	account = client.api.accounts(rootaccount_sid)
	number = account.incoming_phone_numbers(orginalnumber[1])
	number.update(voice_url=url)
	number.update(account_sid=newclient)
	
	#number = client.api.accounts(rootaccount_sid).incoming_phone_numbers(orginalnumber[1]).update(account_sid=newclient)

	num = NumberMaster()
	num.number = phone_number
	num.sid = orginalnumber[1]
	num.date_ordered = datetime.datetime.now()
	num.status = 1
	num.client_uniqueid = request.session["uniqueid"]
	num.save()


	assign = AssignedNumbers()
	assign.number = phone_number
	assign.agency_id = request.session["agency_id"]
	assign.client_id = request.session["client_id"]
	assign.save()

	num_detail = NumberDetails()
	num_detail.number = phone_number
	num_detail.num_type = 'Toll-Free'
	num_detail.save()		
	return HttpResponse(True)


def RecordCallbackUrl(request):
	#Save the record details with call details
	# send_mail("Twilio-Record Url", json.dumps(request.POST), "osho@paul.com",["osho@techwyseintl.com"]) 
	print "Reached in record call back url"
	
	action_data = request.POST
	print action_data
	if request.POST["RecordingSource"] =='DialVerb':
		update_data = {}
		update_data["RecordingSource"] = request.POST["RecordingSource"]
		update_data["RecordingSid"] = request.POST["RecordingSid"]
		update_data["RecordingUrl"] = request.POST["RecordingUrl"]
		update_data["RecordingStatus"] = request.POST["RecordingStatus"]
		update_data["RecordingChannels"] = request.POST["RecordingChannels"]
		update_data["RecordingDuration"] = request.POST["RecordingDuration"]

		if request.POST["RecordingStatus"] == "completed":
			update_data["CallStatus"] = "completed"

		account_sid = request.POST["AccountSid"]
		CallSid = request.POST["CallSid"]

		collection_name = 'calls_'+account_sid
		client = MongoClient()
		db = client.calls_test

		#callDetails = db[collection_name].find({"CallSid":CallSid}) 

		#for call in callDetails:
			#if 'RecordingDuration' in call:
			#	if int(request.POST["RecordingDuration"]) > int(call['RecordingDuration']):
			#		update_id = db[collection_name].update({"CallSid":CallSid},{'$set':update_data})
			#else:
		update_id = db[collection_name].update({"CallSid":CallSid},{'$set':update_data})

		# print update_id
		# print "Call Record Details Updated"

		src = request.POST["RecordingUrl"]
		# src = "https://api.twilio.com/2010-04-01/Accounts/AC657af3d613ca07482633fa69bc591dc2/Recordings/RE2a41fdb1fe6e70cf0e1cbc5f2bc29883"

		file_name = request.POST["RecordingSid"] 
		
		directory_path = settings.BASE_DIR+'/media/callrecords/'+account_sid+'/' 
		directory = os.path.dirname(directory_path)
		if not os.path.exists(directory):
			os.makedirs(directory)
			print "Directory Created"

		dstn = directory_path+file_name+'.wav'	
		record_file = urllib.URLopener()
		record_file.retrieve(src, dstn)
		print "Record File Copied"

		client_t = TwilioClientCallBack(account_sid)
		client_t.recordings(file_name).delete()
		print "Record File removed from server"
		Thirdparty_webhook(action_data)

		return HttpResponse('ok')
	else:
		account_sid = request.POST["AccountSid"]
		client_t = TwilioClientCallBack(account_sid)
		client_t.recordings(file_name).delete()
		print "Record File removed from server"
		return HttpResponse('false')


def Test(request):

	#Mongo find
	# collection_name = 'calls_AC657af3d613ca07482633fa69bc591dc2'
	# client = MongoClient()
	# db = client.calls_test
	# call_sid = ''
	# # call_sid = "CA5447a2f0d110b4df20f193a2d8e1fd3c"
	# call = db[collection_name].find({"CallSid": call_sid})
	# print call.count()
	
	# Send Mail
	print "Sending Mail.."
	name = 'osho'
	subject = "Welcome to CallLuge "
	from_email = 'support@callluge.com'
	to_email = ['osho@techwyseintl.com','oshopaul.techintl@gmail.com']
	text_content = 'This is an Html Message.'
	domain_name = request.META['HTTP_HOST']
	url = "https://"+domain_name+"/userauth/reset-password/"

	html_content = 'Hi '+name+','
	html_content += '<p>Please set your password in the following link.</p><p><a href="'+url+'/">Click Here</a></p>'
	msg = EmailMultiAlternatives(subject, text_content, from_email,to_email)
	msg.attach_alternative(html_content, "text/html")
	# status = msg.send()
	import sys
	try:
		status = msg.send()
		print status
		print "Sent"
	except:
		print "Unexpected error:", sys.exc_info()[0]
		print "Unable to sent"
		raise

	print "--------"	
 
	# print status
	# print account_details.id
	# msg = json.dumps(request.GET)
	# print msg

	# send_mail("Test",msg, "osho@gmail.com",["osho@techwyseintl.com"]) 
	return HttpResponse('ok')

def TwilioClientCallBack(account_sid):
	if account_sid:
		authdata = ProfileDetails.objects.raw("SELECT * FROM agency_client_details WHERE agency_client_details.sid='"+str(account_sid)+"'")[0]		
		auth_token = authdata.auth_token
		client = Client(account_sid, auth_token)
		return client
	else:
		return null



def TwilioClient(request):
	account_sid = request.session["sid"]
	auth_token = request.session["auth_token"]
	print "Sid"
	print account_sid
	print "Auth Token"
	print auth_token
	client = Client(account_sid, auth_token)
	return client

def DialActionUrl(request):
	print "Dial Action Details"
	print "-------------------"
	action_data = request.POST
	print action_data
	return HttpResponse('ok')	

def NumberStatusCallBackUrl(request):
	print "Number Status Call Back "
	print "-------------------"
	action_data = request.POST
	print action_data
	account_sid = request.POST["AccountSid"]
	ParentCallSid = request.POST["ParentCallSid"]
	collection_name = 'calls_'+account_sid
	update_data = {}
	update_data["dialed_to"] = request.POST["To"]
	update_data["CallStatus"] = request.POST["CallStatus"]

	client = MongoClient()
	db = client.calls_test
	update_id = db[collection_name].update({"CallSid":ParentCallSid},{'$set':update_data}) 
	print update_data
	print update_id
	print "Dialed Number Updated"

	return HttpResponse('ok')	

def phone_number(number_param):
	number = number_param[-10:]
	first = number[0:3]
	second = number[3:6]
	third = number[6:10]
	return '(' + first + ')' + ' ' + second + '-' + third
