# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models


class Industry(models.Model):
    id = models.AutoField(primary_key=True)
    name = models.CharField(max_length=200)
    status = models.IntegerField()

    class Meta():
    	db_table='industry'

class AdGroups(models.Model):
	pid = models.AutoField(primary_key=True)
	name = models.CharField(max_length=200)
	description = models.TextField()
	client_id = models.IntegerField()
	status = models.IntegerField()
	date_created = models.DateTimeField()

	class Meta():
		db_table = 'ad_groups'

class PlayFiles(models.Model):
	pid = models.AutoField(primary_key=True)
	playfile_name = models.FileField(upload_to='static_')
	play_file_id = models.CharField(max_length=200)
	client = models.IntegerField()
	general_file = models.IntegerField()

	class Meta():
		db_table = 'play_files'

class CountryCodes(models.Model):
	pid = models.AutoField(primary_key=True)
	country_code = models.FileField(max_length=10)
	country_name = models.CharField(max_length=200)
	state_code = models.CharField(max_length=10)
	state_name = models.CharField(max_length=200)

	class Meta():
		db_table = 'country_codes'

class Pricing(models.Model):
	pid = models.AutoField(primary_key=True)
	tollfree_price = models.DecimalField(max_digits=4,decimal_places=4)
	localnumber_price = models.DecimalField(max_digits=4,decimal_places=4)
	tollfree_minutes = models.DecimalField(max_digits=4,decimal_places=4)
	localnumber_minutes = models.DecimalField(max_digits=4,decimal_places=4)
	recording = models.DecimalField(max_digits=4,decimal_places=4)
	answering_machine = models.DecimalField(max_digits=4,decimal_places=4)
	storage = models.DecimalField(max_digits=4,decimal_places=4)
	general_id = models.IntegerField()

	class Meta():
		db_table = 'pricing'

class WebhookSettings(models.Model):
	pid = models.AutoField(primary_key=True)
	client_id = models.IntegerField()
	agency_id = models.IntegerField()
	url = models.TextField()
	status = models.IntegerField()
	datetime = models.DateTimeField()

	class Meta:
		db_table = 'webhook_settings'
