# -*- coding: utf-8 -*-

from models import Industry,AdGroups,PlayFiles,CountryCodes,WebhookSettings
from userauth.models import ProfileDetails
from rewrites.models import RewriteMaster
from validators import validateinputfile
from django.shortcuts import redirect
from django.http import HttpResponse
from django.http import JsonResponse
from django.shortcuts import render
from sendgrid.helpers.mail import *
from .forms import UploadFileForm
from time import gmtime, strftime
from django.db import connection
from django.db.models import Q
from twilio.rest import Client

from random import randint
from userauth import views
import datetime, time
import sendgrid
import requests
import urlparse
import json
import os


SITE_ROOT = os.path.dirname(os.path.realpath(__file__))

# Create your views here.
def Index(request,id):
	views.AutoLogin(request,id)
	menu = views.getmainmenu(request)
	return render(request, "settings/index.html", {"request" : request,"menu" : menu})

def CategoryList(request):
	agency_id = request.session['agency_id']
	category_list = ClientCategory.objects.filter(agency_id = agency_id)
	
	return render(request, "settings/categorylist.html", {"category_list" : category_list})

def ApiSettings(request):
	datagrid = 'Api Settings'

	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
		agency = True
	else:
		client_id = request.session['client_id']
		agency = False
	agency_id = request.session['agency_id']
	try:
		apisettings = WebhookSettings.objects.get(client_id=client_id,status=1)
	except WebhookSettings.DoesNotExist:
		apisettings = False

	if request.method == "POST":
		formdata = request.POST

		if apisettings:
			if apisettings.url != formdata['webhook_url']:
				apisettings.status = 0
				apisettings.save()
				newapisettings = WebhookSettings(client_id=client_id,agency_id=agency_id,url=formdata['webhook_url'],status=1,datetime=strftime("%Y-%m-%d", gmtime()))
				newapisettings.save()
		else:
			newapisettings = WebhookSettings(client_id=client_id,agency_id=agency_id,url=formdata['webhook_url'],status=1,datetime=strftime("%Y-%m-%d", gmtime()))
			newapisettings.save()
		return redirect('/settings/apisettings/')


	return render(request, "settings/apisettings.html", {"datagrid":datagrid,"apisettings":apisettings})

def TrackScriptData(request):

	# parsed = urlparse.urlparse(url)
	# params = urlparse.parse_qsl(parsed.query)
	# for x,y in params:
	# 	print "Parameter = "+x,"Value = "+y
	finaldata = []
	sqlpart = ''
	ref_status = ''
	ref_query_extra =''

	status = 0
	if 'acc' not in request.GET:
		status = 1
	if 'ref' not in request.GET:
		ref_status = 'no_reference'
	if 'url' not in request.GET:
		status = 1


	
	if status == 1:
		return HttpResponse('Missing parameters', content_type='text/html')
	else:
		if ref_status == '':
			ref_url_replace = request.GET['ref']

			ref_url = ref_url_replace.replace("https://www.","www.")
			ref_url = ref_url.replace("http://www.","www.")

		if '_camp' in request.GET:
			ref_url = request.GET['_camp']
		else:
			if ref_status == 'no_reference':
				ref_url = 'any'
				ref_query_extra = " or reffering_domain = 'Any' " 

		if 'kw' in request.GET:
			keyword = request.GET['kw']
			sqlpart = "and search_phrase = '" + keyword + "'"

		sql = "select C.* from agency_client_details A inner join rewrite_master B on A.id = B.account_id inner join assosiated_campaign D on B.id=D.rewrite_master_id inner join rewrite_numbers C on D.id = C.assosiated_campaign_id inner join campaign_details E on E.pid = D.campaign_id where E.status = 1 and reffering_domain = '"+ref_url+"' "+ref_query_extra+" and uniqueid = '"+request.GET['acc']+"'" + sqlpart
		
		rewrites = RewriteMaster.objects.raw(sql)


		if rewrites:
			for data in rewrites:
				numberlist = {}
				if data.rewrite_to.encode("utf-8") == 'no_rewrite':
					numberlist['dont'] = 1
				
				numberlist['num']  = phone_number(data.rewrite_to.encode("utf-8").replace(".", ""))
				numberlist['repl'] = phone_number(data.number.encode("utf-8").replace(".", ""))
				if data.number.encode("utf-8").lower() == 'any' :
					numberlist['repl'] = ''
				numberlist['cmp'] = 'cmp'
				finaldata.append(numberlist)
	js_section = "if( CRMnotify.d ) {CRMnotify.write_numdata('CRMkeypad_"+request.GET['acc']+"', CRMnotify.d, 3600); CRMnotify.Recast_document();} else {  CRMnotify._ds.parseDomForNumbers();    CRMnotify.getnum_error( 'rewrite not found' );}"

	return HttpResponse('CRMnotify.d ='+ str(finaldata)+';'+ js_section, content_type='application/javascript')

def phone_number(number_param):
	number = number_param[-10:]
	return number

def Playfiles(request):
	
	datagrid = 'Playfiles'
	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
		agency = True
	else:
		client_id = request.session['client_id']
		agency = False

	

	playfiles_list = PlayFiles.objects.filter(Q(client = client_id)| Q(general_file=1))
	validatefile = False
	if request.method == "POST":
		form = UploadFileForm(request.POST, request.FILES)
		if form.is_valid():
			if 'general_file' not in request.POST:
				general_file = 0
			else:
				general_file = 1
			validatefile = validateinputfile(request.FILES['file'])
			if validatefile['status'] == 'error':
				return render(request, "settings/playfileslist.html", {"validatefile" : validatefile,
					"form" : form,'playfiles_list' : playfiles_list,'agency' : agency})
			else:				
				newdoc = PlayFiles(play_file_id = request.POST['title'],playfile_name = request.FILES['file'],
				client = client_id,general_file = general_file)
				newdoc.save()
				return render(request, "settings/playfileslist.html", {"validatefile" : validatefile,
					"form" : form,'playfiles_list' : playfiles_list,'agency' : agency})
			
	else:
		form = UploadFileForm()
		
	return render(request, "settings/playfileslist.html", {"validatefile" : validatefile,"form" : form,
		'playfiles_list' : playfiles_list,'agency' : agency,'client_id' : client_id,"datagrid":datagrid})


def Adgroups(request):
	datagrid = 'Ad Group(s)'

	return render(request, "settings/adgroupslist.html", {"datagrid":datagrid})

def AdgroupsList(request):
	if 'client_id' not in request.session:
		client_id = request.session['agency_id']
	else:
		client_id = request.session['client_id']

	data = request.POST
	cnt_call = data["sEcho"]
	lengthdata = data['iDisplayLength']
	sortop = data['sSortDir_0']
	sort_field = 'mDataProp_'+data['iSortCol_0']
	sort_fieldname = data[sort_field]
	limit_start = data['iDisplayStart']
	search = str(data['sSearch'])

	sort_op = str(sortop)+'()'
	groupData = []

	totallen = int(lengthdata)+int(limit_start)

	if sort_fieldname == 'Num':
		sort_fieldname = 'name'

	if sortop == 'desc':
		sort_fieldname = '-'+sort_fieldname

	if search:
		adgroups_list_cnt = AdGroups.objects.filter(Q(client_id = client_id), Q(name__icontains = search) | Q(description__icontains = search))
		adgroups_list = AdGroups.objects.filter(Q(client_id = client_id), Q(name__icontains = search) | Q(description__icontains = search)).order_by(sort_fieldname)[limit_start:totallen]
	else:
		adgroups_list_cnt = AdGroups.objects.filter(client_id = client_id)
		adgroups_list = AdGroups.objects.filter(client_id = client_id).order_by(sort_fieldname)[limit_start:totallen]
	
	if len(list(adgroups_list_cnt)) == 0:
		groupdetails = 0
	else:
		groupdetails = len(list(adgroups_list_cnt))
		
		i = 1
		num = int(limit_start)+1
		for value in adgroups_list:
			nwdict = {}
			nwdict['Num'] = i	
			nwdict['pid'] = value.pid	
			nwdict['name'] = value.name
			nwdict['description'] = value.description		
			if value.name != '':
				nwdict['name'] = value.name			
			else:
				nwdict['name'] = ''
			if value.description != '':
				nwdict['description'] = value.description		
			else:
				nwdict['description'] = ''
			if value.status == 1:
				nwdict['status'] = 'Active'
			else:
				nwdict['status'] = 'Inactive'
			
			groupData.append(nwdict)
			i = i+1	
	
	results = {"sEcho" : cnt_call, "iTotalRecords" : groupdetails, "iTotalDisplayRecords" : groupdetails, "aaData" : groupData}
	return HttpResponse(JsonResponse(results))

def AddCategory(request):
	if request.method == "POST":
		postdata = request.POST
		insert_time = strftime("%Y-%m-%d %H:%M:%S", gmtime())
		agency_id = request.session['agency_id']
		category_exist = ClientCategory.objects.filter(category_name = postdata['cat_name'])
		if(category_exist):
			message = 'The category already exists'
		else:
			client_category = ClientCategory(category_name = postdata['cat_name'],agency_id = agency_id,status = 1,date_created = insert_time)
			client_category.save()
			message = 'Category added successfully'

		return HttpResponse(json.dumps({"status":"success","message":message}), content_type='application/json')
	else:
		return HttpResponse(json.dumps({"status":"error","message":"Get request not allowed"}), content_type='application/json') 

def FetchClients(request):
	if request.method == "POST":
		postdata = request.POST
		client_list = ProfileDetails.objects.filter(parent_id = postdata['agency_id'])
		clients = []
		for client in client_list:
			clients.append({'id':client.id,'name': client.name})

		return HttpResponse(json.dumps({"status":"success","divcontent":clients}), content_type='application/json')

def TransferClients(request):
	if request.method == "POST":
		cursor = connection.cursor()
		postdata = request.POST
		new_agency_id = postdata['to_agency']
		clients = json.loads(postdata['clients_totransfer'])
		data = ', '.join(clients)
		sql_string = "update agency_client_details set parent_id = "+new_agency_id+" where id in (%s)" %data
		cursor.execute(sql_string)
		return HttpResponse(json.dumps({"status":"success","divcontent":clients}), content_type='application/json')


def UpdateCountryCodes(request):
	# countries = ['AU','CA','US','GB']
	# responsedata = 'https://api.printful.com/countries'
	# response = requests.get(responsedata)
	# data = response.json()
	# for country in data['result']:
	# 	if country['code'] in countries:
	# 		if country['states']:
	# 			for states in country['states']:
	# 				countrycode = CountryCodes(country_code=country['code'],country_name=country['name']
	# 				,state_code = states['code'],state_name = states['name'])
	# 				countrycode.save()
	account_sid = "AC512acd8caaa39ad65450c3b43a2b9258"
	# Your Auth Token from twilio.com/console
	auth_token  = "b39b0f26c89e0dda6db09df5c024a024"
	client = Client(account_sid, auth_token)
	message = client.api.account.incoming_phone_numbers.create(
		voice_url="http://demo.twilio.com/docs/voice.xml",
    phone_number="+15005550006"
    )
 	# message = client.messages.create(
  #       body="All in the game, yo",
  #       to="+5571981265131",
  #       from_="+15005550006")
	print(message.sid)

	return HttpResponse({message}, content_type='application/json')


def DeletePlayfile(request):
	if request.method == "POST":

		if 'client_id' not in request.session:
			client_id = request.session['agency_id']
		else:
			client_id = request.session['client_id']

		postdata = request.POST
		filedetails = PlayFiles.objects.get(pk = postdata['playfile_id'],client = client_id)
		deletefile = filedetails

		filedetails.delete()
		os.remove(SITE_ROOT+'/../media/'+str(deletefile.playfile_name))

		return HttpResponse(json.dumps({"status":"success","message":"Play file removed successfully","id":postdata['playfile_id']
			}), content_type='application/json')
		

def AddAdgroup(request):
	if request.method == "POST":
		postdata = request.POST
		insert_time = strftime("%Y-%m-%d %H:%M:%S", gmtime())
		if 'client_id' not in request.session:
			client_id = request.session['agency_id']
		else:
			client_id = request.session['client_id']
		
		ad_groups_exist = AdGroups.objects.filter(name = postdata['adgroup_name'],client_id = client_id)

		if(ad_groups_exist):
			message = 'The Ad group already exists'
			status = "error"
		else:
			ad_groups = AdGroups(name = postdata['adgroup_name'],description = postdata['description'],
				client_id = client_id,status = 1,date_created = insert_time)
			ad_groups.save()
			message = 'Ad group added successfully'
			status = "success"

		return HttpResponse(json.dumps({"status":status,"message":message}), content_type='application/json')
	else:
		return HttpResponse(json.dumps({"status":"error","message":"Get request not allowed"}), content_type='application/json') 

def ClientTrasnfer(request):

	menu = views.SideMenu(request)
	agency_list = ProfileDetails.objects.filter(parent_id = 0)

	return render(request, "settings/clienttransfer.html", {"request" : request,"menus" : menu,"agency_list":agency_list})


def custom_notfoundpage(request):

	response = render_to_response('400.html',context_instance=RequestContext(request))
	response.status_code = 400
	return response


