from userauth.models import *
from menumanager.models import AgencyClientPermission,Category
from django.core.mail import send_mail, EmailMultiAlternatives
import simplejson as json, datetime, random, base64
from django.core.exceptions import ValidationError
from django.core.validators import validate_email
from django.http import HttpResponseRedirect
from settings.mailer import func_send_mail
from django.shortcuts import redirect
from settings.models import Industry
from calls.models import CallPricing
from django.http import HttpResponse
from django.http import JsonResponse
from django.shortcuts import render
from django.conf import settings
from django.db.models import Q
from twilio.rest import Client
from django import forms
from django.contrib import messages


# Create your views here.

def SideMenu(request):
	#get the menu items
	menu_items = getmainmenu(request)
	
	menu_final = {}
	if menu_items != 0:
		for menu in menu_items:

			if menu.category.parent_id != 0:
				parent = Category.objects.get(id=int(menu.category.parent_id))
			
				# data = {menu.category.name:menu.category.url}
				data = {menu}
				if parent in menu_final:
					menu_final[parent].update(data)
				else:
					menu_final[parent] = data
			else:
				
				data = {menu}
				menu_final[menu.category.name] = data

						
	# return render(request,'userauth/layout/site_menu.html',{'menu':menu_final})			
	return menu_final

def SignUp(request):
	data ={}
	error={}

	if request.method == "POST":
		name = request.POST["user_name"]
		email = request.POST["email"]
		company_name = request.POST["company_name"]
		phone = request.POST["phone_number"]
		individual_business = request.POST["individual_business"]

		if name == '':
			error['user_name_err'] = 'Name Cannot be Null!'
		else:	
			data['user_name'] = name	
		if email == '':
			error['email_err'] = 'Email Cannot be Null!'
		else:
			print("validte email")
			try:
				validate_email(email)
				# print ("valid email")
				num_result = Login.objects.filter(email=email).count()		
				if(num_result > 0):
					error['email_err'] = 'Email Already exist,Please login!'
			except forms.ValidationError:
				print ("Invalid Email Address.")
				error['email_err'] = 'Invalid Email Address.'

		data['email']=email	
		data['user_name'] = name
		data['type'] = 'welcome_mail'
		print (error)
		# print (data)	
		if len(error) == 0:
			print ("No Error")

			profiledetails = ProfileDetails()
			profiledetails.name = company_name
			profiledetails.phone = phone
			profiledetails.individual_business = individual_business
			profiledetails.status = 2
			profiledetails.save()

			obj = ProfileDetails.objects.get(id=profiledetails.id)
			obj.uniqueid = 'CLU_'+str(profiledetails.id)
			obj.save()

			# print("Profile details saved")

			user = Login()
			user.name = name
			user.email = email
			user.status = 2
			user.previlege = 2
			if profiledetails.individual_business == 'individual':
				user.previlege = 3

			user.date_created = datetime.datetime.now()
			user.agency_client_id = profiledetails.id
			user.save();
			# print ("Saved in user master")
			# print (user.id)


			# return HttpResponseRedirect("/reset-password/")
			# Data Encription Starts
			func_send_mail(request,data)


			#Can be used only for Plain Text Mails
			# send_mail(subject, content, from_email,to_email, fail_silently = True ) 
			status = 1
			if status == 1:
				print ("Mail Sent")
			else:
				print ("Unable to sent the mail")

			return render(request,'account-confirmation.html',{'data':data})
			# return HttpResponse('<p>Thankyou for Registering with us.</p><p>Please login using the url which has been sent to your mail id.')
			# return redirect("/userauth/reset-password/"+encoded_string)
	return render(request,'sign-up.html',{'data':data,'err':error})
	# return render(request,'google-login.html',{'data':data,'err':error})
	# return HttpResponse('<p>Test Signup</p>')

def ResetPassword(request,key):

	decoded_string = key.decode('base64','strict')
	data = decoded_string.split(",")
	print (data[0])
	print (data[1])

	print ("Reset Password")
	industry = getindustry(request)
	# user = Users.objects.filter(id=id)	

	try:
		user = Login.objects.get(name=data[0],email=data[1])
		agency = ProfileDetails.objects.get(id=user.agency_client_id)

		user.key = key
		if request.method == "POST":
			password = request.POST["password"]
			url = request.POST["profile_url"]
			#Do Validations
			err_msg=[]
			if agency.sid:
				err_msg.append("Account Already Registerd.")
			else:	
				if url == '':
					err_msg.append("Plese Enter Site URL.")
				if password == '':
					err_msg.append("Plese Enter Password.")
				elif request.POST["password"] != request.POST["confirm_password"]:
					err_msg.append("Passwords Mismatch.")		
			
			if len(err_msg) == 0:
				print "No Validation Errors."	
				user.password = base64.b64encode(password)
				user.status = 1
				user.save()
				print ("Password Updated")
		
				# Send API to Twilio for creating subaccount(Give credentials of main account)

				account_sid = settings.ACCOUNT_SID
				auth_token = settings.AUTH_TOKEN

				companyDetails = ProfileDetails.objects.filter(id=user.agency_client_id)
				
				client = Client(account_sid, auth_token)
				account = client.api.accounts.create(friendly_name=companyDetails.name)

		
				agency.url = url
				if agency.individual_business == 'business':
					agency.parent_id = 0
				else:
					agency.parent_id = 46 #All the individual clients comes under TechWyse Agency

				agency.package_selected = 0 #only for client, for agency it is 0(Trail,Monthly)	
				agency.address = request.POST["address"]
				agency.status = 1
				agency.sid = account.sid
				agency.auth_token = account.auth_token
				agency.date_created = account.date_created
				agency.date_updated = account.date_updated
				agency.save()
				print ("Saved in Agency Client details")

				#set default agency menu's
				if agency.individual_business == 'business':
					print "Default menu for Agency"
					default_menu = [27,41,42,43,37,2,36,24,1]
				else:
					print "Default menu for Individual"
					default_menu = [27,40,41,42,43,44,37,2]
 
				for item in default_menu:
					permission = AgencyClientPermission()
					permission.agency_client_id = user.id
					permission.category_id = item
					permission.save()
				print (" Default menu's Saved")

				# return HttpResponse('<p>You have successfully registerd,Welcome to Callluge Dashboard</p>')
				SetSession(request,user)
				return redirect('/userauth/')
			else:
				print "Validation Error"
				print err_msg
				return render(request,'reset-password.html',{'user':user,'industry':industry,'err_msg':err_msg})	

			# return redirect('/userauth/login')
		# else:
		# 	print "testsss"
		# 	SetSession(request,user)
		# 	menu = getmainmenu(request)
		# 	agency_list ={}
		# 	return render(request, "dashboard.html", {"title" : 'Dashboard',"data" : agency_list,'name' : request.session['name'], 'email' : request.session['username'], 'menu' : menu})
	except:
		return HttpResponse('<p>Error!!!</p>')
	# print industry	
	return render(request,'reset-password.html',{'user':user,'industry':industry})	
	
def Forgotpassword(request):

	if request.method == "POST":
		email = request.POST['email']
		try:
			result = Login.objects.get(email = email)
			str_enc = result.name+','+email
			encoded_string = str_enc.encode('base64','strict')
			# Send Mail
			subject = "Password reset request from Callluge"
			from_email = 'support@callluge.com'
			to_email = [email]
			bcc_email = ['vivek.techintl@gmail.com','nandakumar.techintl@gmail.com']
			domain_name = request.META['HTTP_HOST']
			url = "https://"+domain_name+"/userauth/reset-password/"
			url += encoded_string

			html_content = 'Hi,'
			html_content += '<p>Please set your password in the following link.</p><p><a href="'+url+'/">Click Here</a></p>'	
			msg = EmailMultiAlternatives(subject, html_content, from_email,to_email,bcc_email)
			msg.attach_alternative(html_content, "text/html")
			try :
				msg.send()
				return render(request,'forgotpassword.html',{"err" : 'Please check your mail for the reset password link.'})
			except :
				return HttpResponse('<p>Mail Cannot Be send</p>')

		except Login.DoesNotExist:
			data = 'This email is not registered with us'
			return render(request, "forgotpassword.html", {"err" : data})

	return render(request,'forgotpassword.html',{"err" : ''})	



def login(request):

	auth = "Login"
	data = ''
	agency_list ={}
	if request.method == 'POST':
		form = request.POST
		pwd = base64.b64encode(form['password'])		
		# pwd = base64.b64encode(bytes(form['password'], 'utf-8'))		
		try:
			data = Login.objects.get(email = form['email'], password = pwd)

			if data.previlege == 1:
				#Super Admin
				request.session['username'] = data.email
				request.session['name'] = data.name
				request.session['previlege'] = data.previlege
				request.session['admin_id'] = data.id
				request.session['status'] = 1
				# agency_list = ProfileDetails.objects.filter(parent_id=0)
				agency_list = ProfileDetails.objects.raw("select A.id, A.name, (select count(id) from agency_client_details where parent_id = A.id) as cnt_id, A.status from agency_client_details A where A.parent_id = 0 group by A.id")
				
			elif data.previlege == 2:
				#Agency
				request.session['username'] = data.email
				request.session['name'] = data.name
				request.session['agency_previlege'] = data.previlege
				request.session['agency_id'] = data.agency_client_id
				request.session['agency_user_id'] = data.id	
				request.session['logintype'] = 'direct'

			elif data.previlege == 3:
				#Client
				request.session['username'] = data.email
				request.session['name'] = data.name
				request.session['client_previlege'] = data.previlege
				request.session['client_id'] = data.agency_client_id
				request.session['client_user_id'] = data.id
				request.session['logintype'] = 'direct'
				agency = ProfileDetails.objects.filter(id=data.agency_client_id)[0]
				request.session['parent'] = agency.parent_id
				request.session['agency_id'] = agency.parent_id
				request.session['uniqueid'] = agency.uniqueid



			elif data.previlege == 4:
				#Agency User
				request.session['username'] = data.email
				request.session['name'] = data.name
				request.session['agency_previlege'] = data.previlege
				request.session['agency_id'] = data.agency_client_id
				request.session['agency_user_id'] = data.id
				request.session['logintype'] = 'direct'

			elif data.previlege == 5:
				#Client User
				request.session['username'] = data.email
				request.session['name'] = data.name
				request.session['client_previlege'] = data.previlege
				request.session['client_id'] = data.agency_client_id
				request.session['client_user_id'] = data.id
				request.session['logintype'] = 'direct'
			
			#Set Sid and Token	
			if request.session.has_key('client_id'):
				account_details = ProfileDetails.objects.filter(id=request.session["client_id"])[0]
				request.session['sid'] = account_details.sid
				request.session['auth_token'] =account_details.auth_token
			elif request.session.has_key('agency_id'):
				account_details = ProfileDetails.objects.filter(id=request.session["agency_id"])[0]
				request.session['sid'] = account_details.sid
				request.session['auth_token'] =account_details.auth_token	
				
			#Use different dashboard for Superadmin/Agency/Client sections

			if request.session.has_key('client_id'):
				return redirect('/calls/client-dashboard/')	
			elif request.session.has_key('agency_id'):
				return redirect('/calls/agency-dashboard/')
			elif request.session.has_key('admin_id'):
				datagrid = 'Manage Agency'
				return render(request, "super-admin-dashboard.html", {"datagrid" : datagrid,"data" : agency_list,'name' : request.session['name'], 'email' : request.session['username']})						
			datagrid = 'Manage Agency'
			return render(request, "dashboard.html", {"datagrid" : datagrid,"data" : agency_list,'name' : request.session['name'], 'email' : request.session['username']})		
		except Login.DoesNotExist:
			data = 'Invalid Email Address or Password.'
			return render(request, "login.html", {"err" : data, "title" : auth})
	
	#if already logged in
	agency_list = {}	
	if request.session.has_key('client_previlege'):
		print "client"
		return redirect('/calls/client-dashboard/')		
	elif request.session.has_key('agency_previlege'):
		return redirect('/calls/agency-dashboard/')
		# menu = getmainmenu(request)
		# return render(request, "dashboard.html", {"data" : agency_list, "title" : 'Dashboard', 'name' : request.session['name'], 'email' : request.session['username'], 'menu' : menu})
	elif request.session.has_key('previlege'):	
		menu = getmainmenu(request)
		# agency_list = ProfileDetails.objects.filter(parent_id=0)
		agency_list = ProfileDetails.objects.raw("select A.id, A.name, (select count(id) from agency_client_details where parent_id = A.id) as cnt_id, A.status from agency_client_details A where A.parent_id = 0 group by A.id")
				
		datagrid = 'Manage Agency'
		return render(request, "super-admin-dashboard.html", {"datagrid" : datagrid,"data" : agency_list, "title" : 'Dashboard', 'name' : request.session['name'], 'email' : request.session['username']})
	
	return render(request, "login.html", {"title" : auth})

def getmainmenu(request):
	# menu = Menu.objects.filter(Q(previlege = request.session['previlege']) | Q(previlege = 100), status = 1)
	# menu = Category.objects.filter(menu_show__contains = '1', status = 1)
	#default menu
	# previlege = int(request.session['previlege'])
	if request.session.has_key('client_previlege'):
		user_id =request.session['client_user_id'] 
	
	elif request.session.has_key('agency_previlege'): 			
		# agency_client_id = request.session['agency_id']
		# user = Login.objects.get(previlege=2,agency_client_id=agency_client_id)
		user_id = request.session['agency_user_id'] 

	elif request.session.has_key('previlege'):
		# agency_client_id = request.session['admin_id']
		# user = Login.objects.get(previlege=1)
		user_id = request.session['admin_id']

	# print user_id
		
	menu = AgencyClientPermission.objects.filter(agency_client_id = user_id)

	if menu.count() == 0:
		data_menu = 0
	else:
		data_menu = menu

	return data_menu

def EditProfile(request):
	# Get the id from session
	id = 12
	user = Login.objects.get(id=id)
	print (user.profile.address)

	if request.method == "POST":
		user_details = Profile()
		user.name = request.POST["user_name"]
		user.email = request.POST["email"]
		user.save()
		user_details.master = user
		user_details.address = request.POST["address"]
		user_details.company = request.POST["company"]
		user_details.phone = request.POST["phone"]
		user_details.save()
		print (user.profile.address)
		print (user_details.master.name)
		print ("Profile Details Saved")

	return render(request,'edit-profile.html',{'user':user})

# def category

def logout(request):
	request.session.flush()
	auth = "Login"
	return render(request, "login.html", {"title" : auth})

def logout1(request,key):
	request.session.flush()
	id = int(key)
	user = ProfileDetails.objects.get(id=id)
	if user.parent_id == 0:
		return redirect('/userauth/agency-list/')
	else:
		return redirect('/userauth/autologin/'+str(user.parent_id))	
	# auth = "Login"
	# return render(request, "login.html", {"title" : auth})
def AgencyList(request):

	agency_list = ProfileDetails.objects.filter(parent_id=0)
	return render(request, "agency-list.html", {"data" : agency_list})	

def AutoLoginClient(request,id):
	agency_client = ProfileDetails.objects.get(id=id)
	data = Login.objects.get(agency_client_id = agency_client.id, previlege = 3)
	request.session['username'] = data.email
	request.session['name'] = data.name
	request.session['client_previlege'] = data.previlege
	request.session['client_id'] = data.agency_client_id
	request.session['client_user_id'] = data.id
	request.session['logintype'] = 'autologin'
	request.session['parent'] = agency_client.parent_id
	request.session['uniqueid'] = agency_client.uniqueid

	account_details = ProfileDetails.objects.filter(id=request.session["client_id"])[0]
	request.session['sid'] = account_details.sid
	request.session['auth_token'] =account_details.auth_token

	return HttpResponse('Success')
	
def AutoLogin(request,id):
	agency_client = ProfileDetails.objects.get(id=id)

	# request.session['id'] = user.id
	# request.session['username'] = user.name
	if agency_client.parent_id == 0:
		#Agency
		data = Login.objects.get(agency_client_id = agency_client.id, previlege = 2)
		request.session['username'] = data.email
		request.session['name'] = data.name
		request.session['agency_previlege'] = data.previlege
		request.session['agency_id'] = data.agency_client_id
		request.session['agency_user_id'] = data.id
		request.session['logintype'] = 'autologin'
		request.session['status'] = 0
	else :
		#Client
		data = Login.objects.get(agency_client_id = agency_client.id, previlege = 3)
		request.session['username'] = data.email
		request.session['name'] = data.name
		request.session['client_previlege'] = data.previlege
		request.session['client_id'] = data.agency_client_id
		request.session['client_user_id'] = data.id
		request.session['logintype'] = 'autologin'
		request.session['parent'] = agency_client.parent_id
		request.session['uniqueid'] = agency_client.uniqueid

	#Set Sid and Token	
	if request.session.has_key('client_id'):
		account_details = ProfileDetails.objects.filter(id=request.session["client_id"])[0]
		request.session['sid'] = account_details.sid
		request.session['auth_token'] =account_details.auth_token
		return redirect('/calls/client-dashboard/')
	elif request.session.has_key('agency_id'):
		account_details = ProfileDetails.objects.filter(id=request.session["agency_id"])[0]
		request.session['sid'] = account_details.sid
		request.session['auth_token'] =account_details.auth_token
		return redirect('/calls/agency-dashboard/')		
		
	return render(request, "dashboard.html", {"title" : 'Dashboard','name' : request.session['name'], 'email' : request.session['username']})		



	if agency_client.parent_id == 0:
		#Agency
		request.session['user_type'] = 2 #agency
		clients_under_agency = ProfileDetails.objects.filter(parent_id=user.id)
		category_menu = Category.objects.filter(section=1,menu_show=2)
		menu_items = AgencyClientPermission.objects.filter(category_id__in=category_menu.values('id'),agency_client_id=user.id)	
		# print clients_under_agency
	else:
		#Client	
		request.session['user_type'] = 4 #client
		clients_under_agency ={} 
		category_menu = Category.objects.filter(section=1,menu_show=3)
		menu_items = AgencyClientPermission.objects.filter(category_id__in=category_menu.values('id'),agency_client_id=user.id)	
	
	# print user.id
	return render(request, "agency-dashboard.html",{"menu":menu_items,"clients":clients_under_agency})

	# return HttpResponse('<p>You have successfully Logged In</p><p>Welcome to Agency Dashboard</p>')
def RemoveAgency(request,id):
	agency_client = ProfileDetails.objects.get(id=id)
	user = Login.objects.filter(agency_client_id=id)

	agency_client.delete()
	user.delete()
	print ("deleted")
	return redirect('/userauth/')

def EditAgency(request,id):
	datagrid = 'Edit Agency'
	agency_id = id
	msg = ''
	agency_client = ProfileDetails.objects.raw('select *,A.name as company_name from agency_client_details A inner join user_master B on A.id = B.agency_client_id where B.status = 1 and agency_client_id = %s', [agency_id])[0]
	if request.method == 'POST':
		form = request.POST
		obj = ProfileDetails.objects.get(id=agency_id)
		obj.name = form['company_name']
		obj.url = form['company_url']
		obj.phone = form['phone_num']
		obj.address = form['address']
		obj.status = form['profile_status']
		if(form['pwd'] != ''):
			 obj.password = base64.b64encode(form['pwd'])
		obj.date_updated = datetime.datetime.now()
		obj.save()
		messages.success(request, "Updated Successfully.")
		return redirect('/userauth/')
		# return redirect('/userauth/editagency/'+agency_id+'/')
		# msg = 'Updated Successfully.'
		# return render(request,"edit-agency.html",{"datagrid":datagrid,'name' : request.session['name']
		# 	,'email':request.session['username'],'agency_client':agency_client, 'agency_id': agency_id, 'msg': msg})


	return render(request,"edit-agency.html",{"datagrid":datagrid,'name' : request.session['name']
			,'email':request.session['username'],'agency_client':agency_client, 'agency_id': agency_id, 'msg': msg})

def AddAgency(request):
		#check previlage
	datagrid = 'Add Agency'
	data = {}

	if request.method == 'POST':
		form = request.POST
		
		# Send API to Twilio for creating subaccount(Give credentials of main account)

		account_sid = settings.ACCOUNT_SID
		auth_token = settings.AUTH_TOKEN
		print(account_sid)
		print(auth_token)
				
		client = Client(account_sid, auth_token)
		account = client.api.accounts.create(friendly_name=form['company_name'])
		print(account)

		profiledetails = ProfileDetails()
		profiledetails.name = form['company_name']
		profiledetails.url = form['company_url']
		profiledetails.phone = form['phone_num']
		profiledetails.address = form['address']
		profiledetails.individual_business = 'business'
		profiledetails.parent_id = 0
		profiledetails.status = 1
		profiledetails.sid = account.sid
		profiledetails.auth_token = account.auth_token
		profiledetails.date_created = datetime.datetime.now()
		profiledetails.date_updated = datetime.datetime.now()
		profiledetails.save()

		obj = ProfileDetails.objects.get(id=profiledetails.id)
		obj.uniqueid = 'CLU_'+ str(profiledetails.id)
		obj.save()

		user = Login()
		user.name = form['name']
		user.email = form['company_email']
		user.password = base64.b64encode(form['pwd'])
		user.status = 1
		user.previlege = 2
		user.date_created = datetime.datetime.now()
		user.agency_client_id = profiledetails.id
		user.save();
		
		callprice = CallPricing()
		callprice.client = ProfileDetails.objects.get(id=profiledetails.id)
		callprice.toll_free_number_price = '2.0000'
		callprice.toll_free_minutes_price = '0.0100'
		callprice.local_number_price = '2.0000'
		callprice.local_number_minutes_price = '0.0100'
		callprice.byprefix_number_price = '2.0000'
		callprice.byprefix_minutes_price = '0.0100'
		callprice.save();

		data['user_name'] = form['name']
		data['email'] = form['company_email']
		data['type'] = 'welcome_mail'

		func_send_mail(request,data)

	return redirect('/userauth/')	 

	# return render(request,"add-agency.html",{
	# 		"datagrid":datagrid,'name' : request.session['name']
	# 		, 'email' : request.session['username']})

def AddClient(request):
	#check previlage
	datagrid = 'Add Client'

	# if not CheckPermission(request):
	# 	return redirect('/userauth/')

	industry = getindustry(request)
	package_selected = getpackageselected(request)

	agency_type = 'Full'
	if request.session.has_key('agency_previlege'):
		agency_list = {}
		return render(request,"add-client.html",{'industry' : industry,'package' : package_selected,"data" : agency_list
			,"datagrid":datagrid, "title" : 'Dashboard', 'name' : request.session['name']
			, 'email' : request.session['username']})
	else:
		return HttpResponse('<p>You are not an agency to add client</p>')	
		
def getindustry(request):
	# agency_id = request.session['agency_id']
	Industrylist = Industry.objects.filter(status = 1)
	# print Categorylist
	return Industrylist

def getpackageselected(request):
	package = Packages.objects.all()
	# print Categorylist
	return package


def CheckProfile(request):
	if request.method == 'POST':
		form = request.POST
		getprofile = ProfileDetails.objects.filter(url = form['url'], status = 1)
		if getprofile.count() > 0:
			response = {'status': 'fail'}
		else:
			response = {'status': 'success'}

	return HttpResponse(json.dumps(response), content_type='application/json')

def ClientList(request):
	#check previlage
	datagrid = 'Client(s)'

	# if not CheckPermission(request):
	# 	return redirect('/userauth/')

	if request.session.has_key('agency_previlege'):
		
		print(request.session['agency_previlege'])
		profiledetails = getprofiledetailsClient(request)
		if profiledetails == 0:
			profiledetails = {}
		Industrylist = Industry.objects.filter(status = 1)
		Package 	= Packages.objects.all()
		return render(request,"client-list.html",{'profiledetails' : profiledetails,
			"industrylist":Industrylist,"Package":Package,"datagrid":datagrid})
	else:
		return redirect('/userauth/logout')	

def SaveClient(request):
	if request.method == 'POST':

		client = ProfileDetails()
		client.name = request.POST["profile_name"]
		client.url = request.POST['profile_url']
		client.industry = request.POST['industry']
		client.package_selected_id = request.POST['profile_type']
		client.address = request.POST['address']

		if request.session.has_key('agency_previlege') and request.session.has_key('agency_id'):
			client.parent_id = request.session['agency_id']
		else:
			client.parent_id = 0
		client.status = request.POST['profile_status']

		if request.POST['hid_stat'] == '':

			#Main account credentials
			# account_sid = "ACa1c28a8b86f3a5103a3ca165e417db13"
			# auth_token = "1dca21d049581ee02467f9deb5da2475" 
			account_sid = settings.ACCOUNT_SID
			auth_token = settings.AUTH_TOKEN
			client_obj = Client(account_sid, auth_token)
			account = client_obj.api.accounts.create(friendly_name=client.name)
			client.sid = account.sid
			client.auth_token = account.auth_token
			client.date_created = account.date_created
			client.date_updated = account.date_updated
			client.save()

			obj = ProfileDetails.objects.get(id=client.id)
			obj.uniqueid = 'CLU_'+ str(client.id)
			obj.save()

			user = Login()
			user.name = client.name
			user.email = request.POST["email"].strip()
			user.agency_client_id = client.id
			user.previlege = 3
			user.status = 1

			now = datetime.datetime.now()
			user.date_created = now.strftime("%Y-%m-%d %H:%M:%S")
			rand_pwd = random.randrange(100, 10000, 3)
			pwd = str(client.name[:5]+str(rand_pwd))	
			user.password = base64.b64encode(pwd)
			user.save()

			#set default agency menu's
			default_menu = [27,40,41,42,43,44,37,2]
			for item in default_menu:
				permission = AgencyClientPermission()
				permission.agency_client_id = user.id
				permission.category_id = item
				permission.save()
			print (" Default menu's For client has been Saved")

			subject = "Welcome to CallLuge"
			from_email = 'support@callluge.com'
			# to_email = [request.POST['user_email']]
			to_email = ['osho@techwyseintl.com']
			
			html_content = 'Hi '+client.name+','
			html_content += '<p>Welcome to Callluge. </br> Username is your email id and password is '+pwd+' </p>'
			msg = EmailMultiAlternatives(subject, html_content, from_email,to_email)
			msg.attach_alternative(html_content, "text/html")
			try :
				print "Welcome Mail Sent"
				# msg.send()
			except :
				return HttpResponse('<p>Mail Cannot Be send</p>')


		else:
			ProfileDetails.objects.filter(id = request.POST['hid_stat']).update(name = request.POST['profile_name'], url = request.POST['profile_url'], industry = request.POST['industry'], package_selected = request.POST['profile_type'], address = request.POST['address'], status = request.POST['profile_status'])


		print (client.id)
		messages.success(request, "Updated Successfully.")
		return HttpResponseRedirect('/userauth/client-list/')

		# profiledetails = getprofiledetailsClient(request)
		# return render(request,"client-list.html",{'profiledetails' : profiledetails})

def getprofiledetailsClient(request, id = ''):
	parent_id = request.session['agency_id']
	if request.session.has_key('admin_id'):
		previlege = 2

	if request.session.has_key('agency_id'):
		previlege = 3

	if id == '':
		profDetails = ProfileDetails.objects.raw("select A.*, B.name as agency, C.name as industry_name,D.packagename as packagename from agency_client_details A LEFT JOIN agency_client_details B on A.parent_id = B.id LEFT JOIN industry C on A.industry = C.id LEFT JOIN packages D on A.package_selected_id = D.package_id where A.parent_id = %s",[parent_id])
		# profDetails = ProfileDetails.objects.raw('select A.*, B.name as agency, C.name as industry_name from agency_client_details A LEFT JOIN agency_client_details B on A.parent_id = B.id INNER JOIN industry C on A.industry = C.id where A.status = 1 and A.parent_id = %s',[parent_id])
		# print(profDetails.query)
		if len(list(profDetails)) == 0:
			prof_details = 0
		else:
			prof_details = list(profDetails)

		return prof_details
	else:
		profDetails = ProfileDetails.objects.raw("select A.*, B.name as agency, C.name as industry_name,E.packagename as packagename , D.email from agency_client_details A LEFT JOIN agency_client_details B on A.parent_id = B.id LEFT JOIN industry C on A.industry = C.id LEFT JOIN packages E on A.package_selected_id = E.package_id inner join user_master D on A.id = D.agency_client_id and D.previlege = '"+str(previlege)+"' where A.id = %s", [id])
		print(profDetails.query)
		if len(list(profDetails)) == 0:
			prof_details = 0
		else:
			prof_details = list(profDetails)
			prof_details = prof_details[0]
		return prof_details

def EditClient(request,id = ''):
	datagrid = 'Edit Client'
	if request.method == 'GET':
		# print(request.GET.get('id'))
		profiledetails = getprofiledetailsClient(request,id)
		industry = getindustry(request)
		package_selected = getpackageselected(request)
		agency_type = 'Full'



		return render(request,"add-client.html",{'data' : agency_type, 'package' : package_selected,'industry' : industry, 'profiledetails' : profiledetails,'datagrid':datagrid})
		# print(profiledetails.name)

def UserList(request):
	datagrid = 'User(s)'

	if request.session.has_key('client_previlege'):
		return render(request,"user-list.html",{'datagrid':datagrid})
	elif request.session.has_key('agency_previlege'):
		return render(request,"user-list.html",{'datagrid':datagrid})
	else:
		return redirect('/userauth/logout')

def UserListData(request):
	
	if request.session.has_key('client_previlege'):
		parent_id = request.session['client_id']
		#userdetails = getuserdetails(request,request.session['client_id'])

	elif request.session.has_key('agency_previlege'):
		parent_id = request.session['agency_id']
		#userdetails = getuserdetails(request,request.session['agency_id'])

	parent_id = str(parent_id)
	userData = []

	data = request.POST
	cnt_call = data["sEcho"]
	lengthdata = data['iDisplayLength']
	sortop = data['sSortDir_0']
	sort_field = 'mDataProp_'+data['iSortCol_0']
	sort_fieldname = data[sort_field]
	limit_start = data['iDisplayStart']
	search = data['sSearch'].replace( '(', '' ).replace( ') ', '' ).replace( '-', '' )

	if sort_fieldname == 'Num':
		sort_fieldname = 'name'
	elif sort_fieldname == 'Address':
		sort_fieldname = 'street '+sortop+', city '+sortop+', state '+sortop+', country'
	if parent_id != '':
		sql = "select A.*, B.user_id, B.phone_no, B.street, B.city, B.state, B.country, B.postal_code from user_master A left join user_profiles B on A.id = B.user_id where"

		if search:
			sql += " (lower(A.name) like lower(%s) or A.email like %s or B.phone_no like %s or lower(B.city) like lower(%s) or lower(B.street) like lower(%s) or lower(B.state) like lower(%s) or lower(B.country) like lower(%s)) and"
		
		sql += " agency_client_id ='"+parent_id+"'"
		if search:
			user_details_cnt = Userprofile.objects.raw(sql,['%'+search+'%','%'+search+'%','%'+search+'%','%'+search+'%','%'+search+'%','%'+search+'%','%'+search+'%'])
		else:
			user_details_cnt = Userprofile.objects.raw(sql)

		sql += " order by "+sort_fieldname+" "+sortop+" limit "+lengthdata+" offset "+limit_start
		if search:
			user_details = Userprofile.objects.raw(sql,['%'+search+'%','%'+search+'%','%'+search+'%','%'+search+'%','%'+search+'%','%'+search+'%','%'+search+'%'])
		else:
			user_details = Userprofile.objects.raw(sql)
	

	if len(list(user_details_cnt)) == 0:
		userdetails = 0
	else:
		userdetails = len(list(user_details_cnt))
		i = 1
		num = int(limit_start)+1
		for value in user_details:
			nwdict = {}
			nwdict['Num'] = i	
			nwdict['id'] = value.id	
			nwdict['name'] = value.name
			nwdict['email'] = value.email
			nwdict['status'] = value.status
			nwdict['phone_no'] = phone_number(value.phone_no)
			Address = ''
			if value.street:
				Address += str(value.street)
			if value.city:
				Address += ', '+str(value.city)
			if value.state:
				Address += ', '+str(value.state)
			if value.country:
				Address += ', '+str(value.country)
			nwdict['Address'] = Address
			userData.append(nwdict)
			i = i+1	
	
	results = {"sEcho" : cnt_call, "iTotalRecords" : userdetails, "iTotalDisplayRecords" : userdetails, "aaData" : userData}
	return HttpResponse(JsonResponse(results))
	
	# user_details = []
	# i = 0
	# num = int(limit_start)+1
	# for value in userdetails:
	# 	value['Num'] = num
	# 	if 'name' in value:
	# 		pass
	# 	else:
	# 		value['name'] = ''
	# 	if 'email' in value:
	# 		pass
	# 	else:
	# 		value['email'] = ''
	# 	if 'phone_no' in value:
	# 		pass
	# 	else:
	# 		value['phone_no'] = ''
	# 	if 'street' in value:
	# 		pass
	# 	else:
	# 		value['street'] = ''
	# 	if 'state' in value:
	# 		pass
	# 	else:
	# 		value['state'] = ''
	# 	if 'city' in value:
	# 		pass
	# 	else:
	# 		value['city'] = ''
	# 	if 'country' in value:
	# 		pass
	# 	else:
	# 		value['country'] = ''
	# 	user_details.append(value)
	# 	i = i+1
	# 	num = num+1
	# results = {"sEcho" : cnt_call, "iTotalRecords" : totalcall, "iTotalDisplayRecords" : totalcall, "aaData" : user_details}	
	#return HttpResponse('hi')

def getcalllogdetails(request, id = ''):
	# user_details = Userprofile.objects.select_related('user_id').all()
	# print (user_details.query)
	parent_id = id

	if id != '':
		user_details = Userprofile.objects.raw('select A.*, B.user_id, B.phone_no, B.street, B.city, B.state, B.country, B.postal_code from user_master A left join user_profiles B on A.id = B.user_id where A.status = 1 and agency_client_id = %s', [parent_id])
		if len(list(user_details)) == 0:
			userdetails = 0
		else:
			userdetails = list(user_details)

		return userdetails

def getuserdetails(request, id = ''):
	# user_details = Userprofile.objects.select_related('user_id').all()
	# print (user_details.query)
	parent_id = str(id)

	data = request.POST
	cnt_call = data["sEcho"]
	lengthdata = data['iDisplayLength']
	sortop = data['sSortDir_0']
	sort_field = 'mDataProp_'+data['iSortCol_0']
	sort_fieldname = data[sort_field]
	limit_start = data['iDisplayStart']
	search = data['sSearch']

	if sort_fieldname == 'Num':
		sort_fieldname = 'name'
	if id != '':
		sql_cnt = "select count(A.name) as count_name from user_master A left join user_profiles B on A.id = B.user_id where A.status = 1"
		sql = "select A.*, B.user_id, B.phone_no, B.street, B.city, B.state, B.country, B.postal_code from user_master A left join user_profiles B on A.id = B.user_id where A.status = 1"

		if search:
			sql_cnt += " and (A.name like '"+search+"' or A.email like '"+search+"' or B.phone_no like '"+search+"' or B.city like '"+search+"' or B.street like '"+search+"' or B.state like '"+search+"' or B.country like '"+search+"')"
			sql += " and (A.name like '"+search+"' or A.email like '"+search+"' or B.phone_no like '"+search+"' or B.city like '"+search+"' or B.street like '"+search+"' or B.state like '"+search+"' or B.country like '"+search+"')"
		else:
			sql_cnt += " and agency_client_id ='"+parent_id+"'"
			sql += " and agency_client_id ='"+parent_id+"' order by "+sort_fieldname+" "+sortop+" limit "+lengthdata+" offset "+limit_start
		
		user_details_cnt = Userprofile.objects.raw(sql_cnt)
		user_details = Userprofile.objects.raw(sql)
		# if search:
		# 	user_details_cnt = Userprofile.objects.raw("select count(A.name) as count_name from user_master A left join user_profiles B on A.id = B.user_id where A.status = 1 and (A.name like %s or A.email like %s or B.phone_no like %s or B.city like %s or B.street like %s or B.state like %s or B.country like %s) and agency_client_id = %s",[search,search,search,search,search,search,search,parent_id])
		# 	if sortop == 'asc':
		# 		user_details = Userprofile.objects.raw("select A.*, B.user_id, B.phone_no, B.street, B.city, B.state, B.country, B.postal_code from user_master A left join user_profiles B on A.id = B.user_id where A.status = 1 and (A.name like %s or A.email like %s or B.phone_no like %s or B.city like %s or B.street like %s or B.state like %s or B.country like %s) and agency_client_id = %s order by %s asc limit %s offset %s",[search,search,search,search,search,search,search,parent_id,sort_fieldname,limit_start,lengthdata])
		# 	else:
		# 		user_details = Userprofile.objects.raw("select A.*, B.user_id, B.phone_no, B.street, B.city, B.state, B.country, B.postal_code from user_master A left join user_profiles B on A.id = B.user_id where A.status = 1 and (A.name like %s or A.email like %s or B.phone_no like %s or B.city like %s or B.street like %s or B.state like %s or B.country like %s) and agency_client_id = %s order by %s desc limit %s offset %s",[search,search,search,search,search,search,search,parent_id,sort_fieldname,limit_start,lengthdata])

		# else:
		# 	user_details_cnt = Userprofile.objects.raw('select count(A.name) as count_name from user_master A left join user_profiles B on A.id = B.user_id where A.status = 1 and agency_client_id = %s', [parent_id])
		# 	if sortop == 'asc':
		# 		user_details = Userprofile.objects.raw("select A.*, B.user_id, B.phone_no, B.street, B.city, B.state, B.country, B.postal_code from user_master A left join user_profiles B on A.id = B.user_id where A.status = 1 and agency_client_id = %s order by %s asc limit %s offset %s", [parent_id,sort_fieldname,limit_start,lengthdata])
		# 	else:
		# 		user_details = Userprofile.objects.raw("select A.*, B.user_id, B.phone_no, B.street, B.city, B.state, B.country, B.postal_code from user_master A left join user_profiles B on A.id = B.user_id where A.status = 1 and agency_client_id = %s order by %s desc limit %s offset %s", [parent_id,sort_fieldname,limit_start,lengthdata])

		# print(list(user_details_cnt))
		print(list(user_details))
		
		if len(list(user_details)) == 0:
			userdetails = 0
		else:
			userdetails = list(user_details)

		return userdetails
	# else:
	# 	user_details = Userprofile.objects.raw('select A.*, B.user_id, B.phone_no, B.street, B.city, B.state, B.country, B.postal_code from user_master A inner join user_profiles B on A.id = B.user_id where A.status = 1 and A.id = %s', [id])
	# 	userdetails = list(user_details)
	# 	return userdetails[0]

def AddUser(request):
	datagrid = 'Add User'
	#check previlage
	# if not CheckPermission(request):
	# 	return redirect('/userauth/')

	if request.session.has_key('client_previlege'):

		return render(request,"add-user.html",{'datagrid':datagrid})
	elif request.session.has_key('agency_previlege'):
		menus = SideMenu(request)
		return render(request,"add-user.html",{'datagrid':datagrid})
	else:
		return redirect('/userauth/logout/')	

def SaveUser(request):
	if request.method == 'POST':
		client = Login()
		client.name = request.POST["user_name"].strip()
		client.email = request.POST['user_email'].strip()

		if request.session.has_key('client_previlege') and request.session.has_key('client_id'):
			client.previlege = 5
			client.agency_client_id = request.session['client_id']		
		elif request.session.has_key('agency_previlege') and request.session.has_key('agency_id'):
			client.previlege = 4
			client.agency_client_id = request.session['agency_id']

		client.status = request.POST['user_status']

		if request.POST['hid_stat'] == '':
			now = datetime.datetime.now()
			client.date_created = now.strftime("%Y-%m-%d %H:%M:%S")
			rand_pwd = random.randrange(100, 10000, 3)
			
			pwd = str(request.POST["user_name"][:5]+str(rand_pwd))	
			client.password = base64.b64encode(pwd)
			# client.password = base64.b64encode(bytes(pwd, 'utf-8'))			
			client.save()

			profile = Userprofile()
			profile.user_id = client.id
			profile.phone_no = request.POST['user_phone'].strip()
			profile.street = request.POST['user_street'].strip()
			profile.city = request.POST['user_city'].strip()
			profile.state = request.POST['user_state']
			profile.country = request.POST['user_country']
			profile.postal_code = request.POST['user_postalcode'].strip()

			profile.save()

			subject = "Welcome to CallLuge"
			from_email = 'support@callluge.com'
			to_email = [request.POST['user_email']]

			bcc_email = ['vivek.techintl@gmail.com','nandakumar.techintl@gmail.com']
			
			html_content = 'Hi '+request.POST["user_name"]
			html_content += '<p>You have been added as a user in Callluge </p>'
			html_content += '<p>You can log into your Callluge account by using the given username and password :'+pwd+' </p>'
			msg = EmailMultiAlternatives(subject, html_content, from_email,to_email,bcc_email)
			msg.attach_alternative(html_content, "text/html")
			try :
				msg.send()
			except :
				return HttpResponse('<p>Mail Cannot Be send</p>')

		else:
			Login.objects.filter(id = request.POST['hid_stat']).update(name = request.POST['user_name'], email = request.POST['user_email'], status = request.POST['user_status'])
			user_prof = Userprofile.objects.filter(user_id = request.POST['hid_stat'])
			if user_prof.count() > 0: 
				Userprofile.objects.filter(user_id = request.POST['hid_stat']).update(phone_no = request.POST['user_phone'], street = request.POST['user_street'], city = request.POST['user_city'], state = request.POST['user_state'], country = request.POST['user_country'], postal_code = request.POST['user_postalcode'])
			else:
				user_prof = Userprofile()
				user_prof.user_id = request.POST['hid_stat']
				user_prof.phone_no = request.POST['user_phone'] 
				user_prof.street = request.POST['user_street'] 
				user_prof.city = request.POST['user_city']
				user_prof.state = request.POST['user_state']
				user_prof.country = request.POST['user_country']
				user_prof.postal_code = request.POST['user_postalcode']
				user_prof.save()

		# print (client.id)
		messages.success(request, "Updated Successfully.")
		return HttpResponseRedirect('/userauth/user-list/')

def EditUser(request):
	if request.method == 'GET':
		id = request.GET.get('id')
		userdetails = {}
		menus = {}
		user_details = Userprofile.objects.raw('select A.*, B.user_id, B.phone_no, B.street, B.city, B.state, B.country, B.postal_code from user_master A left join user_profiles B on A.id = B.user_id where A.id = %s', [id])
		if len(list(user_details)) > 0:
			userdetails = list(user_details)
			userdetails = userdetails[0]
			menus = SideMenu(request)
			return render(request,"add-user.html",{'menus':menus,'userdetails' : userdetails,'id':id})
		else:
			return redirect('/userauth/user-list/')

def BackToSuperAdmin(request):
	if request.session.has_key('previlege'): 
		#Logged as superadmin
		# print request.session['previlage']
		# print('superadmin')
		# exit()

		data = Login.objects.get(id=1)
		request.session['username'] = data.email
		request.session['name'] = data.name
		request.session['previlege'] = data.previlege
		request.session['admin_id'] = data.agency_client_id
		request.session['admin_login'] = 1
		del request.session['agency_previlege']
		del request.session['agency_id']
		del request.session['sid']
		del request.session['auth_token']

		menu = getmainmenu(request)
		agency_list = {}
		agency_list = ProfileDetails.objects.filter(parent_id=0)
		return redirect('/userauth/')
		# return render(request, "dashboard.html", {"data" : agency_list, "title" : 'Dashboard', 'name' : request.session['name'], 'email' : request.session['username'], 'menu' : menu})
	else:
		return redirect('/userauth/logout')

def BackToAgency(request):
	if request.session.has_key('agency_previlege') and request.session.has_key('agency_user_id'): 
		agency_user_id = request.session['agency_user_id']
		data = Login.objects.get(id=agency_user_id)
		request.session['username'] = data.email
		request.session['name'] = data.name
	if request.session.has_key('client_previlege'):
		del request.session['client_previlege']

	if request.session.has_key('client_id'):	
		del request.session['client_id']

	if request.session.has_key('client_user_id'):
		del request.session['client_user_id']

	if request.session.has_key('sid'):
		del request.session['sid']
		
	if request.session.has_key('auth_token'):
		del request.session['auth_token']

		#Set Sid and Token	
		if request.session.has_key('agency_id'):
			account_details = ProfileDetails.objects.filter(id=request.session["agency_id"])[0]
		request.session['sid'] = account_details.sid
		request.session['auth_token'] =account_details.auth_token

		menu = getmainmenu(request)
		return redirect('/userauth/')
		# return render(request, "dashboard.html", {"title" : 'Dashboard', 'name' : request.session['name'], 'email' : request.session['username'], 'menu' : menu})
	else:
		return redirect('/userauth/logout')	
		
def GaLogin(request,key1,key2):
	name = key1
	email = key2

	try:
		user = Login.objects.get(name=name,email=email)
		print "already a member, Direct login"
		SetSession(request,user)
		return redirect('/userauth/')

	except:
		print "Do sign up"
		user = Login()
		user.name = name
		user.email = email
		user.status = 2
		user.previlege = 2 #Agency
		user.date_created = datetime.datetime.now()
		user.save();
		print ("Saved in user master")

		# Data Encription Starts
		str_enc = name+','+email
		encoded_string = base64.b64encode(str_enc)
		print ("Encoded String: " + encoded_string)
		return redirect("/userauth/reset-password/"+encoded_string)
	exit()

def SetSession(request,data):
	# data = Login.objects.get(id=user_id)
	if data.previlege == 1:
		#Super Admin
		request.session['username'] = data.email
		request.session['name'] = data.name
		request.session['previlege'] = data.previlege
		request.session['admin_id'] = data.id
		agency_list = ProfileDetails.objects.filter(parent_id=0)
		
	elif data.previlege == 2:
		#Agency
		request.session['username'] = data.email
		request.session['name'] = data.name
		request.session['agency_previlege'] = data.previlege
		request.session['agency_id'] = data.agency_client_id
		request.session['agency_user_id'] = data.id	

	elif data.previlege == 3:
		#Client
		request.session['username'] = data.email
		request.session['name'] = data.name
		request.session['client_previlege'] = data.previlege
		request.session['client_id'] = data.agency_client_id
		request.session['client_user_id'] = data.id
		request.session['logintype'] = 'direct'
		agency = ProfileDetails.objects.filter(id=data.agency_client_id)[0]
		request.session['parent'] = agency.parent_id
		request.session['agency_id'] = agency.parent_id		

	elif data.previlege == 4:
		#Agency User
		request.session['username'] = data.email
		request.session['name'] = data.name
		request.session['agency_previlege'] = data.previlege
		request.session['agency_id'] = data.agency_client_id
		request.session['agency_user_id'] = data.id

	elif data.previlege == 5:
		#Client User
		request.session['username'] = data.email
		request.session['name'] = data.name
		request.session['client_previlege'] = data.previlege
		request.session['client_id'] = data.agency_client_id
		request.session['client_user_id'] = data.id
		agency = ProfileDetails.objects.filter(id=data.agency_client_id)[0]
		request.session['parent'] = agency.parent_id
		request.session['agency_id'] = agency.parent_id


	#Set Sid and Token	
	if request.session.has_key('client_id'):
		account_details = ProfileDetails.objects.filter(id=request.session["client_id"])[0]
		request.session['sid'] = account_details.sid
		request.session['auth_token'] =account_details.auth_token
	elif request.session.has_key('agency_id'):
		account_details = ProfileDetails.objects.filter(id=request.session["agency_id"])[0]
		request.session['sid'] = account_details.sid
		request.session['auth_token'] =account_details.auth_token		

def CheckPermission(request):
	username = request.session["username"]
	user = Login.objects.filter(email=username)[0]
	url = request.path
	permission = Login.objects.raw("select * from agency_client_permission join menu_category on agency_client_permission.category_id = menu_category.id where agency_client_permission.agency_client_id=%s and menu_category.url=%s",[user.id,url])
	if len(list(permission)) == 0:
		print "url permission is not assigned for this user!!"
		return False
	else:
		return True		
	#select * from agency_client_permission join menu_category on agency_client_permission.category_id = menu_category.id where agency_client_permission.agency_client_id=%s",[user.id])

def CheckPermission1(request):
	username = request.session["username"]
	user = Login.objects.filter(email=username)[0]
	url = request.POST["url"]
	print url
	permission = Login.objects.raw("select * from agency_client_permission join menu_category on agency_client_permission.category_id = menu_category.id where agency_client_permission.agency_client_id=%s and menu_category.url=%s",[user.id,url])
	if len(list(permission)) == 0:
		print "url permission is not assigned for this user!!(Ajax Check)"
		return HttpResponse('False') 
	else:
		return HttpResponse('True') 

def TransferClients(request):
	#Save Clients
	if request.method == "POST":
		print "post data"
		data = request.POST
		print data	

	if request.session.has_key('previlege'):
		print "Super admin"		
		#Fetch All agencies
		agencies = ProfileDetails.objects.filter(parent_id=0)
		print "agency count", agencies.count()
		return render(request,'transfer-clients.html',{"agencies":agencies})

		

def GetClients(request):
	agency_id = request.POST["agency_id"]
	clients = ProfileDetails.objects.filter(parent_id=agency_id)
	strg = ''
	for client in clients:
		strg += '<option value="'+str(client.id)+'">'+client.name+'</option>'

	print "agency id", agency_id
	print "client counts", clients.count()
	return HttpResponse(strg)

def UpdateClients(request):
	if request.method == "POST":
		data = request.POST
		from_agency = data["from_agency"]
		to_agency = data["to_agency"]
		if from_agency == to_agency:
			print "Same agency,Cant update"
			result = 'Please select different agencies'
		else:	
			from_clients = json.loads(data["from_clients"])
			from_clients = list(set(from_clients))
			to_clients = json.loads(data["to_clients"])
			to_clients = list(set(to_clients))
			UpdateParent(request,from_clients,from_agency)
			UpdateParent(request,to_clients,to_agency)
			result = 'Client Transfered'	
				
	return HttpResponse(result)	

def UpdateParent(request,clients,parent):
	cnt = len(clients)
	if cnt > 0:
		for client in clients:
			client_details = ProfileDetails.objects.filter(id=client)[0]
			client_details.parent_id = int(parent)
			client_details.save()
			print "parent id updated for",client_details.name

def ResetPasswordErr(request):
	return HttpResponse('<p>Invalid URL</p>')

def phone_number(number_param):
	print(number_param)
	if number_param !='' and number_param != None:
		number = number_param[-10:]
		first = number[0:3]
		second = number[3:6]
		third = number[6:10]
		return '(' + first + ')' + ' ' + second + '-' + third
	else:
		return number_param

def ClientListDEMO(request):
	#check previlage
	datagrid = 'Client(s)'
	prof_details = []
	
	# if not CheckPermission(request):
	# 	return redirect('/userauth/')

	for i in range(10):
		profDetails = ProfileDetails.objects.raw("select A.*, B.name as agency, C.name as industry_name,\
			D.packagename as packagename from agency_client_details A LEFT JOIN agency_client_details B on A.parent_id = B.id \
			 LEFT JOIN industry C on A.industry = C.id LEFT JOIN packages D on A.package_selected_id = D.package_id where A.parent_id = 123")
		
		for p in profDetails:
			d = {}	
			d['name'] = p.name
			d['url'] = p.url	
			d['industry'] = p.industry_name
			d['package'] = p.packagename
			d['address'] = p.address
			prof_details.append(d)
		i +=1
	print(prof_details)
	return render(request,"client-listdemo.html",{'profiledetails' : prof_details,"datagrid":datagrid})

def ManipulatingPhoneNumber(request):
	client = MongoClient()
	db = client.calls_test
	collection_name = 'calls_AC11e4b59b0ed69a0d1aade89fbe996f72'

	from_date = '2017-10-01'
	to_date = '2017-10-02'

	calls = db[collection_name].find({'date': {'$lte': to_date, '$gte': from_date}})
	# print(calls)

	for call in calls:
		# update_data = {}
		call_id = call['_id']
		# print(call_id)
		randNum = randint(100, 999)
		# print(randNum)
		from1 = call['From'][:-3]
		# print(from1)
		update_data['From'] = str(from1) + str(randNum)
		update_id = db[collection_name].update({"_id":call_id},{'$set':update_data}) 
		# print(update_data)
	return 'Success'